<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for GIFTVOUCHERSEARCHV ServiceType
 * @subpackage Services
 */
class GIFTVOUCHERSEARCHV extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named GIFT_VOUCHER_SEARCH_V01
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_GIFT_VOUCHER_SEARCH_V002](../S_GIFT_VOUCHER_SEARCH_V002) - Replaced due to naming convention### GeneralThis service searches for gift vouchers.### Input- sellDate
     * (compulsory), sellTo: Period of sell date - giftVoucherNoFrom, giftVoucherNoTo: gift voucher number- externalReference- blocked, all, open: gift voucher state; only one field may be set with 1- holderName### Output- objid: unique id- status: - 1 =
     * valid - 2 = not valid - 3 = redeemed - 4 = invoiced - 5 = suspended - 6 = incomplete - 7 = unavailable- number, externalReference- amount- sellDate, hotelSell, expiryDate- gift voucher holder: - objid, lastName, matchcode - guestHotel, guestNo
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GIFT_VOUCHER_SEARCH_V01Request $body
     * @return \StructType\GIFT_VOUCHER_SEARCH_V01Response|bool
     */
    public function GIFT_VOUCHER_SEARCH_V01(\StructType\GIFT_VOUCHER_SEARCH_V01Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->GIFT_VOUCHER_SEARCH_V01($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\GIFT_VOUCHER_SEARCH_V01Response
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
