<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for SACCOUNTADDSERVICEV ServiceType
 * @subpackage Services
 */
class SACCOUNTADDSERVICEV extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named S_ACCOUNT_ADD_SERVICE_V001
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_ACCOUNT_SERVICE_ADD_V001](../S_ACCOUNT_SERVICE_ADD_V001) - Replaced due to naming convention### GeneralThis service adds a service to a specific account.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_ACCOUNT_ADD_SERVICE_V001Request $body
     * @return \StructType\S_ACCOUNT_ADD_SERVICE_V001Response|bool
     */
    public function S_ACCOUNT_ADD_SERVICE_V001(\StructType\S_ACCOUNT_ADD_SERVICE_V001Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_ACCOUNT_ADD_SERVICE_V001($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_ACCOUNT_ADD_SERVICE_V002
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_ACCOUNT_SERVICE_ADD_V002](../S_ACCOUNT_SERVICE_ADD_V002) - Replaced due to naming convention### GeneralThis service adds a service to a specific account.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_ACCOUNT_ADD_SERVICE_V002Request $body
     * @return \StructType\S_ACCOUNT_ADD_SERVICE_V002Response|bool
     */
    public function S_ACCOUNT_ADD_SERVICE_V002(\StructType\S_ACCOUNT_ADD_SERVICE_V002Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_ACCOUNT_ADD_SERVICE_V002($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_ACCOUNT_ADD_SERVICE_V003
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_ACCOUNT_SERVICE_ADD_V003](../S_ACCOUNT_SERVICE_ADD_V003) - Replaced due to naming convention### GeneralThis service adds a service to a specific account.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_ACCOUNT_ADD_SERVICE_V003Request $body
     * @return \StructType\S_ACCOUNT_ADD_SERVICE_V003Response|bool
     */
    public function S_ACCOUNT_ADD_SERVICE_V003(\StructType\S_ACCOUNT_ADD_SERVICE_V003Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_ACCOUNT_ADD_SERVICE_V003($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\S_ACCOUNT_ADD_SERVICE_V001Response|\StructType\S_ACCOUNT_ADD_SERVICE_V002Response|\StructType\S_ACCOUNT_ADD_SERVICE_V003Response
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
