<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for SACCOUNTSEARCHV ServiceType
 * @subpackage Services
 */
class SACCOUNTSEARCHV extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named S_ACCOUNT_SEARCH_V001
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_ACCOUNT_SEARCH_V002](../S_ACCOUNT_SEARCH_V002) - Fixed typo in ACCOUNT-OBJID field### GeneralThis service searches for accounts.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_ACCOUNT_SEARCH_V001Request $body
     * @return \StructType\S_ACCOUNT_SEARCH_V001Response|bool
     */
    public function S_ACCOUNT_SEARCH_V001(\StructType\S_ACCOUNT_SEARCH_V001Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_ACCOUNT_SEARCH_V001($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_ACCOUNT_SEARCH_V002
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_ACCOUNT_SEARCH_V003](../S_ACCOUNT_SEARCH_V003) - Added fields creditLimit and noPost### GeneralThis service searches for accounts.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_ACCOUNT_SEARCH_V002Request $body
     * @return \StructType\S_ACCOUNT_SEARCH_V002Response|bool
     */
    public function S_ACCOUNT_SEARCH_V002(\StructType\S_ACCOUNT_SEARCH_V002Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_ACCOUNT_SEARCH_V002($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_ACCOUNT_SEARCH_V003
     * Meta information extracted from the WSDL
     * - documentation: ### GeneralThis service searches for accounts.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_ACCOUNT_SEARCH_V003Request $body
     * @return \StructType\S_ACCOUNT_SEARCH_V003Response|bool
     */
    public function S_ACCOUNT_SEARCH_V003(\StructType\S_ACCOUNT_SEARCH_V003Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_ACCOUNT_SEARCH_V003($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\S_ACCOUNT_SEARCH_V001Response|\StructType\S_ACCOUNT_SEARCH_V002Response|\StructType\S_ACCOUNT_SEARCH_V003Response
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
