<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for SGUESTCREATEV ServiceType
 * @subpackage Services
 */
class SGUESTCREATEV extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named S_GUEST_CREATE_V001
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_GUEST_CREATE_V002](../S_GUEST_CREATE_V002) - Added profession, delete, ratesegment, industryfield, salescategory, salutation, GuestIdentification and GuestAdditional
     * fields### GeneralThis service creates a new guest profile.### InputGuest data### OutputGUEST-OBJID: ObjID of the newly created guest profile
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_GUEST_CREATE_V001Request $body
     * @return \StructType\S_GUEST_CREATE_V001Response|bool
     */
    public function S_GUEST_CREATE_V001(\StructType\S_GUEST_CREATE_V001Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_GUEST_CREATE_V001($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_GUEST_CREATE_V002
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_GUEST_CREATE_V003](../S_GUEST_CREATE_V003) - Extended with discountgroup and emailfilter### GeneralThis service creates a new guest profile.### InputGuest data### Output-
     * GUEST-OBJID: ObjID of the newly created guest profile
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_GUEST_CREATE_V002Request $body
     * @return \StructType\S_GUEST_CREATE_V002Response|bool
     */
    public function S_GUEST_CREATE_V002(\StructType\S_GUEST_CREATE_V002Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_GUEST_CREATE_V002($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_GUEST_CREATE_V003
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_GUEST_CREATE_V004](../S_GUEST_CREATE_V004) - Added email subscription and extra information, GuestIdentification correct spelling### GeneralThis service creates a new guest
     * profile.### InputGuest data### Output- GUEST-OBJID: ObjID of the newly created guest profile
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_GUEST_CREATE_V003Request $body
     * @return \StructType\S_GUEST_CREATE_V003Response|bool
     */
    public function S_GUEST_CREATE_V003(\StructType\S_GUEST_CREATE_V003Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_GUEST_CREATE_V003($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_GUEST_CREATE_V004
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_GUEST_CREATE_V005](../S_GUEST_CREATE_V005) - Added document type and number### GeneralThis service creates a new guest profile.### Input- Guest data- extra-information key:
     * valid options can be queried with combobox key "gstGenericExtensionKeys"- extra-information value: valid options depend on the entered extra-information key (can be queried by a combo box search)### Output- GUEST-OBJID: ObjID of the newly created
     * guest profile
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_GUEST_CREATE_V004Request $body
     * @return \StructType\S_GUEST_CREATE_V004Response|bool
     */
    public function S_GUEST_CREATE_V004(\StructType\S_GUEST_CREATE_V004Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_GUEST_CREATE_V004($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_GUEST_CREATE_V005
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_GUEST_CREATE_V006](../S_GUEST_CREATE_V006) - Added birth country and date, document expiry date, document issue date, document issuing country, document date, licence plate
     * number, nationality, place of birth, region, sub country and sub sub country.### GeneralThis service creates a new guest profile.### Input- Guest data- extra-information key: valid options can be queried with combobox key "gstGenericExtensionKeys"-
     * extra-information value: valid options depend on the entered extra-information key (can be queried by a combo box search)### Output- GUEST-OBJID: ObjID of the newly created guest profile
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_GUEST_CREATE_V005Request $body
     * @return \StructType\S_GUEST_CREATE_V005Response|bool
     */
    public function S_GUEST_CREATE_V005(\StructType\S_GUEST_CREATE_V005Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_GUEST_CREATE_V005($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_GUEST_CREATE_V006
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_GUEST_CREATE_V007](../S_GUEST_CREATE_V007) - Added iata and tax related fields.### GeneralThis service creates a new guest profile.### Input- Guest data- extra-information
     * key: valid options can be queried with combobox key "gstGenericExtensionKeys"- extra-information value: valid options depend on the entered extra-information key (can be queried by a combo box search)### Output- GUEST-OBJID: ObjID of the newly
     * created guest profile
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_GUEST_CREATE_V006Request $body
     * @return \StructType\S_GUEST_CREATE_V006Response|bool
     */
    public function S_GUEST_CREATE_V006(\StructType\S_GUEST_CREATE_V006Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_GUEST_CREATE_V006($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_GUEST_CREATE_V007
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_GUEST_CREATE_V008](../S_GUEST_CREATE_V008) - Added marketSegment, fax, vip and vip2 fields. Renamed guest identification according to convention### GeneralThis service
     * creates a new guest profile.### Input- Guest data- extra-information key: valid options can be queried with combobox key "gstGenericExtensionKeys"- extra-information value: valid options depend on the entered extra-information key (can be queried by
     * a combo box search)### Output- GUEST-OBJID: ObjID of the newly created guest profile
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_GUEST_CREATE_V007Request $body
     * @return \StructType\S_GUEST_CREATE_V007Response|bool
     */
    public function S_GUEST_CREATE_V007(\StructType\S_GUEST_CREATE_V007Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_GUEST_CREATE_V007($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_GUEST_CREATE_V008
     * Meta information extracted from the WSDL
     * - documentation: ### GeneralThis service creates a new guest profile.### Input- Guest data- extra-information key: valid options can be queried with combobox key "gstGenericExtensionKeys"- extra-information value: valid options depend on the entered
     * extra-information key (can be queried by a combo box search)### Output- GUEST-OBJID: ObjID of the newly created guest profile
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_GUEST_CREATE_V008Request $body
     * @return \StructType\S_GUEST_CREATE_V008Response|bool
     */
    public function S_GUEST_CREATE_V008(\StructType\S_GUEST_CREATE_V008Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_GUEST_CREATE_V008($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\S_GUEST_CREATE_V001Response|\StructType\S_GUEST_CREATE_V002Response|\StructType\S_GUEST_CREATE_V003Response|\StructType\S_GUEST_CREATE_V004Response|\StructType\S_GUEST_CREATE_V005Response|\StructType\S_GUEST_CREATE_V006Response|\StructType\S_GUEST_CREATE_V007Response|\StructType\S_GUEST_CREATE_V008Response
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
