<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for SGUESTMODIFYV ServiceType
 * @subpackage Services
 */
class SGUESTMODIFYV extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named S_GUEST_MODIFY_V001
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_GUEST_MODIFY_V002](../S_GUEST_MODIFY_V002) - It is now possible to modify a guest by central ID### GeneralThis service modifies a specific guest.### Input- GUEST-OBJID:
     * ObjID of the guest, which can be obtained from defined services. Mandatory- All data to be changed
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_GUEST_MODIFY_V001Request $body
     * @return \StructType\S_GUEST_MODIFY_V001Response|bool
     */
    public function S_GUEST_MODIFY_V001(\StructType\S_GUEST_MODIFY_V001Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_GUEST_MODIFY_V001($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_GUEST_MODIFY_V002
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_GUEST_MODIFY_V003](../S_GUEST_MODIFY_V003) - Fixed input naming according to convention### GeneralThis service modifies a specific guest.### Input- GUEST-OBJID: ObjID of
     * the guest, which can be obtained from defined services. Mandatoryor- GUEST-CENTRALID: Central ID of the guest, which can be obtained from defined services. Mandatory- All data to be changed
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_GUEST_MODIFY_V002Request $body
     * @return \StructType\S_GUEST_MODIFY_V002Response|bool
     */
    public function S_GUEST_MODIFY_V002(\StructType\S_GUEST_MODIFY_V002Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_GUEST_MODIFY_V002($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_GUEST_MODIFY_V003
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_GUEST_MODIFY_V004](../S_GUEST_MODIFY_V004) - Added email2, phone1, phone2, mobile2, delete, matchcode, language, poboxratesegment, industryfield, salescategory, salutation,
     * GuestIdentification and GuestAdditional fields### GeneralThis service modifies a specific guest.### Input- GUEST-OBJID: ObjID of the guest, which can be obtained from other defined servicesor- GUEST-CENTRALID: Central ID of the guest, which can be
     * obtained from other defined services- All data to be changed
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_GUEST_MODIFY_V003Request $body
     * @return \StructType\S_GUEST_MODIFY_V003Response|bool
     */
    public function S_GUEST_MODIFY_V003(\StructType\S_GUEST_MODIFY_V003Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_GUEST_MODIFY_V003($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_GUEST_MODIFY_V004
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_GUEST_MODIFY_V005](../S_GUEST_MODIFY_V005) - Extended with discountgroup and emailfilter### GeneralThis service modifies a specific guest.### Input- GUEST-OBJID: ObjID of
     * the guest, which can be obtained from other defined servicesor- GUEST-CENTRALID: Central ID of the guest, which can be obtained from other defined services- All data to be changed
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_GUEST_MODIFY_V004Request $body
     * @return \StructType\S_GUEST_MODIFY_V004Response|bool
     */
    public function S_GUEST_MODIFY_V004(\StructType\S_GUEST_MODIFY_V004Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_GUEST_MODIFY_V004($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_GUEST_MODIFY_V005
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_GUEST_MODIFY_V006](../S_GUEST_MODIFY_V006) - Added email subscription and extra information, GuestIdentification correct spelling### GeneralThis service modifies a specific
     * guest.### Input- GUEST-OBJID: ObjID of the guest, which can be obtained from other defined servicesor- GUEST-CENTRALID: Central ID of the guest, which can be obtained from other defined services- All data to be changed
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_GUEST_MODIFY_V005Request $body
     * @return \StructType\S_GUEST_MODIFY_V005Response|bool
     */
    public function S_GUEST_MODIFY_V005(\StructType\S_GUEST_MODIFY_V005Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_GUEST_MODIFY_V005($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_GUEST_MODIFY_V006
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_GUEST_MODIFY_V007](../S_GUEST_MODIFY_V007) - Added identification number, key card access code, note and salutation correspond### GeneralThis service modifies a specific
     * guest.### Input- GUEST-OBJID: ObjID of the guest, which can be obtained from other defined servicesor- GUEST-CENTRALID: Central ID of the guest, which can be obtained from other defined services- extra-information key: valid options can be queried
     * with combobox key "gstGenericExtensionKeys"- extra-information value: valid options depend on the entered extra-information key (can be queried by a combo box search)- All data to be changed
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_GUEST_MODIFY_V006Request $body
     * @return \StructType\S_GUEST_MODIFY_V006Response|bool
     */
    public function S_GUEST_MODIFY_V006(\StructType\S_GUEST_MODIFY_V006Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_GUEST_MODIFY_V006($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_GUEST_MODIFY_V007
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_GUEST_MODIFY_V008](../S_GUEST_MODIFY_V008) - Added iata and tax related fields### GeneralThis service modifies a specific guest.### Input- GUEST-OBJID: ObjID of the guest,
     * which can be obtained from other defined servicesor- GUEST-CENTRALID: Central ID of the guest, which can be obtained from other defined services- extra-information key: valid options can be queried with combobox key "gstGenericExtensionKeys"-
     * extra-information value: valid options depend on the entered extra-information key (can be queried by a combo box search)- All data to be changed
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_GUEST_MODIFY_V007Request $body
     * @return \StructType\S_GUEST_MODIFY_V007Response|bool
     */
    public function S_GUEST_MODIFY_V007(\StructType\S_GUEST_MODIFY_V007Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_GUEST_MODIFY_V007($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_GUEST_MODIFY_V008
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_GUEST_MODIFY_V009](../S_GUEST_MODIFY_V009) - Added marketSegment, fax, vip and vip2 fields. Renamed guest identification according to convention### GeneralThis service
     * modifies a specific guest.### Input- GUEST-OBJID: ObjID of the guest, which can be obtained from other defined servicesor- GUEST-CENTRALID: Central ID of the guest, which can be obtained from other defined services- extra-information key: valid
     * options can be queried with combobox key "gstGenericExtensionKeys"- extra-information value: valid options depend on the entered extra-information key (can be queried by a combo box search)- All data to be changed
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_GUEST_MODIFY_V008Request $body
     * @return \StructType\S_GUEST_MODIFY_V008Response|bool
     */
    public function S_GUEST_MODIFY_V008(\StructType\S_GUEST_MODIFY_V008Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_GUEST_MODIFY_V008($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_GUEST_MODIFY_V009
     * Meta information extracted from the WSDL
     * - documentation: ### GeneralThis service modifies a specific guest.### Input- GUEST-OBJID: ObjID of the guest, which can be obtained from other defined servicesor- GUEST-CENTRALID: Central ID of the guest, which can be obtained from other defined
     * services- extra-information key: valid options can be queried with combobox key "gstGenericExtensionKeys"- extra-information value: valid options depend on the entered extra-information key (can be queried by a combo box search)- All data to be
     * changed
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_GUEST_MODIFY_V009Request $body
     * @return \StructType\S_GUEST_MODIFY_V009Response|bool
     */
    public function S_GUEST_MODIFY_V009(\StructType\S_GUEST_MODIFY_V009Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_GUEST_MODIFY_V009($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\S_GUEST_MODIFY_V001Response|\StructType\S_GUEST_MODIFY_V002Response|\StructType\S_GUEST_MODIFY_V003Response|\StructType\S_GUEST_MODIFY_V004Response|\StructType\S_GUEST_MODIFY_V005Response|\StructType\S_GUEST_MODIFY_V006Response|\StructType\S_GUEST_MODIFY_V007Response|\StructType\S_GUEST_MODIFY_V008Response|\StructType\S_GUEST_MODIFY_V009Response
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
