<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for SGUESTSEARCHV ServiceType
 * @subpackage Services
 */
class SGUESTSEARCHV extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named S_GUEST_SEARCH_V002
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_GUEST_SEARCH_V003](../S_GUEST_SEARCH_V003) - Added vip and vip2 fields### GeneralThis service searches for guests.## Input- lastName- firstName- matchcode- guestType: - 0 =
     * accompaniment - 1 = guest - 2 = company - 3 = agency - 4 = sales office - 5 = co-operation partner - 6 = affiliated company - 7 = tour operator- coutnry- city- postCode- street- email- guestNo- identificationNo- centralID (only available in central
     * systems)### OutputList of guests (see searchcriteria)
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_GUEST_SEARCH_V002Request $body
     * @return \StructType\S_GUEST_SEARCH_V002Response|bool
     */
    public function S_GUEST_SEARCH_V002(\StructType\S_GUEST_SEARCH_V002Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_GUEST_SEARCH_V002($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_GUEST_SEARCH_V003
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_GUEST_SEARCH_V004](../S_GUEST_SEARCH_V004) - Adjusted due to structure and naming conventions### GeneralThis service searches for guests.### Input- lastName- firstName-
     * matchcode- guestType: - 0 = accompaniment - 1 = guest - 2 = company - 3 = agency - 4 = sales office - 5 = co-operation partner - 6 = affiliated company - 7 = tour operator- coutnry- city- postCode- street- email- guestNo- identificationNo- centralID
     * (only available in central systems)### OutputList of guests (see searchcriteria)
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_GUEST_SEARCH_V003Request $body
     * @return \StructType\S_GUEST_SEARCH_V003Response|bool
     */
    public function S_GUEST_SEARCH_V003(\StructType\S_GUEST_SEARCH_V003Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_GUEST_SEARCH_V003($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_GUEST_SEARCH_V004
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_GUEST_SEARCH_V005](../S_GUEST_SEARCH_V005) - Added guest identification information### GeneralThis service searches for guests.Guests can be legal entities (e.g. company,
     * tour operator) or private persons.### Input- lastName- firstName - matchcode- guestType: - 0 = accompaniment - 1 = guest - 2 = company - 3 = agency - 4 = sales office - 5 = co-operation partner - 6 = affiliated company - 7 = tour operator- coutnry-
     * city- postCode- street- email- guestNo- identificationNo- centralID (only available in central systems)### OutputList of guests (see searchcriteria)
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_GUEST_SEARCH_V004Request $body
     * @return \StructType\S_GUEST_SEARCH_V004Response|bool
     */
    public function S_GUEST_SEARCH_V004(\StructType\S_GUEST_SEARCH_V004Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_GUEST_SEARCH_V004($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_GUEST_SEARCH_V005
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_GUEST_SEARCH_V006](../S_GUEST_SEARCH_V006) - Added documenttype and documentnumber fields### GeneralThis service searches for guests.Guests can be legal entities (e.g.
     * company, tour operator) or private persons.### Input- lastName- firstName- matchcode- guestType: - 0 = accompaniment - 1 = guest - 2 = company - 3 = agency - 4 = sales office - 5 = co-operation partner - 6 = affiliated company - 7 = tour operator-
     * coutnry,- city,- postCode- street- email- guestNo- identificationNo- centralID (only available in central systems)### OutputList of guests (see searchcriteria)
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_GUEST_SEARCH_V005Request $body
     * @return \StructType\S_GUEST_SEARCH_V005Response|bool
     */
    public function S_GUEST_SEARCH_V005(\StructType\S_GUEST_SEARCH_V005Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_GUEST_SEARCH_V005($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_GUEST_SEARCH_V006
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_GUEST_SEARCH_V007](../S_GUEST_SEARCH_V007) - Added iata field### GeneralThis service searches for guests.Guests can be legal entities (e.g. company, tour operator) or
     * private persons.### Input- lastName- firstName- matchcode- guestType: - 0 = accompaniment - 1 = guest - 2 = company - 3 = agency - 4 = sales office - 5 = co-operation partner - 6 = affiliated company - 7 = tour operator- coutnry,- city,- postCode-
     * street- email- guestNo- identificationNo- centralID (only available in central systems)### OutputList of guests (see searchcriteria)
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_GUEST_SEARCH_V006Request $body
     * @return \StructType\S_GUEST_SEARCH_V006Response|bool
     */
    public function S_GUEST_SEARCH_V006(\StructType\S_GUEST_SEARCH_V006Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_GUEST_SEARCH_V006($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_GUEST_SEARCH_V007
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_GUEST_SEARCH_V008](../S_GUEST_SEARCH_V008) - Renamed guest identification according to convention### GeneralThis service searches for guests.Guests can be legal entities
     * (e.g. company, tour operator) or private persons.### Input- lastName- firstName- matchcode- guestType: - 0 = accompaniment - 1 = guest - 2 = company - 3 = agency - 4 = sales office - 5 = co-operation partner - 6 = affiliated company - 7 = tour
     * operator- coutnry,- city,- postCode- street- email- guestNo- identificationNo- centralID (only available in central systems)### OutputList of guests (see searchcriteria)
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_GUEST_SEARCH_V007Request $body
     * @return \StructType\S_GUEST_SEARCH_V007Response|bool
     */
    public function S_GUEST_SEARCH_V007(\StructType\S_GUEST_SEARCH_V007Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_GUEST_SEARCH_V007($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_GUEST_SEARCH_V008
     * Meta information extracted from the WSDL
     * - documentation: ### GeneralThis service searches for guests.Guests can be legal entities (e.g. company, tour operator) or private persons.### Input- lastName- firstName- matchcode- guestType: - 0 = accompaniment - 1 = guest - 2 = company - 3 =
     * agency - 4 = sales office - 5 = co-operation partner - 6 = affiliated company - 7 = tour operator- coutnry,- city,- postCode- street- email- guestNo- identificationNo- centralID (only available in central systems)### OutputList of guests (see
     * searchcriteria)
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_GUEST_SEARCH_V008Request $body
     * @return \StructType\S_GUEST_SEARCH_V008Response|bool
     */
    public function S_GUEST_SEARCH_V008(\StructType\S_GUEST_SEARCH_V008Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_GUEST_SEARCH_V008($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\S_GUEST_SEARCH_V002Response|\StructType\S_GUEST_SEARCH_V003Response|\StructType\S_GUEST_SEARCH_V004Response|\StructType\S_GUEST_SEARCH_V005Response|\StructType\S_GUEST_SEARCH_V006Response|\StructType\S_GUEST_SEARCH_V007Response|\StructType\S_GUEST_SEARCH_V008Response
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
