<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for SNOTIFICATIONCONFIRMV ServiceType
 * @subpackage Services
 */
class SNOTIFICATIONCONFIRMV extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named S_NOTIFICATION_CONFIRM_V001
     * Meta information extracted from the WSDL
     * - documentation: ### GeneralThis service confirms a notification (autotask). This means that the notification was successfully processed by the external system, after it was received.### Input- TASK-OBJID: ObjID of the notification (autotask) that
     * will be confirmed.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_NOTIFICATION_CONFIRM_V001Request $body
     * @return \StructType\S_NOTIFICATION_CONFIRM_V001Response|bool
     */
    public function S_NOTIFICATION_CONFIRM_V001(\StructType\S_NOTIFICATION_CONFIRM_V001Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_NOTIFICATION_CONFIRM_V001($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\S_NOTIFICATION_CONFIRM_V001Response
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
