<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for SPERSONGUESTASSIGNV ServiceType
 * @subpackage Services
 */
class SPERSONGUESTASSIGNV extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named S_PERSON_GUEST_ASSIGN_V001
     * Meta information extracted from the WSDL
     * - documentation: ### GeneralThis service assigns a specific guest profile to a specific person.### Input- PERSON-OBJID: ObjID of the person, which can be obtained from defined services. Mandatory- GUEST-OBJID: ObjID of the guest, which can be
     * obtained from defined services. Mandatory
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_PERSON_GUEST_ASSIGN_V001Request $body
     * @return \StructType\S_PERSON_GUEST_ASSIGN_V001Response|bool
     */
    public function S_PERSON_GUEST_ASSIGN_V001(\StructType\S_PERSON_GUEST_ASSIGN_V001Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_PERSON_GUEST_ASSIGN_V001($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\S_PERSON_GUEST_ASSIGN_V001Response
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
