<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for SPERSONMODIFYV ServiceType
 * @subpackage Services
 */
class SPERSONMODIFYV extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named S_PERSON_MODIFY_V001
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_PERSON_MODIFY_V002](../S_PERSON_MODIFY_V002) - Fixed incorrect naming (from guestType to personType)### GeneralThis service modifies a person.### Input- PERSON-OBJID:ObjID
     * of the person, which can be obtained from defined services. Mandatory- All data to be changed
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_PERSON_MODIFY_V001Request $body
     * @return \StructType\S_PERSON_MODIFY_V001Response|bool
     */
    public function S_PERSON_MODIFY_V001(\StructType\S_PERSON_MODIFY_V001Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_PERSON_MODIFY_V001($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_PERSON_MODIFY_V002
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_PERSON_MODIFY_V003](../S_PERSON_MODIFY_V003) - Extended with document type and document number### GeneralThis service modifies a person.### Input- PERSON-OBJID:ObjID of the
     * person, which can be obtained from defined services. Mandatory- All data to be changed
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_PERSON_MODIFY_V002Request $body
     * @return \StructType\S_PERSON_MODIFY_V002Response|bool
     */
    public function S_PERSON_MODIFY_V002(\StructType\S_PERSON_MODIFY_V002Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_PERSON_MODIFY_V002($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_PERSON_MODIFY_V003
     * Meta information extracted from the WSDL
     * - documentation: ### GeneralThis service modifies a person.### Input- PERSON-OBJID:ObjID of the person, which can be obtained from defined services. Mandatory- documenttype: Document Type, valid options can be queried with combobox key "PL"- All data
     * to be changed
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_PERSON_MODIFY_V003Request $body
     * @return \StructType\S_PERSON_MODIFY_V003Response|bool
     */
    public function S_PERSON_MODIFY_V003(\StructType\S_PERSON_MODIFY_V003Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_PERSON_MODIFY_V003($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\S_PERSON_MODIFY_V001Response|\StructType\S_PERSON_MODIFY_V002Response|\StructType\S_PERSON_MODIFY_V003Response
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
