<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for SRESERVATIONCREATEV ServiceType
 * @subpackage Services
 */
class SRESERVATIONCREATEV extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named S_RESERVATION_CREATE_V001
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_RESERVATION_CREATE_V002](../S_RESERVATION_CREATE_V002) - Added optiontodate as possible input### GeneralThis service creates a new individual reservation### Input-
     * ORDERER-OBJID: (Mandatory) ObjID of the orderer, which can be obtained from other defined services. Mandatory- Reservation dataOther optional fields:- ORDERER-OBJID: ObjID of the orderer- TRAVELAGENCY-OBJID: ObjID of the travel agency-
     * TRAVELPOINT-OBJID: ObjID of the travel point- ORDERERCONTACTPERSON-OBJID: ObjID of the orderer contact person (make sure it's a valid contact person for ORDERER-OBJID)- TRAVELAGENCYCONTACTPERSON-OBJID: ObjID of the travel agency contact person (make
     * sure it's a valid contact person for TRAVELAGENCY-OBJID)- TRAVELPOINTCONTACTPERSON-OBJID: ObjID of the travel point contact person (make sure it's a valid contact person for TRAVELPOINT-OBJID)- ALLOTMENT-OBJID: ObjID of the allotmentWhen creating a
     * reservation linked to an allotment (with the exception of shared allotments), the allotment needs to belong to the orderer of the reservation (holder)However, this depends on who the rate is assigned to, which can also be defined### Output-
     * RESERVATION-OBJID: ObjID of the newly created reservation
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_CREATE_V001Request $body
     * @return \StructType\S_RESERVATION_CREATE_V001Response|bool
     */
    public function S_RESERVATION_CREATE_V001(\StructType\S_RESERVATION_CREATE_V001Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_CREATE_V001($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_RESERVATION_CREATE_V002
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_RESERVATION_CREATE_V003](../S_RESERVATION_CREATE_V003) - Added missing comment fields (tecnhnical, internet, central, invoice)### GeneralThis service creates a new
     * individual reservation.### Input- ORDERER-OBJID: (Mandatory) ObjID of the orderer, which can be obtained from other defined services. Mandatory- Reservation dataOther optional fields:- ORDERER-OBJID: ObjID of the orderer- TRAVELAGENCY-OBJID: ObjID of
     * the travel agency- TRAVELPOINT-OBJID: ObjID of the travel point- ORDERERCONTACTPERSON-OBJID: ObjID of the orderer contact person (make sure it's a valid contact person for ORDERER-OBJID)- TRAVELAGENCYCONTACTPERSON-OBJID: ObjID of the travel agency
     * contact person (make sure it's a valid contact person for TRAVELAGENCY-OBJID)- TRAVELPOINTCONTACTPERSON-OBJID: ObjID of the travel point contact person (make sure it's a valid contact person for TRAVELPOINT-OBJID)- ALLOTMENT-OBJID: ObjID of the
     * allotmentWhen creating a reservation linked to an allotment (with the exception of shared allotments), the allotment needs to belong to the orderer of the reservation (holder)However, this depends on who the rate is assigned to, which can also be
     * defined### Output- RESERVATION-OBJID: ObjID of the newly created reservation
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_CREATE_V002Request $body
     * @return \StructType\S_RESERVATION_CREATE_V002Response|bool
     */
    public function S_RESERVATION_CREATE_V002(\StructType\S_RESERVATION_CREATE_V002Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_CREATE_V002($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_RESERVATION_CREATE_V003
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_RESERVATION_CREATE_V004](../S_RESERVATION_CREATE_V004) - Added channel and nn1 fields### GeneralThis service creates a new individual reservation.### Input- ORDERER-OBJID:
     * (Mandatory) ObjID of the orderer, which can be obtained from other defined services. Mandatory- Reservation dataOther optional fields:- ORDERER-OBJID: ObjID of the orderer- TRAVELAGENCY-OBJID: ObjID of the travel agency- TRAVELPOINT-OBJID: ObjID of
     * the travel point- ORDERERCONTACTPERSON-OBJID: ObjID of the orderer contact person (make sure it's a valid contact person for ORDERER-OBJID)- TRAVELAGENCYCONTACTPERSON-OBJID: ObjID of the travel agency contact person (make sure it's a valid contact
     * person for TRAVELAGENCY-OBJID)- TRAVELPOINTCONTACTPERSON-OBJID: ObjID of the travel point contact person (make sure it's a valid contact person for TRAVELPOINT-OBJID)- ALLOTMENT-OBJID: ObjID of the allotmentWhen creating a reservation linked to an
     * allotment (with the exception of shared allotments), the allotment needs to belong to the orderer of the reservation (holder)However, this depends on who the rate is assigned to, which can also be defined### Output- RESERVATION-OBJID: ObjID of the
     * newly created reservation
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_CREATE_V003Request $body
     * @return \StructType\S_RESERVATION_CREATE_V003Response|bool
     */
    public function S_RESERVATION_CREATE_V003(\StructType\S_RESERVATION_CREATE_V003Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_CREATE_V003($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_RESERVATION_CREATE_V004
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_RESERVATION_CREATE_V005](../S_RESERVATION_CREATE_V005) - Added payminstrautoservice field### GeneralThis service creates a new individual reservation.### Input-
     * ORDERER-OBJID: (Mandatory) ObjID of the orderer, which can be obtained from other defined services. Mandatory- Reservation dataOther optional fields:- ORDERER-OBJID: ObjID of the orderer- TRAVELAGENCY-OBJID: ObjID of the travel agency-
     * TRAVELPOINT-OBJID: ObjID of the travel point- ORDERERCONTACTPERSON-OBJID: ObjID of the orderer contact person (make sure it's a valid contact person for ORDERER-OBJID)- TRAVELAGENCYCONTACTPERSON-OBJID: ObjID of the travel agency contact person (make
     * sure it's a valid contact person for TRAVELAGENCY-OBJID)- TRAVELPOINTCONTACTPERSON-OBJID: ObjID of the travel point contact person (make sure it's a valid contact person for TRAVELPOINT-OBJID)- ALLOTMENT-OBJID: ObjID of the allotmentWhen creating a
     * reservation linked to an allotment (with the exception of shared allotments), the allotment needs to belong to the orderer of the reservation (holder)However, this depends on who the rate is assigned to, which can also be defined### Output-
     * RESERVATION-OBJID: ObjID of the newly created reservation
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_CREATE_V004Request $body
     * @return \StructType\S_RESERVATION_CREATE_V004Response|bool
     */
    public function S_RESERVATION_CREATE_V004(\StructType\S_RESERVATION_CREATE_V004Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_CREATE_V004($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_RESERVATION_CREATE_V005
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_RESERVATION_CREATE_V006](../S_RESERVATION_CREATE_V006) - Added discountGroup field### GeneralThis service creates a new individual reservation.### Input- ORDERER-OBJID:
     * (Mandatory) ObjID of the orderer, which can be obtained from other defined services. Mandatory- Reservation dataOther optional fields:- ORDERER-OBJID: ObjID of the orderer- TRAVELAGENCY-OBJID: ObjID of the travel agency- TRAVELPOINT-OBJID: ObjID of
     * the travel point- ORDERERCONTACTPERSON-OBJID: ObjID of the orderer contact person (make sure it's a valid contact person for ORDERER-OBJID)- TRAVELAGENCYCONTACTPERSON-OBJID: ObjID of the travel agency contact person (make sure it's a valid contact
     * person for TRAVELAGENCY-OBJID)- TRAVELPOINTCONTACTPERSON-OBJID: ObjID of the travel point contact person (make sure it's a valid contact person for TRAVELPOINT-OBJID)- ALLOTMENT-OBJID: ObjID of the allotmentWhen creating a reservation linked to an
     * allotment (with the exception of shared allotments), the allotment needs to belong to the orderer of the reservation (holder)However, this depends on who the rate is assigned to, which can also be defined### Output- RESERVATION-OBJID: ObjID of the
     * newly created reservation
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_CREATE_V005Request $body
     * @return \StructType\S_RESERVATION_CREATE_V005Response|bool
     */
    public function S_RESERVATION_CREATE_V005(\StructType\S_RESERVATION_CREATE_V005Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_CREATE_V005($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_RESERVATION_CREATE_V006
     * Meta information extracted from the WSDL
     * - documentation: ### General This service creates a new individual reservation. ### Input - ORDERER-OBJID: (Mandatory) ObjID of the orderer, which can be obtained from other defined services. Mandatory- Reservation data Other optional fields: -
     * ORDERER-OBJID: ObjID of the orderer- TRAVELAGENCY-OBJID: ObjID of the travel agency- TRAVELPOINT-OBJID: ObjID of the travel point- ORDERERCONTACTPERSON-OBJID: ObjID of the orderer contact person (make sure it's a valid contact person for
     * ORDERER-OBJID)- TRAVELAGENCYCONTACTPERSON-OBJID: ObjID of the travel agency contact person (make sure it's a valid contact person for TRAVELAGENCY-OBJID)- TRAVELPOINTCONTACTPERSON-OBJID: ObjID of the travel point contact person (make sure it's a
     * valid contact person for TRAVELPOINT-OBJID)- ALLOTMENT-OBJID: ObjID of the allotment When creating a reservation linked to an allotment (with the exception of shared allotments), the allotment needs to belong to the orderer of the reservation
     * (holder)However, this depends on who the rate is assigned to, which can also be defined ### Output - RESERVATION-OBJID: ObjID of the newly created reservation
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_CREATE_V006Request $body
     * @return \StructType\S_RESERVATION_CREATE_V006Response|bool
     */
    public function S_RESERVATION_CREATE_V006(\StructType\S_RESERVATION_CREATE_V006Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_CREATE_V006($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\S_RESERVATION_CREATE_V001Response|\StructType\S_RESERVATION_CREATE_V002Response|\StructType\S_RESERVATION_CREATE_V003Response|\StructType\S_RESERVATION_CREATE_V004Response|\StructType\S_RESERVATION_CREATE_V005Response|\StructType\S_RESERVATION_CREATE_V006Response
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
