<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for SRESERVATIONGETV ServiceType
 * @subpackage Services
 */
class SRESERVATIONGETV extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named S_RESERVATION_GET_V001
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_RESERVATION_GET_V002](../S_RESERVATION_GET_V002) - Added optiontodate to output### GeneralThis service returns a specific reservation### Input- RESERVATION-OBJID: ObjID of
     * the reservation, which can be obtained from other defined services. Mandatory### OutputReservation data
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_GET_V001Request $body
     * @return \StructType\S_RESERVATION_GET_V001Response|bool
     */
    public function S_RESERVATION_GET_V001(\StructType\S_RESERVATION_GET_V001Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_GET_V001($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_RESERVATION_GET_V002
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_RESERVATION_GET_V003](../S_RESERVATION_GET_V003) - Fixed contact person information, added ratesFixed field, added missing comment fields (tecnhnical, internet, central,
     * invoice)### GeneralThis service returns a specific reservation.### Input- RESERVATION-OBJID: ObjID of the reservation, which can be obtained from other defined services. Mandatory### OutputReservation data
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_GET_V002Request $body
     * @return \StructType\S_RESERVATION_GET_V002Response|bool
     */
    public function S_RESERVATION_GET_V002(\StructType\S_RESERVATION_GET_V002Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_GET_V002($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_RESERVATION_GET_V003
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_RESERVATION_GET_V004](../S_RESERVATION_GET_V004) - Added marketSegment, channel, nn1 and personStatus fields### GeneralThis service returns a specific reservation.###
     * Input- RESERVATION-OBJID: ObjID of the reservation, which can be obtained from other defined services. Mandatory### OutputReservation data
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_GET_V003Request $body
     * @return \StructType\S_RESERVATION_GET_V003Response|bool
     */
    public function S_RESERVATION_GET_V003(\StructType\S_RESERVATION_GET_V003Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_GET_V003($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_RESERVATION_GET_V004
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_RESERVATION_GET_V005](../S_RESERVATION_GET_V005) - Added category field### GeneralThis service returns a specific reservation.### Input- RESERVATION-OBJID: ObjID of the
     * reservation, which can be obtained from other defined services. Mandatory### OutputReservation data
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_GET_V004Request $body
     * @return \StructType\S_RESERVATION_GET_V004Response|bool
     */
    public function S_RESERVATION_GET_V004(\StructType\S_RESERVATION_GET_V004Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_GET_V004($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_RESERVATION_GET_V005
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_RESERVATION_GET_V006](../S_RESERVATION_GET_V006) - Fixed incorrect naming (from person guestType to personType)### GeneralThis service returns a specific reservation.###
     * Input- RESERVATION-OBJID: ObjID of the reservation, which can be obtained from other defined services. Mandatory### OutputReservation data
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_GET_V005Request $body
     * @return \StructType\S_RESERVATION_GET_V005Response|bool
     */
    public function S_RESERVATION_GET_V005(\StructType\S_RESERVATION_GET_V005Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_GET_V005($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_RESERVATION_GET_V006
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_RESERVATION_GET_V007](../S_RESERVATION_GET_V007) - Added paymentinstructions field to output### GeneralThis service returns a specific reservation.### Input-
     * RESERVATION-OBJID: ObjID of the reservation, which can be obtained from other defined services. Mandatory### OutputReservation data
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_GET_V006Request $body
     * @return \StructType\S_RESERVATION_GET_V006Response|bool
     */
    public function S_RESERVATION_GET_V006(\StructType\S_RESERVATION_GET_V006Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_GET_V006($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_RESERVATION_GET_V007
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_RESERVATION_GET_V008](../S_RESERVATION_GET_V008) - Added guest type to Orderer, Travel Agent and Travel Point. Added nationality, document type and document number to
     * person in room data### GeneralThis service returns a specific reservation.### Input- RESERVATION-OBJID: ObjID of the reservation, which can be obtained from other defined services. Mandatory### OutputReservation data
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_GET_V007Request $body
     * @return \StructType\S_RESERVATION_GET_V007Response|bool
     */
    public function S_RESERVATION_GET_V007(\StructType\S_RESERVATION_GET_V007Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_GET_V007($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_RESERVATION_GET_V008
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_RESERVATION_GET_V009](../S_RESERVATION_GET_V009) - Added payminstrautoservice field### GeneralThis service returns a specific reservation.### Input- RESERVATION-OBJID:
     * ObjID of the reservation, which can be obtained from other defined services. Mandatory### OutputReservation data
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_GET_V008Request $body
     * @return \StructType\S_RESERVATION_GET_V008Response|bool
     */
    public function S_RESERVATION_GET_V008(\StructType\S_RESERVATION_GET_V008Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_GET_V008($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_RESERVATION_GET_V009
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_RESERVATION_GET_V010](../S_RESERVATION_GET_V010) - Added discountGroup field### GeneralThis service returns a specific reservation.### Input- RESERVATION-OBJID: ObjID of
     * the reservation, which can be obtained from other defined services. Mandatory### OutputReservation data
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_GET_V009Request $body
     * @return \StructType\S_RESERVATION_GET_V009Response|bool
     */
    public function S_RESERVATION_GET_V009(\StructType\S_RESERVATION_GET_V009Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_GET_V009($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_RESERVATION_GET_V010
     * Meta information extracted from the WSDL
     * - documentation: ### GeneralThis service returns a specific reservation.### Input- RESERVATION-OBJID: ObjID of the reservation, which can be obtained from other defined services. Mandatory### OutputReservation data
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_GET_V010Request $body
     * @return \StructType\S_RESERVATION_GET_V010Response|bool
     */
    public function S_RESERVATION_GET_V010(\StructType\S_RESERVATION_GET_V010Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_GET_V010($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\S_RESERVATION_GET_V001Response|\StructType\S_RESERVATION_GET_V002Response|\StructType\S_RESERVATION_GET_V003Response|\StructType\S_RESERVATION_GET_V004Response|\StructType\S_RESERVATION_GET_V005Response|\StructType\S_RESERVATION_GET_V006Response|\StructType\S_RESERVATION_GET_V007Response|\StructType\S_RESERVATION_GET_V008Response|\StructType\S_RESERVATION_GET_V009Response|\StructType\S_RESERVATION_GET_V010Response
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
