<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for SRESERVATIONGROUPCREATEV ServiceType
 * @subpackage Services
 */
class SRESERVATIONGROUPCREATEV extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named S_RESERVATION_GROUP_CREATE_V001
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_RESERVATION_GROUP_CREATE_V002](../S_RESERVATION_GROUP_CREATE_V002) - Added optiontodate for optional reservations### GeneralThis service creates a new reservation which is
     * the first element of a group.To add new "elements" to an existing group, the following service should be used: S_RESERVATION_GROUP_RESERVATION_ADD...What to consider when creating a reservation linked to an allotment?- The allotment needs to belong
     * to the orderer of the reservation (holder). However, this depends on who the rate is assigned to, which can also be defined.- The reservation type should be consistent with the allotment we are linking the reservation to. See input section.### Input-
     * ORDERER-OBJID: ObjID of the orderer, which can be obtained from other defined services (Mandatory)- TRAVELAGENCY-OBJID: ObjID of the travel agency (Optional)- TRAVELPOINT-OBJID: ObjID of the travel point (Optional)- ORDERERCONTACTPERSON-OBJID: ObjID
     * of the orderer contact person. Make sure it's a valid contact person for ORDERER-OBJID (Optional)- TRAVELAGENCYCONTACTPERSON-OBJID: ObjID of the travel agency contact person. Make sure it's a valid contact person for TRAVELAGENCY-OBJID (Optional)-
     * TRAVELPOINTCONTACTPERSON-OBJID: ObjID of the travel point contact person. Make sure it's a valid contact person for TRAVELPOINT-OBJID (Optional)- ALLOTMENT-OBJID: ObjID of the allotment to be linked to the reservation (Optional)- restype: Reservation
     * type for the new reservation, see table below (Mandatory) | Reservation type | Description | |------------------|------------------------------------| | 0 | Group block offer | | 1 | Guaranteed | | 2 | Not guaranteed | | 3 | Walk-In | | 4 |
     * Pre-blocked | | 5 | Group block | | 6 | Group reservation (guaranteed) | | 7 | Timeshare | | J | Allotment/group block option | | 8 | Timeshare option | | 9 | Group block option | | H | Allotment-confirmed option | | G | Group block offer option | |
     * A | Turned away | | E | Error | | K | Allotment/group block | | I | Allotment-confirmed | | L | Room blocked | | M | Moved | | N | No-Show | | O | Optional | | S | Cancelled | | W | Waiting list | - Remaining reservation data### Output-
     * RESERVATION-OBJID: ObjID of the newly created reservation
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_GROUP_CREATE_V001Request $body
     * @return \StructType\S_RESERVATION_GROUP_CREATE_V001Response|bool
     */
    public function S_RESERVATION_GROUP_CREATE_V001(\StructType\S_RESERVATION_GROUP_CREATE_V001Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_GROUP_CREATE_V001($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_RESERVATION_GROUP_CREATE_V002
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_RESERVATION_GROUP_CREATE_V003](../S_RESERVATION_GROUP_CREATE_V003) - Added missing comment fields (tecnhnical, internet, central, invoice)### GeneralThis service creates a
     * new reservation which is the first element of a group.To add new "elements" to an existing group, the following service should be used: S_RESERVATION_GROUP_RESERVATION_ADD...What to consider when creating a reservation linked to an allotment?- The
     * allotment needs to belong to the orderer of the reservation (holder). However, this depends on who the rate is assigned to, which can also be defined.- The reservation type should be consistent with the allotment we are linking the reservation to.
     * See input section.### Input- ORDERER-OBJID: ObjID of the orderer, which can be obtained from other defined services (Mandatory)- TRAVELAGENCY-OBJID: ObjID of the travel agency (Optional)- TRAVELPOINT-OBJID: ObjID of the travel point (Optional)-
     * ORDERERCONTACTPERSON-OBJID: ObjID of the orderer contact person. Make sure it's a valid contact person for ORDERER-OBJID (Optional)- TRAVELAGENCYCONTACTPERSON-OBJID: ObjID of the travel agency contact person. Make sure it's a valid contact person for
     * TRAVELAGENCY-OBJID (Optional)- TRAVELPOINTCONTACTPERSON-OBJID: ObjID of the travel point contact person. Make sure it's a valid contact person for TRAVELPOINT-OBJID (Optional)- ALLOTMENT-OBJID: ObjID of the allotment to be linked to the reservation
     * (Optional)- restype: Reservation type for the new reservation, see table below (Mandatory) | Reservation type | Description | |------------------|------------------------------------| | 0 | Group block offer | | 1 | Guaranteed | | 2 | Not guaranteed
     * | | 3 | Walk-In | | 4 | Pre-blocked | | 5 | Group block | | 6 | Group reservation (guaranteed) | | 7 | Timeshare | | J | Allotment/group block option | | 8 | Timeshare option | | 9 | Group block option | | H | Allotment-confirmed option | | G | Group
     * block offer option | | A | Turned away | | E | Error | | K | Allotment/group block | | I | Allotment-confirmed | | L | Room blocked | | M | Moved | | N | No-Show | | O | Optional | | S | Cancelled | | W | Waiting list | - Remaining reservation
     * data### Output- RESERVATION-OBJID: ObjID of the newly created reservation
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_GROUP_CREATE_V002Request $body
     * @return \StructType\S_RESERVATION_GROUP_CREATE_V002Response|bool
     */
    public function S_RESERVATION_GROUP_CREATE_V002(\StructType\S_RESERVATION_GROUP_CREATE_V002Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_GROUP_CREATE_V002($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_RESERVATION_GROUP_CREATE_V003
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_RESERVATION_GROUP_CREATE_V004](../S_RESERVATION_GROUP_CREATE_V004) - Added channel and nn1 fields### GeneralThis service creates a new reservation which is the first
     * element of a group.To add new "elements" to an existing group, the following service should be used: S_RESERVATION_GROUP_RESERVATION_ADD...What to consider when creating a reservation linked to an allotment?- The allotment needs to belong to the
     * orderer of the reservation (holder). However, this depends on who the rate is assigned to, which can also be defined.- The reservation type should be consistent with the allotment we are linking the reservation to. See input section.### Input-
     * ORDERER-OBJID: ObjID of the orderer, which can be obtained from other defined services (Mandatory)- TRAVELAGENCY-OBJID: ObjID of the travel agency (Optional)- TRAVELPOINT-OBJID: ObjID of the travel point (Optional)- ORDERERCONTACTPERSON-OBJID: ObjID
     * of the orderer contact person. Make sure it's a valid contact person for ORDERER-OBJID (Optional)- TRAVELAGENCYCONTACTPERSON-OBJID: ObjID of the travel agency contact person. Make sure it's a valid contact person for TRAVELAGENCY-OBJID (Optional)-
     * TRAVELPOINTCONTACTPERSON-OBJID: ObjID of the travel point contact person. Make sure it's a valid contact person for TRAVELPOINT-OBJID (Optional)- ALLOTMENT-OBJID: ObjID of the allotment to be linked to the reservation (Optional)- restype: Reservation
     * type for the new reservation, see table below (Mandatory) | Reservation type | Description | |------------------|------------------------------------| | 0 | Group block offer | | 1 | Guaranteed | | 2 | Not guaranteed | | 3 | Walk-In | | 4 |
     * Pre-blocked | | 5 | Group block | | 6 | Group reservation (guaranteed) | | 7 | Timeshare | | J | Allotment/group block option | | 8 | Timeshare option | | 9 | Group block option | | H | Allotment-confirmed option | | G | Group block offer option | |
     * A | Turned away | | E | Error | | K | Allotment/group block | | I | Allotment-confirmed | | L | Room blocked | | M | Moved | | N | No-Show | | O | Optional | | S | Cancelled | | W | Waiting list | - Remaining reservation data### Output-
     * RESERVATION-OBJID: ObjID of the newly created reservation
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_GROUP_CREATE_V003Request $body
     * @return \StructType\S_RESERVATION_GROUP_CREATE_V003Response|bool
     */
    public function S_RESERVATION_GROUP_CREATE_V003(\StructType\S_RESERVATION_GROUP_CREATE_V003Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_GROUP_CREATE_V003($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_RESERVATION_GROUP_CREATE_V004
     * Meta information extracted from the WSDL
     * - documentation: ### GeneralThis service creates a new reservation which is the first element of a group.To add new "elements" to an existing group, the following service should be used: S_RESERVATION_GROUP_RESERVATION_ADD...What to consider when
     * creating a reservation linked to an allotment?- The allotment needs to belong to the orderer of the reservation (holder). However, this depends on who the rate is assigned to, which can also be defined.- The reservation type should be consistent with
     * the allotment we are linking the reservation to. See input section.### Input- ORDERER-OBJID: ObjID of the orderer, which can be obtained from other defined services (Mandatory)- TRAVELAGENCY-OBJID: ObjID of the travel agency (Optional)-
     * TRAVELPOINT-OBJID: ObjID of the travel point (Optional)- ORDERERCONTACTPERSON-OBJID: ObjID of the orderer contact person. Make sure it's a valid contact person for ORDERER-OBJID (Optional)- TRAVELAGENCYCONTACTPERSON-OBJID: ObjID of the travel agency
     * contact person. Make sure it's a valid contact person for TRAVELAGENCY-OBJID (Optional)- TRAVELPOINTCONTACTPERSON-OBJID: ObjID of the travel point contact person. Make sure it's a valid contact person for TRAVELPOINT-OBJID (Optional)-
     * ALLOTMENT-OBJID: ObjID of the allotment to be linked to the reservation (Optional)- restype: Reservation type for the new reservation, see table below (Mandatory) | Reservation type | Description |
     * |------------------|------------------------------------| | 0 | Group block offer | | 1 | Guaranteed | | 2 | Not guaranteed | | 3 | Walk-In | | 4 | Pre-blocked | | 5 | Group block | | 6 | Group reservation (guaranteed) | | 7 | Timeshare | | J |
     * Allotment/group block option | | 8 | Timeshare option | | 9 | Group block option | | H | Allotment-confirmed option | | G | Group block offer option | | A | Turned away | | E | Error | | K | Allotment/group block | | I | Allotment-confirmed | | L |
     * Room blocked | | M | Moved | | N | No-Show | | O | Optional | | S | Cancelled | | W | Waiting list | - Remaining reservation data### Output- RESERVATION-OBJID: ObjID of the newly created reservation
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_GROUP_CREATE_V004Request $body
     * @return \StructType\S_RESERVATION_GROUP_CREATE_V004Response|bool
     */
    public function S_RESERVATION_GROUP_CREATE_V004(\StructType\S_RESERVATION_GROUP_CREATE_V004Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_GROUP_CREATE_V004($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\S_RESERVATION_GROUP_CREATE_V001Response|\StructType\S_RESERVATION_GROUP_CREATE_V002Response|\StructType\S_RESERVATION_GROUP_CREATE_V003Response|\StructType\S_RESERVATION_GROUP_CREATE_V004Response
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
