<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for SRESERVATIONMODIFYV ServiceType
 * @subpackage Services
 */
class SRESERVATIONMODIFYV extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named S_RESERVATION_MODIFY_V001
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_RESERVATION_MODIFY_V002](../S_RESERVATION_MODIFY_V002) - Added optiontodate for optional reservations### GeneralThis service modifies an existing reservation### Input-
     * RESERVATION-OBJID: ObjID of the reservation to be modified, which can be obtained from other defined services. Mandatory- All reservation data to be changed
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_MODIFY_V001Request $body
     * @return \StructType\S_RESERVATION_MODIFY_V001Response|bool
     */
    public function S_RESERVATION_MODIFY_V001(\StructType\S_RESERVATION_MODIFY_V001Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_MODIFY_V001($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_RESERVATION_MODIFY_V002
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_RESERVATION_MODIFY_V003](../S_RESERVATION_MODIFY_V003) - Added missing comment fields (tecnhnical, internet, central, invoice)### GeneralThis service modifies an existing
     * reservation.### Input- RESERVATION-OBJID: ObjID of the reservation to be modified, which can be obtained from other defined services. Mandatory- All reservation data to be changed
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_MODIFY_V002Request $body
     * @return \StructType\S_RESERVATION_MODIFY_V002Response|bool
     */
    public function S_RESERVATION_MODIFY_V002(\StructType\S_RESERVATION_MODIFY_V002Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_MODIFY_V002($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_RESERVATION_MODIFY_V003
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_RESERVATION_MODIFY_V004](../S_RESERVATION_MODIFY_V004) - Added resMedium, resSource, channel and nn1 fields### GeneralThis service modifies an existing reservation.###
     * Input- RESERVATION-OBJID: ObjID of the reservation to be modified, which can be obtained from other defined services. Mandatory- All reservation data to be changed
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_MODIFY_V003Request $body
     * @return \StructType\S_RESERVATION_MODIFY_V003Response|bool
     */
    public function S_RESERVATION_MODIFY_V003(\StructType\S_RESERVATION_MODIFY_V003Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_MODIFY_V003($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_RESERVATION_MODIFY_V004
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_RESERVATION_MODIFY_V005](../S_RESERVATION_MODIFY_V005) - Added ratesegment field### GeneralThis service modifies an existing reservation.### Input- RESERVATION-OBJID: ObjID
     * of the reservation to be modified, which can be obtained from other defined services. Mandatory- All reservation data to be changed
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_MODIFY_V004Request $body
     * @return \StructType\S_RESERVATION_MODIFY_V004Response|bool
     */
    public function S_RESERVATION_MODIFY_V004(\StructType\S_RESERVATION_MODIFY_V004Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_MODIFY_V004($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_RESERVATION_MODIFY_V005
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_RESERVATION_MODIFY_V006](../S_RESERVATION_MODIFY_V006) - Added payminstrautoservice field### GeneralThis service modifies an existing reservation.### Input-
     * RESERVATION-OBJID: ObjID of the reservation to be modified, which can be obtained from other defined services. Mandatory- All reservation data to be changed
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_MODIFY_V005Request $body
     * @return \StructType\S_RESERVATION_MODIFY_V005Response|bool
     */
    public function S_RESERVATION_MODIFY_V005(\StructType\S_RESERVATION_MODIFY_V005Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_MODIFY_V005($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_RESERVATION_MODIFY_V006
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_RESERVATION_MODIFY_V007](../S_RESERVATION_MODIFY_V007) - Added discountGroup field### GeneralThis service modifies an existing reservation.### Input- RESERVATION-OBJID:
     * ObjID of the reservation to be modified, which can be obtained from other defined services. Mandatory- All reservation data to be changed
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_MODIFY_V006Request $body
     * @return \StructType\S_RESERVATION_MODIFY_V006Response|bool
     */
    public function S_RESERVATION_MODIFY_V006(\StructType\S_RESERVATION_MODIFY_V006Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_MODIFY_V006($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_RESERVATION_MODIFY_V007
     * Meta information extracted from the WSDL
     * - documentation: ### GeneralThis service modifies an existing reservation.### Input- RESERVATION-OBJID: ObjID of the reservation to be modified, which can be obtained from other defined services. Mandatory- All reservation data to be changed
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_MODIFY_V007Request $body
     * @return \StructType\S_RESERVATION_MODIFY_V007Response|bool
     */
    public function S_RESERVATION_MODIFY_V007(\StructType\S_RESERVATION_MODIFY_V007Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_MODIFY_V007($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\S_RESERVATION_MODIFY_V001Response|\StructType\S_RESERVATION_MODIFY_V002Response|\StructType\S_RESERVATION_MODIFY_V003Response|\StructType\S_RESERVATION_MODIFY_V004Response|\StructType\S_RESERVATION_MODIFY_V005Response|\StructType\S_RESERVATION_MODIFY_V006Response|\StructType\S_RESERVATION_MODIFY_V007Response
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
