<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for SRESERVATIONPAYMENTINSTRUCTIONSETV ServiceType
 * @subpackage Services
 */
class SRESERVATIONPAYMENTINSTRUCTIONSETV extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named
     * S_RESERVATION_PAYMENTINSTRUCTION_SET_V001
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_RESERVATION_PAYMENT_INSTRUCTION_SET_V002](../S_RESERVATION_PAYMENT_INSTRUCTION_SET_V002) - Naming convention correction, added new strucutre for invoice guest, orderer and
     * group.### GeneralThis service sets one or more payment instructions for a specific reservation.### Input- RESERVATION-OBJID: ObjID of the reservation, which can be obtained from defined services (mandatory)- GUEST-OBJID: ObjID of the guest profile,
     * which should be added for the guest account payment instructions.- GUEST-OBJID: ObjID of the guest profile, which should be added for the client account payment instructions.- GUEST-OBJID: ObjID of the guest profile, which should be added for the
     * group account payment instructions.### OutputPayment instructions of the reservation, which can be used to check if the operation was successful.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_PAYMENTINSTRUCTION_SET_V001Request $body
     * @return \StructType\S_RESERVATION_PAYMENTINSTRUCTION_SET_V001Response|bool
     */
    public function S_RESERVATION_PAYMENTINSTRUCTION_SET_V001(\StructType\S_RESERVATION_PAYMENTINSTRUCTION_SET_V001Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_PAYMENTINSTRUCTION_SET_V001($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\S_RESERVATION_PAYMENTINSTRUCTION_SET_V001Response
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
