<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for SRESERVATIONSEARCHV ServiceType
 * @subpackage Services
 */
class SRESERVATIONSEARCHV extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named S_RESERVATION_SEARCH_V001
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_RESERVATION_SEARCH_V002](../S_RESERVATION_SEARCH_V002) - Naming convention changes### GeneralThis service searches for reservations.### Input- resnofrom: start reservation
     * number. Optional- resnoto: end reservation number. Optional- gdsresnumber: GDS number of the reservation. Optional- arrival: arrival date of the reservation. Optional- departure: departure date of the reservation. Optional### OutputList of
     * reservations matching the request.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_SEARCH_V001Request $body
     * @return \StructType\S_RESERVATION_SEARCH_V001Response|bool
     */
    public function S_RESERVATION_SEARCH_V001(\StructType\S_RESERVATION_SEARCH_V001Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_SEARCH_V001($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_RESERVATION_SEARCH_V002
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_RESERVATION_SEARCH_V003](../S_RESERVATION_SEARCH_V003) - Added definitiveTentative search filter and internalrestype to the output### GeneralThis service searches for
     * reservations.### Input- resnofrom: start reservation number. Optional- resnoto: end reservation number. Optional- gdsresnumber: GDS number of the reservation. Optional- arrival: arrival date of the reservation. Optional- departure: departure date of
     * the reservation. Optional- hotel: hotel number of the reservation. Optional### OutputList of reservations matching the request.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_SEARCH_V002Request $body
     * @return \StructType\S_RESERVATION_SEARCH_V002Response|bool
     */
    public function S_RESERVATION_SEARCH_V002(\StructType\S_RESERVATION_SEARCH_V002Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_SEARCH_V002($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_RESERVATION_SEARCH_V003
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_RESERVATION_SEARCH_V004](../S_RESERVATION_SEARCH_V004) - Added paymentinstructions field to the output### GeneralThis service searches for reservations.### Input-
     * resnofrom: start reservation number. Optional- resnoto: end reservation number. Optional- gdsresnumber: GDS number of the reservation. Optional- arrival: arrival date of the reservation. Optional- departure: departure date of the reservation.
     * Optional- hotel: hotel number of the reservation. Optional- definitiveTentative: definitive/tentative reservation. Optional. Possible values are: - 0 = all, - 1 = definitive (default), - 2 = tentative, - 3 = definitive and tentative### OutputList of
     * reservations matching the request.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_SEARCH_V003Request $body
     * @return \StructType\S_RESERVATION_SEARCH_V003Response|bool
     */
    public function S_RESERVATION_SEARCH_V003(\StructType\S_RESERVATION_SEARCH_V003Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_SEARCH_V003($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_RESERVATION_SEARCH_V004
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_RESERVATION_SEARCH_V005](../S_RESERVATION_SEARCH_V005) - Added discountGroup field### GeneralThis service searches for reservations.### Input- resnofrom: start reservation
     * number. Optional- resnoto: end reservation number. Optional- gdsresnumber: GDS number of the reservation. Optional- arrival: arrival date of the reservation. Optional- departure: departure date of the reservation. Optional- hotel: hotel number of the
     * reservation. Optional- definitiveTentative: definitive/tentative reservation. Optional. Possible values are: - 0 = all, - 1 = definitive (default), - 2 = tentative, - 3 = definitive and tentative### OutputList of reservations matching the request.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_SEARCH_V004Request $body
     * @return \StructType\S_RESERVATION_SEARCH_V004Response|bool
     */
    public function S_RESERVATION_SEARCH_V004(\StructType\S_RESERVATION_SEARCH_V004Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_SEARCH_V004($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_RESERVATION_SEARCH_V005
     * Meta information extracted from the WSDL
     * - documentation: ### GeneralThis service searches for reservations.### Input- resnofrom: start reservation number. Optional- resnoto: end reservation number. Optional- gdsresnumber: GDS number of the reservation. Optional- arrival: arrival date of
     * the reservation. Optional- departure: departure date of the reservation. Optional- hotel: hotel number of the reservation. Optional- definitiveTentative: definitive/tentative reservation. Optional. Possible values are: - 0 = all, - 1 = definitive
     * (default), - 2 = tentative, - 3 = definitive and tentative### OutputList of reservations matching the request.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_SEARCH_V005Request $body
     * @return \StructType\S_RESERVATION_SEARCH_V005Response|bool
     */
    public function S_RESERVATION_SEARCH_V005(\StructType\S_RESERVATION_SEARCH_V005Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_SEARCH_V005($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\S_RESERVATION_SEARCH_V001Response|\StructType\S_RESERVATION_SEARCH_V002Response|\StructType\S_RESERVATION_SEARCH_V003Response|\StructType\S_RESERVATION_SEARCH_V004Response|\StructType\S_RESERVATION_SEARCH_V005Response
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
