<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for SRESERVATIONV ServiceType
 * @subpackage Services
 */
class SRESERVATIONV extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named S_RESERVATION_V001
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_RESERVATION_GET_V001](../S_RESERVATION_GET_V001)### GeneralThis service returns a specific reservation.### InputRESERVATION-OBJID: ObjID of the reservation, which can be
     * obtained from defined services. Mandatory### OutputReservation data.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_V001Request $body
     * @return \StructType\S_RESERVATION_V001Response|bool
     */
    public function S_RESERVATION_V001(\StructType\S_RESERVATION_V001Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_V001($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_RESERVATION_V002
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_RESERVATION_GET_V001](../S_RESERVATION_GET_V001)### GeneralThis service return a specific reservation.### Input- RESERVATION-OBJID: ObjID of the reservation, which can be
     * obtained from defined services. Mandatory### OutputReservation data.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_V002Request $body
     * @return \StructType\S_RESERVATION_V002Response|bool
     */
    public function S_RESERVATION_V002(\StructType\S_RESERVATION_V002Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_V002($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_RESERVATION_V003
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_RESERVATION_GET_V001](../S_RESERVATION_GET_V001)### GeneralThis service returns a specific reservation.### Input- RESERVATION-OBJID: ObjID of the reservation, which can be
     * obtained from defined services. Mandatory### OutputReservation data.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_RESERVATION_V003Request $body
     * @return \StructType\S_RESERVATION_V003Response|bool
     */
    public function S_RESERVATION_V003(\StructType\S_RESERVATION_V003Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_RESERVATION_V003($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\S_RESERVATION_V001Response|\StructType\S_RESERVATION_V002Response|\StructType\S_RESERVATION_V003Response
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
