<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for SROOMBOOKINGSTATEV ServiceType
 * @subpackage Services
 */
class SROOMBOOKINGSTATEV extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named S_ROOM_BOOKING_STATE_V001
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_ROOM_BOOKING_STATE_V002](../S_ROOM_BOOKING_STATE_V002) - Fixed incorrect naming (from guestType to personType)### GeneralThis service searches for room booking states.###
     * Input- ROOM-OBJID: ObjID of the room, which can be obtained from defined services. Mandatory### OutputRoom booking state(s).
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_ROOM_BOOKING_STATE_V001Request $body
     * @return \StructType\S_ROOM_BOOKING_STATE_V001Response|bool
     */
    public function S_ROOM_BOOKING_STATE_V001(\StructType\S_ROOM_BOOKING_STATE_V001Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_ROOM_BOOKING_STATE_V001($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_ROOM_BOOKING_STATE_V002
     * Meta information extracted from the WSDL
     * - documentation: ### GeneralThis service searches for room booking states.### Input- ROOM-OBJID: ObjID of the room, which can be obtained from defined services. Mandatory### OutputRoom booking state(s).
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_ROOM_BOOKING_STATE_V002Request $body
     * @return \StructType\S_ROOM_BOOKING_STATE_V002Response|bool
     */
    public function S_ROOM_BOOKING_STATE_V002(\StructType\S_ROOM_BOOKING_STATE_V002Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_ROOM_BOOKING_STATE_V002($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_ROOM_BOOKING_STATE_V01
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_ROOM_BOOKING_STATE_V001](../S_ROOM_BOOKING_STATE_V001) - Replaced due to naming convention### GeneralThis service searches for room states.### Input- ROOM-OBJID: ObjID of
     * the room, which can be obtained from defined services. Mandatory### OutputRoom state(s).
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_ROOM_BOOKING_STATE_V01Request $body
     * @return \StructType\S_ROOM_BOOKING_STATE_V01Response|bool
     */
    public function S_ROOM_BOOKING_STATE_V01(\StructType\S_ROOM_BOOKING_STATE_V01Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_ROOM_BOOKING_STATE_V01($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\S_ROOM_BOOKING_STATE_V001Response|\StructType\S_ROOM_BOOKING_STATE_V002Response|\StructType\S_ROOM_BOOKING_STATE_V01Response
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
