<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for SSERVICESEARCHV ServiceType
 * @subpackage Services
 */
class SSERVICESEARCHV extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named S_SERVICE_SEARCH_V001
     * Meta information extracted from the WSDL
     * - documentation: ### GeneralThis service searches for services.### Input- servicecode: service code, combo box key. Optional- servicetype: service type, combo box key. Optional- ratefilter: rate filter, combo box key. Optional- ratesegment:
     * ratesegment, combo box key. Optional- dateforprice: date for calculate rate. Optional### OutputList of services matching the request.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_SERVICE_SEARCH_V001Request $body
     * @return \StructType\S_SERVICE_SEARCH_V001Response|bool
     */
    public function S_SERVICE_SEARCH_V001(\StructType\S_SERVICE_SEARCH_V001Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_SERVICE_SEARCH_V001($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_SERVICE_SEARCH_V002
     * Meta information extracted from the WSDL
     * - documentation: ### GeneralThis service searches for services.### Input- servicecode: service code, combo box key. Optional- servicetype: service type, combo box key. Optional- ratefilter: rate filter, combo box key. Optional- ratesegment:
     * ratesegment, combo box key. Optional- dateforprice: date for calculate rate. Optional### OutputList of services matching the request.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_SERVICE_SEARCH_V002Request $body
     * @return \StructType\S_SERVICE_SEARCH_V002Response|bool
     */
    public function S_SERVICE_SEARCH_V002(\StructType\S_SERVICE_SEARCH_V002Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_SERVICE_SEARCH_V002($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\S_SERVICE_SEARCH_V001Response|\StructType\S_SERVICE_SEARCH_V002Response
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
