<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for SUSERINFOGETV ServiceType
 * @subpackage Services
 */
class SUSERINFOGETV extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named S_USER_INFO_GET_V001
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_USER_INFO_GET_V002](../S_USER_INFO_GET_V002) - Extended with language, allowed hotels and preferred hotels ### GeneralThis service returns information about the current
     * user and current hotel, which is determined by the specified SecurityID.### InputOnly the SecurityID must be specified.### OutputThe service will return information about the current user and current hotel.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_USER_INFO_GET_V001Request $body
     * @return \StructType\S_USER_INFO_GET_V001Response|bool
     */
    public function S_USER_INFO_GET_V001(\StructType\S_USER_INFO_GET_V001Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_USER_INFO_GET_V001($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_USER_INFO_GET_V002
     * Meta information extracted from the WSDL
     * - documentation: ### DeprecatedThis has been deprecated. Please refer to:- [S_USER_INFO_GET_V003](../S_USER_INFO_GET_V003) - Extended with codeinternal ### GeneralThis service returns information about the current user and current hotel, which is
     * determined by the specified SecurityID.### InputOnly the SecurityID must be specified.### OutputThe service will return information about the current user and current hotel.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_USER_INFO_GET_V002Request $body
     * @return \StructType\S_USER_INFO_GET_V002Response|bool
     */
    public function S_USER_INFO_GET_V002(\StructType\S_USER_INFO_GET_V002Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_USER_INFO_GET_V002($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named S_USER_INFO_GET_V003
     * Meta information extracted from the WSDL
     * - documentation: ### GeneralThis service returns information about the current user and current hotel, which is determined by the specified SecurityID.### InputOnly the SecurityID must be specified.### OutputThe service will return information about
     * the current user and current hotel.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\S_USER_INFO_GET_V003Request $body
     * @return \StructType\S_USER_INFO_GET_V003Response|bool
     */
    public function S_USER_INFO_GET_V003(\StructType\S_USER_INFO_GET_V003Request $body)
    {
        try {
            $this->setResult($this->getSoapClient()->S_USER_INFO_GET_V003($body));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\S_USER_INFO_GET_V001Response|\StructType\S_USER_INFO_GET_V002Response|\StructType\S_USER_INFO_GET_V003Response
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
