<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AllowedHotels StructType
 * @subpackage Structs
 */
class AllowedHotels extends AbstractStructBase
{
    /**
     * The AllowedHotel
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\AllowedHotel[]
     */
    public $AllowedHotel;
    /**
     * Constructor method for AllowedHotels
     * @uses AllowedHotels::setAllowedHotel()
     * @param \StructType\AllowedHotel[] $allowedHotel
     */
    public function __construct(array $allowedHotel = array())
    {
        $this
            ->setAllowedHotel($allowedHotel);
    }
    /**
     * Get AllowedHotel value
     * @return \StructType\AllowedHotel[]|null
     */
    public function getAllowedHotel()
    {
        return $this->AllowedHotel;
    }
    /**
     * This method is responsible for validating the values passed to the setAllowedHotel method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAllowedHotel method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAllowedHotelForArrayConstraintsFromSetAllowedHotel(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $allowedHotelsAllowedHotelItem) {
            // validation for constraint: itemType
            if (!$allowedHotelsAllowedHotelItem instanceof \StructType\AllowedHotel) {
                $invalidValues[] = is_object($allowedHotelsAllowedHotelItem) ? get_class($allowedHotelsAllowedHotelItem) : sprintf('%s(%s)', gettype($allowedHotelsAllowedHotelItem), var_export($allowedHotelsAllowedHotelItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AllowedHotel property can only contain items of type \StructType\AllowedHotel, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AllowedHotel value
     * @throws \InvalidArgumentException
     * @param \StructType\AllowedHotel[] $allowedHotel
     * @return \StructType\AllowedHotels
     */
    public function setAllowedHotel(array $allowedHotel = array())
    {
        // validation for constraint: array
        if ('' !== ($allowedHotelArrayErrorMessage = self::validateAllowedHotelForArrayConstraintsFromSetAllowedHotel($allowedHotel))) {
            throw new \InvalidArgumentException($allowedHotelArrayErrorMessage, __LINE__);
        }
        $this->AllowedHotel = $allowedHotel;
        return $this;
    }
    /**
     * Add item to AllowedHotel value
     * @throws \InvalidArgumentException
     * @param \StructType\AllowedHotel $item
     * @return \StructType\AllowedHotels
     */
    public function addToAllowedHotel(\StructType\AllowedHotel $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AllowedHotel) {
            throw new \InvalidArgumentException(sprintf('The AllowedHotel property can only contain items of type \StructType\AllowedHotel, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AllowedHotel[] = $item;
        return $this;
    }
}
