<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CATEGORY-SEARCH StructType
 * @subpackage Structs
 */
class CATEGORY_SEARCH extends AbstractStructBase
{
    /**
     * The category
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $category;
    /**
     * Constructor method for CATEGORY-SEARCH
     * @uses CATEGORY_SEARCH::setCategory()
     * @param string $category
     */
    public function __construct($category = null)
    {
        $this
            ->setCategory($category);
    }
    /**
     * Get category value
     * @return string|null
     */
    public function getCategory()
    {
        return $this->category;
    }
    /**
     * Set category value
     * @param string $category
     * @return \StructType\CATEGORY_SEARCH
     */
    public function setCategory($category = null)
    {
        // validation for constraint: string
        if (!is_null($category) && !is_string($category)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($category, true), gettype($category)), __LINE__);
        }
        $this->category = $category;
        return $this;
    }
}
