<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CONSTRAINT-OPTIONS StructType
 * @subpackage Structs
 */
class CONSTRAINT_OPTIONS extends AbstractStructBase
{
    /**
     * The CONSTRAINT
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CONSTRAINT[]
     */
    public $CONSTRAINT;
    /**
     * Constructor method for CONSTRAINT-OPTIONS
     * @uses CONSTRAINT_OPTIONS::setCONSTRAINT()
     * @param \StructType\CONSTRAINT[] $cONSTRAINT
     */
    public function __construct(array $cONSTRAINT = array())
    {
        $this
            ->setCONSTRAINT($cONSTRAINT);
    }
    /**
     * Get CONSTRAINT value
     * @return \StructType\CONSTRAINT[]|null
     */
    public function getCONSTRAINT()
    {
        return $this->CONSTRAINT;
    }
    /**
     * This method is responsible for validating the values passed to the setCONSTRAINT method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCONSTRAINT method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCONSTRAINTForArrayConstraintsFromSetCONSTRAINT(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $cONSTRAINT_OPTIONSCONSTRAINTItem) {
            // validation for constraint: itemType
            if (!$cONSTRAINT_OPTIONSCONSTRAINTItem instanceof \StructType\CONSTRAINT) {
                $invalidValues[] = is_object($cONSTRAINT_OPTIONSCONSTRAINTItem) ? get_class($cONSTRAINT_OPTIONSCONSTRAINTItem) : sprintf('%s(%s)', gettype($cONSTRAINT_OPTIONSCONSTRAINTItem), var_export($cONSTRAINT_OPTIONSCONSTRAINTItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CONSTRAINT property can only contain items of type \StructType\CONSTRAINT, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CONSTRAINT value
     * @throws \InvalidArgumentException
     * @param \StructType\CONSTRAINT[] $cONSTRAINT
     * @return \StructType\CONSTRAINT_OPTIONS
     */
    public function setCONSTRAINT(array $cONSTRAINT = array())
    {
        // validation for constraint: array
        if ('' !== ($cONSTRAINTArrayErrorMessage = self::validateCONSTRAINTForArrayConstraintsFromSetCONSTRAINT($cONSTRAINT))) {
            throw new \InvalidArgumentException($cONSTRAINTArrayErrorMessage, __LINE__);
        }
        $this->CONSTRAINT = $cONSTRAINT;
        return $this;
    }
    /**
     * Add item to CONSTRAINT value
     * @throws \InvalidArgumentException
     * @param \StructType\CONSTRAINT $item
     * @return \StructType\CONSTRAINT_OPTIONS
     */
    public function addToCONSTRAINT(\StructType\CONSTRAINT $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CONSTRAINT) {
            throw new \InvalidArgumentException(sprintf('The CONSTRAINT property can only contain items of type \StructType\CONSTRAINT, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CONSTRAINT[] = $item;
        return $this;
    }
}
