<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CONTACT-PERSONS StructType
 * @subpackage Structs
 */
class CONTACT_PERSONS extends AbstractStructBase
{
    /**
     * The CONTACT_PERSON
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CONTACT_PERSON[]
     */
    public $CONTACT_PERSON;
    /**
     * Constructor method for CONTACT-PERSONS
     * @uses CONTACT_PERSONS::setCONTACT_PERSON()
     * @param \StructType\CONTACT_PERSON[] $cONTACT_PERSON
     */
    public function __construct(array $cONTACT_PERSON = array())
    {
        $this
            ->setCONTACT_PERSON($cONTACT_PERSON);
    }
    /**
     * Get CONTACT_PERSON value
     * @return \StructType\CONTACT_PERSON[]|null
     */
    public function getCONTACT_PERSON()
    {
        return $this->{'CONTACT-PERSON'};
    }
    /**
     * This method is responsible for validating the values passed to the setCONTACT_PERSON method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCONTACT_PERSON method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCONTACT_PERSONForArrayConstraintsFromSetCONTACT_PERSON(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $cONTACT_PERSONSCONTACT_PERSONItem) {
            // validation for constraint: itemType
            if (!$cONTACT_PERSONSCONTACT_PERSONItem instanceof \StructType\CONTACT_PERSON) {
                $invalidValues[] = is_object($cONTACT_PERSONSCONTACT_PERSONItem) ? get_class($cONTACT_PERSONSCONTACT_PERSONItem) : sprintf('%s(%s)', gettype($cONTACT_PERSONSCONTACT_PERSONItem), var_export($cONTACT_PERSONSCONTACT_PERSONItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CONTACT_PERSON property can only contain items of type \StructType\CONTACT_PERSON, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CONTACT_PERSON value
     * @throws \InvalidArgumentException
     * @param \StructType\CONTACT_PERSON[] $cONTACT_PERSON
     * @return \StructType\CONTACT_PERSONS
     */
    public function setCONTACT_PERSON(array $cONTACT_PERSON = array())
    {
        // validation for constraint: array
        if ('' !== ($cONTACT_PERSONArrayErrorMessage = self::validateCONTACT_PERSONForArrayConstraintsFromSetCONTACT_PERSON($cONTACT_PERSON))) {
            throw new \InvalidArgumentException($cONTACT_PERSONArrayErrorMessage, __LINE__);
        }
        $this->CONTACT_PERSON = $this->{'CONTACT-PERSON'} = $cONTACT_PERSON;
        return $this;
    }
    /**
     * Add item to CONTACT_PERSON value
     * @throws \InvalidArgumentException
     * @param \StructType\CONTACT_PERSON $item
     * @return \StructType\CONTACT_PERSONS
     */
    public function addToCONTACT_PERSON(\StructType\CONTACT_PERSON $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CONTACT_PERSON) {
            throw new \InvalidArgumentException(sprintf('The CONTACT_PERSON property can only contain items of type \StructType\CONTACT_PERSON, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CONTACT_PERSON[] = $this->{'CONTACT-PERSON'}[] = $item;
        return $this;
    }
}
