<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CRITERIA StructType
 * @subpackage Structs
 */
class CRITERIA extends AbstractStructBase
{
    /**
     * The DESCRIPTION
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $DESCRIPTION;
    /**
     * The TYPE
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $TYPE;
    /**
     * The CRITERION
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CRITERION[]
     */
    public $CRITERION;
    /**
     * Constructor method for CRITERIA
     * @uses CRITERIA::setDESCRIPTION()
     * @uses CRITERIA::setTYPE()
     * @uses CRITERIA::setCRITERION()
     * @param string $dESCRIPTION
     * @param string $tYPE
     * @param \StructType\CRITERION[] $cRITERION
     */
    public function __construct($dESCRIPTION = null, $tYPE = null, array $cRITERION = array())
    {
        $this
            ->setDESCRIPTION($dESCRIPTION)
            ->setTYPE($tYPE)
            ->setCRITERION($cRITERION);
    }
    /**
     * Get DESCRIPTION value
     * @return string
     */
    public function getDESCRIPTION()
    {
        return $this->DESCRIPTION;
    }
    /**
     * Set DESCRIPTION value
     * @param string $dESCRIPTION
     * @return \StructType\CRITERIA
     */
    public function setDESCRIPTION($dESCRIPTION = null)
    {
        // validation for constraint: string
        if (!is_null($dESCRIPTION) && !is_string($dESCRIPTION)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dESCRIPTION, true), gettype($dESCRIPTION)), __LINE__);
        }
        $this->DESCRIPTION = $dESCRIPTION;
        return $this;
    }
    /**
     * Get TYPE value
     * @return string
     */
    public function getTYPE()
    {
        return $this->TYPE;
    }
    /**
     * Set TYPE value
     * @param string $tYPE
     * @return \StructType\CRITERIA
     */
    public function setTYPE($tYPE = null)
    {
        // validation for constraint: string
        if (!is_null($tYPE) && !is_string($tYPE)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tYPE, true), gettype($tYPE)), __LINE__);
        }
        $this->TYPE = $tYPE;
        return $this;
    }
    /**
     * Get CRITERION value
     * @return \StructType\CRITERION[]|null
     */
    public function getCRITERION()
    {
        return $this->CRITERION;
    }
    /**
     * This method is responsible for validating the values passed to the setCRITERION method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCRITERION method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCRITERIONForArrayConstraintsFromSetCRITERION(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $cRITERIACRITERIONItem) {
            // validation for constraint: itemType
            if (!$cRITERIACRITERIONItem instanceof \StructType\CRITERION) {
                $invalidValues[] = is_object($cRITERIACRITERIONItem) ? get_class($cRITERIACRITERIONItem) : sprintf('%s(%s)', gettype($cRITERIACRITERIONItem), var_export($cRITERIACRITERIONItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CRITERION property can only contain items of type \StructType\CRITERION, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CRITERION value
     * @throws \InvalidArgumentException
     * @param \StructType\CRITERION[] $cRITERION
     * @return \StructType\CRITERIA
     */
    public function setCRITERION(array $cRITERION = array())
    {
        // validation for constraint: array
        if ('' !== ($cRITERIONArrayErrorMessage = self::validateCRITERIONForArrayConstraintsFromSetCRITERION($cRITERION))) {
            throw new \InvalidArgumentException($cRITERIONArrayErrorMessage, __LINE__);
        }
        $this->CRITERION = $cRITERION;
        return $this;
    }
    /**
     * Add item to CRITERION value
     * @throws \InvalidArgumentException
     * @param \StructType\CRITERION $item
     * @return \StructType\CRITERIA
     */
    public function addToCRITERION(\StructType\CRITERION $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CRITERION) {
            throw new \InvalidArgumentException(sprintf('The CRITERION property can only contain items of type \StructType\CRITERION, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CRITERION[] = $item;
        return $this;
    }
}
