<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DISCOUNTS StructType
 * @subpackage Structs
 */
class DISCOUNTS extends AbstractStructBase
{
    /**
     * The DISCOUNT
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\DISCOUNT[]
     */
    public $DISCOUNT;
    /**
     * Constructor method for DISCOUNTS
     * @uses DISCOUNTS::setDISCOUNT()
     * @param \StructType\DISCOUNT[] $dISCOUNT
     */
    public function __construct(array $dISCOUNT = array())
    {
        $this
            ->setDISCOUNT($dISCOUNT);
    }
    /**
     * Get DISCOUNT value
     * @return \StructType\DISCOUNT[]|null
     */
    public function getDISCOUNT()
    {
        return $this->DISCOUNT;
    }
    /**
     * This method is responsible for validating the values passed to the setDISCOUNT method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDISCOUNT method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDISCOUNTForArrayConstraintsFromSetDISCOUNT(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $dISCOUNTSDISCOUNTItem) {
            // validation for constraint: itemType
            if (!$dISCOUNTSDISCOUNTItem instanceof \StructType\DISCOUNT) {
                $invalidValues[] = is_object($dISCOUNTSDISCOUNTItem) ? get_class($dISCOUNTSDISCOUNTItem) : sprintf('%s(%s)', gettype($dISCOUNTSDISCOUNTItem), var_export($dISCOUNTSDISCOUNTItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DISCOUNT property can only contain items of type \StructType\DISCOUNT, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DISCOUNT value
     * @throws \InvalidArgumentException
     * @param \StructType\DISCOUNT[] $dISCOUNT
     * @return \StructType\DISCOUNTS
     */
    public function setDISCOUNT(array $dISCOUNT = array())
    {
        // validation for constraint: array
        if ('' !== ($dISCOUNTArrayErrorMessage = self::validateDISCOUNTForArrayConstraintsFromSetDISCOUNT($dISCOUNT))) {
            throw new \InvalidArgumentException($dISCOUNTArrayErrorMessage, __LINE__);
        }
        $this->DISCOUNT = $dISCOUNT;
        return $this;
    }
    /**
     * Add item to DISCOUNT value
     * @throws \InvalidArgumentException
     * @param \StructType\DISCOUNT $item
     * @return \StructType\DISCOUNTS
     */
    public function addToDISCOUNT(\StructType\DISCOUNT $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DISCOUNT) {
            throw new \InvalidArgumentException(sprintf('The DISCOUNT property can only contain items of type \StructType\DISCOUNT, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DISCOUNT[] = $item;
        return $this;
    }
}
