<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EVENT-ROOMS StructType
 * @subpackage Structs
 */
class EVENT_ROOMS extends AbstractStructBase
{
    /**
     * The EVENT_ROOM
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\EVENT_ROOM[]
     */
    public $EVENT_ROOM;
    /**
     * Constructor method for EVENT-ROOMS
     * @uses EVENT_ROOMS::setEVENT_ROOM()
     * @param \StructType\EVENT_ROOM[] $eVENT_ROOM
     */
    public function __construct(array $eVENT_ROOM = array())
    {
        $this
            ->setEVENT_ROOM($eVENT_ROOM);
    }
    /**
     * Get EVENT_ROOM value
     * @return \StructType\EVENT_ROOM[]|null
     */
    public function getEVENT_ROOM()
    {
        return $this->{'EVENT-ROOM'};
    }
    /**
     * This method is responsible for validating the values passed to the setEVENT_ROOM method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEVENT_ROOM method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEVENT_ROOMForArrayConstraintsFromSetEVENT_ROOM(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $eVENT_ROOMSEVENT_ROOMItem) {
            // validation for constraint: itemType
            if (!$eVENT_ROOMSEVENT_ROOMItem instanceof \StructType\EVENT_ROOM) {
                $invalidValues[] = is_object($eVENT_ROOMSEVENT_ROOMItem) ? get_class($eVENT_ROOMSEVENT_ROOMItem) : sprintf('%s(%s)', gettype($eVENT_ROOMSEVENT_ROOMItem), var_export($eVENT_ROOMSEVENT_ROOMItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EVENT_ROOM property can only contain items of type \StructType\EVENT_ROOM, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EVENT_ROOM value
     * @throws \InvalidArgumentException
     * @param \StructType\EVENT_ROOM[] $eVENT_ROOM
     * @return \StructType\EVENT_ROOMS
     */
    public function setEVENT_ROOM(array $eVENT_ROOM = array())
    {
        // validation for constraint: array
        if ('' !== ($eVENT_ROOMArrayErrorMessage = self::validateEVENT_ROOMForArrayConstraintsFromSetEVENT_ROOM($eVENT_ROOM))) {
            throw new \InvalidArgumentException($eVENT_ROOMArrayErrorMessage, __LINE__);
        }
        $this->EVENT_ROOM = $this->{'EVENT-ROOM'} = $eVENT_ROOM;
        return $this;
    }
    /**
     * Add item to EVENT_ROOM value
     * @throws \InvalidArgumentException
     * @param \StructType\EVENT_ROOM $item
     * @return \StructType\EVENT_ROOMS
     */
    public function addToEVENT_ROOM(\StructType\EVENT_ROOM $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EVENT_ROOM) {
            throw new \InvalidArgumentException(sprintf('The EVENT_ROOM property can only contain items of type \StructType\EVENT_ROOM, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EVENT_ROOM[] = $this->{'EVENT-ROOM'}[] = $item;
        return $this;
    }
}
