<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EXTERNALID StructType
 * @subpackage Structs
 */
class EXTERNALID extends AbstractStructBase
{
    /**
     * The externalid
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $externalid;
    /**
     * The externaltype
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $externaltype;
    /**
     * Constructor method for EXTERNALID
     * @uses EXTERNALID::setExternalid()
     * @uses EXTERNALID::setExternaltype()
     * @param string $externalid
     * @param string $externaltype
     */
    public function __construct($externalid = null, $externaltype = null)
    {
        $this
            ->setExternalid($externalid)
            ->setExternaltype($externaltype);
    }
    /**
     * Get externalid value
     * @return string
     */
    public function getExternalid()
    {
        return $this->externalid;
    }
    /**
     * Set externalid value
     * @param string $externalid
     * @return \StructType\EXTERNALID
     */
    public function setExternalid($externalid = null)
    {
        // validation for constraint: string
        if (!is_null($externalid) && !is_string($externalid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($externalid, true), gettype($externalid)), __LINE__);
        }
        $this->externalid = $externalid;
        return $this;
    }
    /**
     * Get externaltype value
     * @return string
     */
    public function getExternaltype()
    {
        return $this->externaltype;
    }
    /**
     * Set externaltype value
     * @param string $externaltype
     * @return \StructType\EXTERNALID
     */
    public function setExternaltype($externaltype = null)
    {
        // validation for constraint: string
        if (!is_null($externaltype) && !is_string($externaltype)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($externaltype, true), gettype($externaltype)), __LINE__);
        }
        $this->externaltype = $externaltype;
        return $this;
    }
}
