<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EXTERNALIDS StructType
 * @subpackage Structs
 */
class EXTERNALIDS extends AbstractStructBase
{
    /**
     * The EXTERNALID
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\EXTERNALID[]
     */
    public $EXTERNALID;
    /**
     * Constructor method for EXTERNALIDS
     * @uses EXTERNALIDS::setEXTERNALID()
     * @param \StructType\EXTERNALID[] $eXTERNALID
     */
    public function __construct(array $eXTERNALID = array())
    {
        $this
            ->setEXTERNALID($eXTERNALID);
    }
    /**
     * Get EXTERNALID value
     * @return \StructType\EXTERNALID[]|null
     */
    public function getEXTERNALID()
    {
        return $this->EXTERNALID;
    }
    /**
     * This method is responsible for validating the values passed to the setEXTERNALID method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEXTERNALID method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEXTERNALIDForArrayConstraintsFromSetEXTERNALID(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $eXTERNALIDSEXTERNALIDItem) {
            // validation for constraint: itemType
            if (!$eXTERNALIDSEXTERNALIDItem instanceof \StructType\EXTERNALID) {
                $invalidValues[] = is_object($eXTERNALIDSEXTERNALIDItem) ? get_class($eXTERNALIDSEXTERNALIDItem) : sprintf('%s(%s)', gettype($eXTERNALIDSEXTERNALIDItem), var_export($eXTERNALIDSEXTERNALIDItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EXTERNALID property can only contain items of type \StructType\EXTERNALID, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EXTERNALID value
     * @throws \InvalidArgumentException
     * @param \StructType\EXTERNALID[] $eXTERNALID
     * @return \StructType\EXTERNALIDS
     */
    public function setEXTERNALID(array $eXTERNALID = array())
    {
        // validation for constraint: array
        if ('' !== ($eXTERNALIDArrayErrorMessage = self::validateEXTERNALIDForArrayConstraintsFromSetEXTERNALID($eXTERNALID))) {
            throw new \InvalidArgumentException($eXTERNALIDArrayErrorMessage, __LINE__);
        }
        $this->EXTERNALID = $eXTERNALID;
        return $this;
    }
    /**
     * Add item to EXTERNALID value
     * @throws \InvalidArgumentException
     * @param \StructType\EXTERNALID $item
     * @return \StructType\EXTERNALIDS
     */
    public function addToEXTERNALID(\StructType\EXTERNALID $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EXTERNALID) {
            throw new \InvalidArgumentException(sprintf('The EXTERNALID property can only contain items of type \StructType\EXTERNALID, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EXTERNALID[] = $item;
        return $this;
    }
}
