<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EventEquipmentMasterFiles StructType
 * @subpackage Structs
 */
class EventEquipmentMasterFiles extends AbstractStructBase
{
    /**
     * The EventEquipmentMasterFile
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\EventEquipmentMasterFile[]
     */
    public $EventEquipmentMasterFile;
    /**
     * Constructor method for EventEquipmentMasterFiles
     * @uses EventEquipmentMasterFiles::setEventEquipmentMasterFile()
     * @param \StructType\EventEquipmentMasterFile[] $eventEquipmentMasterFile
     */
    public function __construct(array $eventEquipmentMasterFile = array())
    {
        $this
            ->setEventEquipmentMasterFile($eventEquipmentMasterFile);
    }
    /**
     * Get EventEquipmentMasterFile value
     * @return \StructType\EventEquipmentMasterFile[]|null
     */
    public function getEventEquipmentMasterFile()
    {
        return $this->EventEquipmentMasterFile;
    }
    /**
     * This method is responsible for validating the values passed to the setEventEquipmentMasterFile method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEventEquipmentMasterFile method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEventEquipmentMasterFileForArrayConstraintsFromSetEventEquipmentMasterFile(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $eventEquipmentMasterFilesEventEquipmentMasterFileItem) {
            // validation for constraint: itemType
            if (!$eventEquipmentMasterFilesEventEquipmentMasterFileItem instanceof \StructType\EventEquipmentMasterFile) {
                $invalidValues[] = is_object($eventEquipmentMasterFilesEventEquipmentMasterFileItem) ? get_class($eventEquipmentMasterFilesEventEquipmentMasterFileItem) : sprintf('%s(%s)', gettype($eventEquipmentMasterFilesEventEquipmentMasterFileItem), var_export($eventEquipmentMasterFilesEventEquipmentMasterFileItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EventEquipmentMasterFile property can only contain items of type \StructType\EventEquipmentMasterFile, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EventEquipmentMasterFile value
     * @throws \InvalidArgumentException
     * @param \StructType\EventEquipmentMasterFile[] $eventEquipmentMasterFile
     * @return \StructType\EventEquipmentMasterFiles
     */
    public function setEventEquipmentMasterFile(array $eventEquipmentMasterFile = array())
    {
        // validation for constraint: array
        if ('' !== ($eventEquipmentMasterFileArrayErrorMessage = self::validateEventEquipmentMasterFileForArrayConstraintsFromSetEventEquipmentMasterFile($eventEquipmentMasterFile))) {
            throw new \InvalidArgumentException($eventEquipmentMasterFileArrayErrorMessage, __LINE__);
        }
        $this->EventEquipmentMasterFile = $eventEquipmentMasterFile;
        return $this;
    }
    /**
     * Add item to EventEquipmentMasterFile value
     * @throws \InvalidArgumentException
     * @param \StructType\EventEquipmentMasterFile $item
     * @return \StructType\EventEquipmentMasterFiles
     */
    public function addToEventEquipmentMasterFile(\StructType\EventEquipmentMasterFile $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EventEquipmentMasterFile) {
            throw new \InvalidArgumentException(sprintf('The EventEquipmentMasterFile property can only contain items of type \StructType\EventEquipmentMasterFile, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EventEquipmentMasterFile[] = $item;
        return $this;
    }
}
