<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EventRoomMasterFiles StructType
 * @subpackage Structs
 */
class EventRoomMasterFiles extends AbstractStructBase
{
    /**
     * The EventRoomMasterFile
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\EventRoomMasterFile[]
     */
    public $EventRoomMasterFile;
    /**
     * Constructor method for EventRoomMasterFiles
     * @uses EventRoomMasterFiles::setEventRoomMasterFile()
     * @param \StructType\EventRoomMasterFile[] $eventRoomMasterFile
     */
    public function __construct(array $eventRoomMasterFile = array())
    {
        $this
            ->setEventRoomMasterFile($eventRoomMasterFile);
    }
    /**
     * Get EventRoomMasterFile value
     * @return \StructType\EventRoomMasterFile[]|null
     */
    public function getEventRoomMasterFile()
    {
        return $this->EventRoomMasterFile;
    }
    /**
     * This method is responsible for validating the values passed to the setEventRoomMasterFile method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEventRoomMasterFile method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEventRoomMasterFileForArrayConstraintsFromSetEventRoomMasterFile(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $eventRoomMasterFilesEventRoomMasterFileItem) {
            // validation for constraint: itemType
            if (!$eventRoomMasterFilesEventRoomMasterFileItem instanceof \StructType\EventRoomMasterFile) {
                $invalidValues[] = is_object($eventRoomMasterFilesEventRoomMasterFileItem) ? get_class($eventRoomMasterFilesEventRoomMasterFileItem) : sprintf('%s(%s)', gettype($eventRoomMasterFilesEventRoomMasterFileItem), var_export($eventRoomMasterFilesEventRoomMasterFileItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EventRoomMasterFile property can only contain items of type \StructType\EventRoomMasterFile, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EventRoomMasterFile value
     * @throws \InvalidArgumentException
     * @param \StructType\EventRoomMasterFile[] $eventRoomMasterFile
     * @return \StructType\EventRoomMasterFiles
     */
    public function setEventRoomMasterFile(array $eventRoomMasterFile = array())
    {
        // validation for constraint: array
        if ('' !== ($eventRoomMasterFileArrayErrorMessage = self::validateEventRoomMasterFileForArrayConstraintsFromSetEventRoomMasterFile($eventRoomMasterFile))) {
            throw new \InvalidArgumentException($eventRoomMasterFileArrayErrorMessage, __LINE__);
        }
        $this->EventRoomMasterFile = $eventRoomMasterFile;
        return $this;
    }
    /**
     * Add item to EventRoomMasterFile value
     * @throws \InvalidArgumentException
     * @param \StructType\EventRoomMasterFile $item
     * @return \StructType\EventRoomMasterFiles
     */
    public function addToEventRoomMasterFile(\StructType\EventRoomMasterFile $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EventRoomMasterFile) {
            throw new \InvalidArgumentException(sprintf('The EventRoomMasterFile property can only contain items of type \StructType\EventRoomMasterFile, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EventRoomMasterFile[] = $item;
        return $this;
    }
}
