<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ExternalFileDatas StructType
 * @subpackage Structs
 */
class ExternalFileDatas extends AbstractStructBase
{
    /**
     * The ExternalFileData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ExternalFileData[]
     */
    public $ExternalFileData;
    /**
     * Constructor method for ExternalFileDatas
     * @uses ExternalFileDatas::setExternalFileData()
     * @param \StructType\ExternalFileData[] $externalFileData
     */
    public function __construct(array $externalFileData = array())
    {
        $this
            ->setExternalFileData($externalFileData);
    }
    /**
     * Get ExternalFileData value
     * @return \StructType\ExternalFileData[]|null
     */
    public function getExternalFileData()
    {
        return $this->ExternalFileData;
    }
    /**
     * This method is responsible for validating the values passed to the setExternalFileData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setExternalFileData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateExternalFileDataForArrayConstraintsFromSetExternalFileData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $externalFileDatasExternalFileDataItem) {
            // validation for constraint: itemType
            if (!$externalFileDatasExternalFileDataItem instanceof \StructType\ExternalFileData) {
                $invalidValues[] = is_object($externalFileDatasExternalFileDataItem) ? get_class($externalFileDatasExternalFileDataItem) : sprintf('%s(%s)', gettype($externalFileDatasExternalFileDataItem), var_export($externalFileDatasExternalFileDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ExternalFileData property can only contain items of type \StructType\ExternalFileData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ExternalFileData value
     * @throws \InvalidArgumentException
     * @param \StructType\ExternalFileData[] $externalFileData
     * @return \StructType\ExternalFileDatas
     */
    public function setExternalFileData(array $externalFileData = array())
    {
        // validation for constraint: array
        if ('' !== ($externalFileDataArrayErrorMessage = self::validateExternalFileDataForArrayConstraintsFromSetExternalFileData($externalFileData))) {
            throw new \InvalidArgumentException($externalFileDataArrayErrorMessage, __LINE__);
        }
        $this->ExternalFileData = $externalFileData;
        return $this;
    }
    /**
     * Add item to ExternalFileData value
     * @throws \InvalidArgumentException
     * @param \StructType\ExternalFileData $item
     * @return \StructType\ExternalFileDatas
     */
    public function addToExternalFileData(\StructType\ExternalFileData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ExternalFileData) {
            throw new \InvalidArgumentException(sprintf('The ExternalFileData property can only contain items of type \StructType\ExternalFileData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ExternalFileData[] = $item;
        return $this;
    }
}
