<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FEATURES StructType
 * @subpackage Structs
 */
class FEATURES extends AbstractStructBase
{
    /**
     * The FEATURE
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\FEATURE[]
     */
    public $FEATURE;
    /**
     * Constructor method for FEATURES
     * @uses FEATURES::setFEATURE()
     * @param \StructType\FEATURE[] $fEATURE
     */
    public function __construct(array $fEATURE = array())
    {
        $this
            ->setFEATURE($fEATURE);
    }
    /**
     * Get FEATURE value
     * @return \StructType\FEATURE[]|null
     */
    public function getFEATURE()
    {
        return $this->FEATURE;
    }
    /**
     * This method is responsible for validating the values passed to the setFEATURE method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFEATURE method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFEATUREForArrayConstraintsFromSetFEATURE(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $fEATURESFEATUREItem) {
            // validation for constraint: itemType
            if (!$fEATURESFEATUREItem instanceof \StructType\FEATURE) {
                $invalidValues[] = is_object($fEATURESFEATUREItem) ? get_class($fEATURESFEATUREItem) : sprintf('%s(%s)', gettype($fEATURESFEATUREItem), var_export($fEATURESFEATUREItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FEATURE property can only contain items of type \StructType\FEATURE, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FEATURE value
     * @throws \InvalidArgumentException
     * @param \StructType\FEATURE[] $fEATURE
     * @return \StructType\FEATURES
     */
    public function setFEATURE(array $fEATURE = array())
    {
        // validation for constraint: array
        if ('' !== ($fEATUREArrayErrorMessage = self::validateFEATUREForArrayConstraintsFromSetFEATURE($fEATURE))) {
            throw new \InvalidArgumentException($fEATUREArrayErrorMessage, __LINE__);
        }
        $this->FEATURE = $fEATURE;
        return $this;
    }
    /**
     * Add item to FEATURE value
     * @throws \InvalidArgumentException
     * @param \StructType\FEATURE $item
     * @return \StructType\FEATURES
     */
    public function addToFEATURE(\StructType\FEATURE $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FEATURE) {
            throw new \InvalidArgumentException(sprintf('The FEATURE property can only contain items of type \StructType\FEATURE, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FEATURE[] = $item;
        return $this;
    }
}
