<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for followUps StructType
 * @subpackage Structs
 */
class FollowUps_1 extends AbstractStructBase
{
    /**
     * The followUp
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\FollowUp_1[]
     */
    public $followUp;
    /**
     * Constructor method for followUps
     * @uses FollowUps_1::setFollowUp()
     * @param \StructType\FollowUp_1[] $followUp
     */
    public function __construct(array $followUp = array())
    {
        $this
            ->setFollowUp($followUp);
    }
    /**
     * Get followUp value
     * @return \StructType\FollowUp_1[]|null
     */
    public function getFollowUp()
    {
        return $this->followUp;
    }
    /**
     * This method is responsible for validating the values passed to the setFollowUp method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFollowUp method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFollowUpForArrayConstraintsFromSetFollowUp(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $followUpsFollowUpItem) {
            // validation for constraint: itemType
            if (!$followUpsFollowUpItem instanceof \StructType\FollowUp_1) {
                $invalidValues[] = is_object($followUpsFollowUpItem) ? get_class($followUpsFollowUpItem) : sprintf('%s(%s)', gettype($followUpsFollowUpItem), var_export($followUpsFollowUpItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The followUp property can only contain items of type \StructType\FollowUp_1, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set followUp value
     * @throws \InvalidArgumentException
     * @param \StructType\FollowUp_1[] $followUp
     * @return \StructType\FollowUps_1
     */
    public function setFollowUp(array $followUp = array())
    {
        // validation for constraint: array
        if ('' !== ($followUpArrayErrorMessage = self::validateFollowUpForArrayConstraintsFromSetFollowUp($followUp))) {
            throw new \InvalidArgumentException($followUpArrayErrorMessage, __LINE__);
        }
        $this->followUp = $followUp;
        return $this;
    }
    /**
     * Add item to followUp value
     * @throws \InvalidArgumentException
     * @param \StructType\FollowUp_1 $item
     * @return \StructType\FollowUps_1
     */
    public function addToFollowUp(\StructType\FollowUp_1 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FollowUp_1) {
            throw new \InvalidArgumentException(sprintf('The followUp property can only contain items of type \StructType\FollowUp_1, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->followUp[] = $item;
        return $this;
    }
}
