<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GIFT_VOUCHER_SEARCH_V01Request StructType
 * @subpackage Structs
 */
class GIFT_VOUCHER_SEARCH_V01Request extends AbstractStructBase
{
    /**
     * The Authentication
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Authentication
     */
    public $Authentication;
    /**
     * The GiftvoucherSearch
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\GiftvoucherSearch
     */
    public $GiftvoucherSearch;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * Constructor method for GIFT_VOUCHER_SEARCH_V01Request
     * @uses GIFT_VOUCHER_SEARCH_V01Request::setAuthentication()
     * @uses GIFT_VOUCHER_SEARCH_V01Request::setGiftvoucherSearch()
     * @uses GIFT_VOUCHER_SEARCH_V01Request::setTransactionID()
     * @param \StructType\Authentication $authentication
     * @param \StructType\GiftvoucherSearch $giftvoucherSearch
     * @param string $transactionID
     */
    public function __construct(\StructType\Authentication $authentication = null, \StructType\GiftvoucherSearch $giftvoucherSearch = null, $transactionID = null)
    {
        $this
            ->setAuthentication($authentication)
            ->setGiftvoucherSearch($giftvoucherSearch)
            ->setTransactionID($transactionID);
    }
    /**
     * Get Authentication value
     * @return \StructType\Authentication
     */
    public function getAuthentication()
    {
        return $this->Authentication;
    }
    /**
     * Set Authentication value
     * @param \StructType\Authentication $authentication
     * @return \StructType\GIFT_VOUCHER_SEARCH_V01Request
     */
    public function setAuthentication(\StructType\Authentication $authentication = null)
    {
        $this->Authentication = $authentication;
        return $this;
    }
    /**
     * Get GiftvoucherSearch value
     * @return \StructType\GiftvoucherSearch
     */
    public function getGiftvoucherSearch()
    {
        return $this->GiftvoucherSearch;
    }
    /**
     * Set GiftvoucherSearch value
     * @param \StructType\GiftvoucherSearch $giftvoucherSearch
     * @return \StructType\GIFT_VOUCHER_SEARCH_V01Request
     */
    public function setGiftvoucherSearch(\StructType\GiftvoucherSearch $giftvoucherSearch = null)
    {
        $this->GiftvoucherSearch = $giftvoucherSearch;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\GIFT_VOUCHER_SEARCH_V01Request
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
}
