<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GIFT_VOUCHER_SELL_V01Response StructType
 * @subpackage Structs
 */
class GIFT_VOUCHER_SELL_V01Response extends AbstractStructBase
{
    /**
     * The Result
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Result
     */
    public $Result;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * The NewGiftvoucher
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\NewGiftvoucher[]
     */
    public $NewGiftvoucher;
    /**
     * Constructor method for GIFT_VOUCHER_SELL_V01Response
     * @uses GIFT_VOUCHER_SELL_V01Response::setResult()
     * @uses GIFT_VOUCHER_SELL_V01Response::setTransactionID()
     * @uses GIFT_VOUCHER_SELL_V01Response::setNewGiftvoucher()
     * @param \StructType\Result $result
     * @param string $transactionID
     * @param \StructType\NewGiftvoucher[] $newGiftvoucher
     */
    public function __construct(\StructType\Result $result = null, $transactionID = null, array $newGiftvoucher = array())
    {
        $this
            ->setResult($result)
            ->setTransactionID($transactionID)
            ->setNewGiftvoucher($newGiftvoucher);
    }
    /**
     * Get Result value
     * @return \StructType\Result
     */
    public function getResult()
    {
        return $this->Result;
    }
    /**
     * Set Result value
     * @param \StructType\Result $result
     * @return \StructType\GIFT_VOUCHER_SELL_V01Response
     */
    public function setResult(\StructType\Result $result = null)
    {
        $this->Result = $result;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\GIFT_VOUCHER_SELL_V01Response
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
    /**
     * Get NewGiftvoucher value
     * @return \StructType\NewGiftvoucher[]|null
     */
    public function getNewGiftvoucher()
    {
        return $this->NewGiftvoucher;
    }
    /**
     * This method is responsible for validating the values passed to the setNewGiftvoucher method
     * This method is willingly generated in order to preserve the one-line inline validation within the setNewGiftvoucher method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateNewGiftvoucherForArrayConstraintsFromSetNewGiftvoucher(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $gIFT_VOUCHER_SELL_V01ResponseNewGiftvoucherItem) {
            // validation for constraint: itemType
            if (!$gIFT_VOUCHER_SELL_V01ResponseNewGiftvoucherItem instanceof \StructType\NewGiftvoucher) {
                $invalidValues[] = is_object($gIFT_VOUCHER_SELL_V01ResponseNewGiftvoucherItem) ? get_class($gIFT_VOUCHER_SELL_V01ResponseNewGiftvoucherItem) : sprintf('%s(%s)', gettype($gIFT_VOUCHER_SELL_V01ResponseNewGiftvoucherItem), var_export($gIFT_VOUCHER_SELL_V01ResponseNewGiftvoucherItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The NewGiftvoucher property can only contain items of type \StructType\NewGiftvoucher, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set NewGiftvoucher value
     * @throws \InvalidArgumentException
     * @param \StructType\NewGiftvoucher[] $newGiftvoucher
     * @return \StructType\GIFT_VOUCHER_SELL_V01Response
     */
    public function setNewGiftvoucher(array $newGiftvoucher = array())
    {
        // validation for constraint: array
        if ('' !== ($newGiftvoucherArrayErrorMessage = self::validateNewGiftvoucherForArrayConstraintsFromSetNewGiftvoucher($newGiftvoucher))) {
            throw new \InvalidArgumentException($newGiftvoucherArrayErrorMessage, __LINE__);
        }
        $this->NewGiftvoucher = $newGiftvoucher;
        return $this;
    }
    /**
     * Add item to NewGiftvoucher value
     * @throws \InvalidArgumentException
     * @param \StructType\NewGiftvoucher $item
     * @return \StructType\GIFT_VOUCHER_SELL_V01Response
     */
    public function addToNewGiftvoucher(\StructType\NewGiftvoucher $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\NewGiftvoucher) {
            throw new \InvalidArgumentException(sprintf('The NewGiftvoucher property can only contain items of type \StructType\NewGiftvoucher, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->NewGiftvoucher[] = $item;
        return $this;
    }
}
