<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GUEST-IDS StructType
 * @subpackage Structs
 */
class GUEST_IDS extends AbstractStructBase
{
    /**
     * The CARD
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CARD[]
     */
    public $CARD;
    /**
     * The GUEST_ID
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\GUEST_ID[]
     */
    public $GUEST_ID;
    /**
     * Constructor method for GUEST-IDS
     * @uses GUEST_IDS::setCARD()
     * @uses GUEST_IDS::setGUEST_ID()
     * @param \StructType\CARD[] $cARD
     * @param \StructType\GUEST_ID[] $gUEST_ID
     */
    public function __construct(array $cARD = array(), array $gUEST_ID = array())
    {
        $this
            ->setCARD($cARD)
            ->setGUEST_ID($gUEST_ID);
    }
    /**
     * Get CARD value
     * @return \StructType\CARD[]|null
     */
    public function getCARD()
    {
        return $this->CARD;
    }
    /**
     * This method is responsible for validating the values passed to the setCARD method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCARD method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCARDForArrayConstraintsFromSetCARD(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $gUEST_IDSCARDItem) {
            // validation for constraint: itemType
            if (!$gUEST_IDSCARDItem instanceof \StructType\CARD) {
                $invalidValues[] = is_object($gUEST_IDSCARDItem) ? get_class($gUEST_IDSCARDItem) : sprintf('%s(%s)', gettype($gUEST_IDSCARDItem), var_export($gUEST_IDSCARDItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CARD property can only contain items of type \StructType\CARD, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CARD value
     * @throws \InvalidArgumentException
     * @param \StructType\CARD[] $cARD
     * @return \StructType\GUEST_IDS
     */
    public function setCARD(array $cARD = array())
    {
        // validation for constraint: array
        if ('' !== ($cARDArrayErrorMessage = self::validateCARDForArrayConstraintsFromSetCARD($cARD))) {
            throw new \InvalidArgumentException($cARDArrayErrorMessage, __LINE__);
        }
        $this->CARD = $cARD;
        return $this;
    }
    /**
     * Add item to CARD value
     * @throws \InvalidArgumentException
     * @param \StructType\CARD $item
     * @return \StructType\GUEST_IDS
     */
    public function addToCARD(\StructType\CARD $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CARD) {
            throw new \InvalidArgumentException(sprintf('The CARD property can only contain items of type \StructType\CARD, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CARD[] = $item;
        return $this;
    }
    /**
     * Get GUEST_ID value
     * @return \StructType\GUEST_ID[]|null
     */
    public function getGUEST_ID()
    {
        return $this->{'GUEST-ID'};
    }
    /**
     * This method is responsible for validating the values passed to the setGUEST_ID method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGUEST_ID method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGUEST_IDForArrayConstraintsFromSetGUEST_ID(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $gUEST_IDSGUEST_IDItem) {
            // validation for constraint: itemType
            if (!$gUEST_IDSGUEST_IDItem instanceof \StructType\GUEST_ID) {
                $invalidValues[] = is_object($gUEST_IDSGUEST_IDItem) ? get_class($gUEST_IDSGUEST_IDItem) : sprintf('%s(%s)', gettype($gUEST_IDSGUEST_IDItem), var_export($gUEST_IDSGUEST_IDItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The GUEST_ID property can only contain items of type \StructType\GUEST_ID, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GUEST_ID value
     * @throws \InvalidArgumentException
     * @param \StructType\GUEST_ID[] $gUEST_ID
     * @return \StructType\GUEST_IDS
     */
    public function setGUEST_ID(array $gUEST_ID = array())
    {
        // validation for constraint: array
        if ('' !== ($gUEST_IDArrayErrorMessage = self::validateGUEST_IDForArrayConstraintsFromSetGUEST_ID($gUEST_ID))) {
            throw new \InvalidArgumentException($gUEST_IDArrayErrorMessage, __LINE__);
        }
        $this->GUEST_ID = $this->{'GUEST-ID'} = $gUEST_ID;
        return $this;
    }
    /**
     * Add item to GUEST_ID value
     * @throws \InvalidArgumentException
     * @param \StructType\GUEST_ID $item
     * @return \StructType\GUEST_IDS
     */
    public function addToGUEST_ID(\StructType\GUEST_ID $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GUEST_ID) {
            throw new \InvalidArgumentException(sprintf('The GUEST_ID property can only contain items of type \StructType\GUEST_ID, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->GUEST_ID[] = $this->{'GUEST-ID'}[] = $item;
        return $this;
    }
}
