<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetPackageMappingRequest StructType
 * @subpackage Structs
 */
class GetPackageMappingRequest extends AbstractStructBase
{
    /**
     * The Authentication
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Authentication
     */
    public $Authentication;
    /**
     * The PackageSearch
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\PackageSearch
     */
    public $PackageSearch;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * Constructor method for GetPackageMappingRequest
     * @uses GetPackageMappingRequest::setAuthentication()
     * @uses GetPackageMappingRequest::setPackageSearch()
     * @uses GetPackageMappingRequest::setTransactionID()
     * @param \StructType\Authentication $authentication
     * @param \StructType\PackageSearch $packageSearch
     * @param string $transactionID
     */
    public function __construct(\StructType\Authentication $authentication = null, \StructType\PackageSearch $packageSearch = null, $transactionID = null)
    {
        $this
            ->setAuthentication($authentication)
            ->setPackageSearch($packageSearch)
            ->setTransactionID($transactionID);
    }
    /**
     * Get Authentication value
     * @return \StructType\Authentication
     */
    public function getAuthentication()
    {
        return $this->Authentication;
    }
    /**
     * Set Authentication value
     * @param \StructType\Authentication $authentication
     * @return \StructType\GetPackageMappingRequest
     */
    public function setAuthentication(\StructType\Authentication $authentication = null)
    {
        $this->Authentication = $authentication;
        return $this;
    }
    /**
     * Get PackageSearch value
     * @return \StructType\PackageSearch
     */
    public function getPackageSearch()
    {
        return $this->PackageSearch;
    }
    /**
     * Set PackageSearch value
     * @param \StructType\PackageSearch $packageSearch
     * @return \StructType\GetPackageMappingRequest
     */
    public function setPackageSearch(\StructType\PackageSearch $packageSearch = null)
    {
        $this->PackageSearch = $packageSearch;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\GetPackageMappingRequest
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
}
