<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LOYALTY-CARDS StructType
 * @subpackage Structs
 */
class LOYALTY_CARDS extends AbstractStructBase
{
    /**
     * The CARD
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CARD[]
     */
    public $CARD;
    /**
     * The LOYALTY_CARD
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\LOYALTY_CARD[]
     */
    public $LOYALTY_CARD;
    /**
     * Constructor method for LOYALTY-CARDS
     * @uses LOYALTY_CARDS::setCARD()
     * @uses LOYALTY_CARDS::setLOYALTY_CARD()
     * @param \StructType\CARD[] $cARD
     * @param \StructType\LOYALTY_CARD[] $lOYALTY_CARD
     */
    public function __construct(array $cARD = array(), array $lOYALTY_CARD = array())
    {
        $this
            ->setCARD($cARD)
            ->setLOYALTY_CARD($lOYALTY_CARD);
    }
    /**
     * Get CARD value
     * @return \StructType\CARD[]|null
     */
    public function getCARD()
    {
        return $this->CARD;
    }
    /**
     * This method is responsible for validating the values passed to the setCARD method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCARD method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCARDForArrayConstraintsFromSetCARD(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $lOYALTY_CARDSCARDItem) {
            // validation for constraint: itemType
            if (!$lOYALTY_CARDSCARDItem instanceof \StructType\CARD) {
                $invalidValues[] = is_object($lOYALTY_CARDSCARDItem) ? get_class($lOYALTY_CARDSCARDItem) : sprintf('%s(%s)', gettype($lOYALTY_CARDSCARDItem), var_export($lOYALTY_CARDSCARDItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CARD property can only contain items of type \StructType\CARD, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CARD value
     * @throws \InvalidArgumentException
     * @param \StructType\CARD[] $cARD
     * @return \StructType\LOYALTY_CARDS
     */
    public function setCARD(array $cARD = array())
    {
        // validation for constraint: array
        if ('' !== ($cARDArrayErrorMessage = self::validateCARDForArrayConstraintsFromSetCARD($cARD))) {
            throw new \InvalidArgumentException($cARDArrayErrorMessage, __LINE__);
        }
        $this->CARD = $cARD;
        return $this;
    }
    /**
     * Add item to CARD value
     * @throws \InvalidArgumentException
     * @param \StructType\CARD $item
     * @return \StructType\LOYALTY_CARDS
     */
    public function addToCARD(\StructType\CARD $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CARD) {
            throw new \InvalidArgumentException(sprintf('The CARD property can only contain items of type \StructType\CARD, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CARD[] = $item;
        return $this;
    }
    /**
     * Get LOYALTY_CARD value
     * @return \StructType\LOYALTY_CARD[]|null
     */
    public function getLOYALTY_CARD()
    {
        return $this->{'LOYALTY-CARD'};
    }
    /**
     * This method is responsible for validating the values passed to the setLOYALTY_CARD method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLOYALTY_CARD method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLOYALTY_CARDForArrayConstraintsFromSetLOYALTY_CARD(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $lOYALTY_CARDSLOYALTY_CARDItem) {
            // validation for constraint: itemType
            if (!$lOYALTY_CARDSLOYALTY_CARDItem instanceof \StructType\LOYALTY_CARD) {
                $invalidValues[] = is_object($lOYALTY_CARDSLOYALTY_CARDItem) ? get_class($lOYALTY_CARDSLOYALTY_CARDItem) : sprintf('%s(%s)', gettype($lOYALTY_CARDSLOYALTY_CARDItem), var_export($lOYALTY_CARDSLOYALTY_CARDItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The LOYALTY_CARD property can only contain items of type \StructType\LOYALTY_CARD, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set LOYALTY_CARD value
     * @throws \InvalidArgumentException
     * @param \StructType\LOYALTY_CARD[] $lOYALTY_CARD
     * @return \StructType\LOYALTY_CARDS
     */
    public function setLOYALTY_CARD(array $lOYALTY_CARD = array())
    {
        // validation for constraint: array
        if ('' !== ($lOYALTY_CARDArrayErrorMessage = self::validateLOYALTY_CARDForArrayConstraintsFromSetLOYALTY_CARD($lOYALTY_CARD))) {
            throw new \InvalidArgumentException($lOYALTY_CARDArrayErrorMessage, __LINE__);
        }
        $this->LOYALTY_CARD = $this->{'LOYALTY-CARD'} = $lOYALTY_CARD;
        return $this;
    }
    /**
     * Add item to LOYALTY_CARD value
     * @throws \InvalidArgumentException
     * @param \StructType\LOYALTY_CARD $item
     * @return \StructType\LOYALTY_CARDS
     */
    public function addToLOYALTY_CARD(\StructType\LOYALTY_CARD $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LOYALTY_CARD) {
            throw new \InvalidArgumentException(sprintf('The LOYALTY_CARD property can only contain items of type \StructType\LOYALTY_CARD, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->LOYALTY_CARD[] = $this->{'LOYALTY-CARD'}[] = $item;
        return $this;
    }
}
