<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MSG-ENTRY-PARAM-LIST StructType
 * @subpackage Structs
 */
class MSG_ENTRY_PARAM_LIST extends AbstractStructBase
{
    /**
     * The PARAM
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\MSG_PARAM[]
     */
    public $PARAM;
    /**
     * Constructor method for MSG-ENTRY-PARAM-LIST
     * @uses MSG_ENTRY_PARAM_LIST::setPARAM()
     * @param \StructType\MSG_PARAM[] $pARAM
     */
    public function __construct(array $pARAM = array())
    {
        $this
            ->setPARAM($pARAM);
    }
    /**
     * Get PARAM value
     * @return \StructType\MSG_PARAM[]|null
     */
    public function getPARAM()
    {
        return $this->PARAM;
    }
    /**
     * This method is responsible for validating the values passed to the setPARAM method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPARAM method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePARAMForArrayConstraintsFromSetPARAM(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $mSG_ENTRY_PARAM_LISTPARAMItem) {
            // validation for constraint: itemType
            if (!$mSG_ENTRY_PARAM_LISTPARAMItem instanceof \StructType\MSG_PARAM) {
                $invalidValues[] = is_object($mSG_ENTRY_PARAM_LISTPARAMItem) ? get_class($mSG_ENTRY_PARAM_LISTPARAMItem) : sprintf('%s(%s)', gettype($mSG_ENTRY_PARAM_LISTPARAMItem), var_export($mSG_ENTRY_PARAM_LISTPARAMItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PARAM property can only contain items of type \StructType\MSG_PARAM, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PARAM value
     * @throws \InvalidArgumentException
     * @param \StructType\MSG_PARAM[] $pARAM
     * @return \StructType\MSG_ENTRY_PARAM_LIST
     */
    public function setPARAM(array $pARAM = array())
    {
        // validation for constraint: array
        if ('' !== ($pARAMArrayErrorMessage = self::validatePARAMForArrayConstraintsFromSetPARAM($pARAM))) {
            throw new \InvalidArgumentException($pARAMArrayErrorMessage, __LINE__);
        }
        $this->PARAM = $pARAM;
        return $this;
    }
    /**
     * Add item to PARAM value
     * @throws \InvalidArgumentException
     * @param \StructType\MSG_PARAM $item
     * @return \StructType\MSG_ENTRY_PARAM_LIST
     */
    public function addToPARAM(\StructType\MSG_PARAM $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MSG_PARAM) {
            throw new \InvalidArgumentException(sprintf('The PARAM property can only contain items of type \StructType\MSG_PARAM, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PARAM[] = $item;
        return $this;
    }
}
