<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MSG-LIST StructType
 * @subpackage Structs
 */
class MSG_LIST extends AbstractStructBase
{
    /**
     * The MSG_ENTRY
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\MSG_ENTRY[]
     */
    public $MSG_ENTRY;
    /**
     * Constructor method for MSG-LIST
     * @uses MSG_LIST::setMSG_ENTRY()
     * @param \StructType\MSG_ENTRY[] $mSG_ENTRY
     */
    public function __construct(array $mSG_ENTRY = array())
    {
        $this
            ->setMSG_ENTRY($mSG_ENTRY);
    }
    /**
     * Get MSG_ENTRY value
     * @return \StructType\MSG_ENTRY[]|null
     */
    public function getMSG_ENTRY()
    {
        return $this->{'MSG-ENTRY'};
    }
    /**
     * This method is responsible for validating the values passed to the setMSG_ENTRY method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMSG_ENTRY method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMSG_ENTRYForArrayConstraintsFromSetMSG_ENTRY(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $mSG_LISTMSG_ENTRYItem) {
            // validation for constraint: itemType
            if (!$mSG_LISTMSG_ENTRYItem instanceof \StructType\MSG_ENTRY) {
                $invalidValues[] = is_object($mSG_LISTMSG_ENTRYItem) ? get_class($mSG_LISTMSG_ENTRYItem) : sprintf('%s(%s)', gettype($mSG_LISTMSG_ENTRYItem), var_export($mSG_LISTMSG_ENTRYItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The MSG_ENTRY property can only contain items of type \StructType\MSG_ENTRY, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set MSG_ENTRY value
     * @throws \InvalidArgumentException
     * @param \StructType\MSG_ENTRY[] $mSG_ENTRY
     * @return \StructType\MSG_LIST
     */
    public function setMSG_ENTRY(array $mSG_ENTRY = array())
    {
        // validation for constraint: array
        if ('' !== ($mSG_ENTRYArrayErrorMessage = self::validateMSG_ENTRYForArrayConstraintsFromSetMSG_ENTRY($mSG_ENTRY))) {
            throw new \InvalidArgumentException($mSG_ENTRYArrayErrorMessage, __LINE__);
        }
        $this->MSG_ENTRY = $this->{'MSG-ENTRY'} = $mSG_ENTRY;
        return $this;
    }
    /**
     * Add item to MSG_ENTRY value
     * @throws \InvalidArgumentException
     * @param \StructType\MSG_ENTRY $item
     * @return \StructType\MSG_LIST
     */
    public function addToMSG_ENTRY(\StructType\MSG_ENTRY $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MSG_ENTRY) {
            throw new \InvalidArgumentException(sprintf('The MSG_ENTRY property can only contain items of type \StructType\MSG_ENTRY, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->MSG_ENTRY[] = $this->{'MSG-ENTRY'}[] = $item;
        return $this;
    }
}
