<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ModuleRes StructType
 * @subpackage Structs
 */
class ModuleRes extends AbstractStructBase
{
    /**
     * The ModuleServiceRes
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ModuleServiceRes[]
     */
    public $ModuleServiceRes;
    /**
     * The ModuleRoomRes
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ModuleRoomRes[]
     */
    public $ModuleRoomRes;
    /**
     * Constructor method for ModuleRes
     * @uses ModuleRes::setModuleServiceRes()
     * @uses ModuleRes::setModuleRoomRes()
     * @param \StructType\ModuleServiceRes[] $moduleServiceRes
     * @param \StructType\ModuleRoomRes[] $moduleRoomRes
     */
    public function __construct(array $moduleServiceRes = array(), array $moduleRoomRes = array())
    {
        $this
            ->setModuleServiceRes($moduleServiceRes)
            ->setModuleRoomRes($moduleRoomRes);
    }
    /**
     * Get ModuleServiceRes value
     * @return \StructType\ModuleServiceRes[]|null
     */
    public function getModuleServiceRes()
    {
        return $this->ModuleServiceRes;
    }
    /**
     * This method is responsible for validating the values passed to the setModuleServiceRes method
     * This method is willingly generated in order to preserve the one-line inline validation within the setModuleServiceRes method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateModuleServiceResForArrayConstraintsFromSetModuleServiceRes(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $moduleResModuleServiceResItem) {
            // validation for constraint: itemType
            if (!$moduleResModuleServiceResItem instanceof \StructType\ModuleServiceRes) {
                $invalidValues[] = is_object($moduleResModuleServiceResItem) ? get_class($moduleResModuleServiceResItem) : sprintf('%s(%s)', gettype($moduleResModuleServiceResItem), var_export($moduleResModuleServiceResItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ModuleServiceRes property can only contain items of type \StructType\ModuleServiceRes, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ModuleServiceRes value
     * @throws \InvalidArgumentException
     * @param \StructType\ModuleServiceRes[] $moduleServiceRes
     * @return \StructType\ModuleRes
     */
    public function setModuleServiceRes(array $moduleServiceRes = array())
    {
        // validation for constraint: array
        if ('' !== ($moduleServiceResArrayErrorMessage = self::validateModuleServiceResForArrayConstraintsFromSetModuleServiceRes($moduleServiceRes))) {
            throw new \InvalidArgumentException($moduleServiceResArrayErrorMessage, __LINE__);
        }
        $this->ModuleServiceRes = $moduleServiceRes;
        return $this;
    }
    /**
     * Add item to ModuleServiceRes value
     * @throws \InvalidArgumentException
     * @param \StructType\ModuleServiceRes $item
     * @return \StructType\ModuleRes
     */
    public function addToModuleServiceRes(\StructType\ModuleServiceRes $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ModuleServiceRes) {
            throw new \InvalidArgumentException(sprintf('The ModuleServiceRes property can only contain items of type \StructType\ModuleServiceRes, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ModuleServiceRes[] = $item;
        return $this;
    }
    /**
     * Get ModuleRoomRes value
     * @return \StructType\ModuleRoomRes[]|null
     */
    public function getModuleRoomRes()
    {
        return $this->ModuleRoomRes;
    }
    /**
     * This method is responsible for validating the values passed to the setModuleRoomRes method
     * This method is willingly generated in order to preserve the one-line inline validation within the setModuleRoomRes method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateModuleRoomResForArrayConstraintsFromSetModuleRoomRes(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $moduleResModuleRoomResItem) {
            // validation for constraint: itemType
            if (!$moduleResModuleRoomResItem instanceof \StructType\ModuleRoomRes) {
                $invalidValues[] = is_object($moduleResModuleRoomResItem) ? get_class($moduleResModuleRoomResItem) : sprintf('%s(%s)', gettype($moduleResModuleRoomResItem), var_export($moduleResModuleRoomResItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ModuleRoomRes property can only contain items of type \StructType\ModuleRoomRes, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ModuleRoomRes value
     * @throws \InvalidArgumentException
     * @param \StructType\ModuleRoomRes[] $moduleRoomRes
     * @return \StructType\ModuleRes
     */
    public function setModuleRoomRes(array $moduleRoomRes = array())
    {
        // validation for constraint: array
        if ('' !== ($moduleRoomResArrayErrorMessage = self::validateModuleRoomResForArrayConstraintsFromSetModuleRoomRes($moduleRoomRes))) {
            throw new \InvalidArgumentException($moduleRoomResArrayErrorMessage, __LINE__);
        }
        $this->ModuleRoomRes = $moduleRoomRes;
        return $this;
    }
    /**
     * Add item to ModuleRoomRes value
     * @throws \InvalidArgumentException
     * @param \StructType\ModuleRoomRes $item
     * @return \StructType\ModuleRes
     */
    public function addToModuleRoomRes(\StructType\ModuleRoomRes $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ModuleRoomRes) {
            throw new \InvalidArgumentException(sprintf('The ModuleRoomRes property can only contain items of type \StructType\ModuleRoomRes, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ModuleRoomRes[] = $item;
        return $this;
    }
}
