<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ModuleReservations StructType
 * @subpackage Structs
 */
class ModuleReservations extends AbstractStructBase
{
    /**
     * The ModuleReservation
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ModuleReservation[]
     */
    public $ModuleReservation;
    /**
     * Constructor method for ModuleReservations
     * @uses ModuleReservations::setModuleReservation()
     * @param \StructType\ModuleReservation[] $moduleReservation
     */
    public function __construct(array $moduleReservation = array())
    {
        $this
            ->setModuleReservation($moduleReservation);
    }
    /**
     * Get ModuleReservation value
     * @return \StructType\ModuleReservation[]|null
     */
    public function getModuleReservation()
    {
        return $this->ModuleReservation;
    }
    /**
     * This method is responsible for validating the values passed to the setModuleReservation method
     * This method is willingly generated in order to preserve the one-line inline validation within the setModuleReservation method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateModuleReservationForArrayConstraintsFromSetModuleReservation(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $moduleReservationsModuleReservationItem) {
            // validation for constraint: itemType
            if (!$moduleReservationsModuleReservationItem instanceof \StructType\ModuleReservation) {
                $invalidValues[] = is_object($moduleReservationsModuleReservationItem) ? get_class($moduleReservationsModuleReservationItem) : sprintf('%s(%s)', gettype($moduleReservationsModuleReservationItem), var_export($moduleReservationsModuleReservationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ModuleReservation property can only contain items of type \StructType\ModuleReservation, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ModuleReservation value
     * @throws \InvalidArgumentException
     * @param \StructType\ModuleReservation[] $moduleReservation
     * @return \StructType\ModuleReservations
     */
    public function setModuleReservation(array $moduleReservation = array())
    {
        // validation for constraint: array
        if ('' !== ($moduleReservationArrayErrorMessage = self::validateModuleReservationForArrayConstraintsFromSetModuleReservation($moduleReservation))) {
            throw new \InvalidArgumentException($moduleReservationArrayErrorMessage, __LINE__);
        }
        $this->ModuleReservation = $moduleReservation;
        return $this;
    }
    /**
     * Add item to ModuleReservation value
     * @throws \InvalidArgumentException
     * @param \StructType\ModuleReservation $item
     * @return \StructType\ModuleReservations
     */
    public function addToModuleReservation(\StructType\ModuleReservation $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ModuleReservation) {
            throw new \InvalidArgumentException(sprintf('The ModuleReservation property can only contain items of type \StructType\ModuleReservation, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ModuleReservation[] = $item;
        return $this;
    }
}
