<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MultiLangComments StructType
 * @subpackage Structs
 */
class MultiLangComments extends AbstractStructBase
{
    /**
     * The MultiLangComment
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\MultiLangComment[]
     */
    public $MultiLangComment;
    /**
     * Constructor method for MultiLangComments
     * @uses MultiLangComments::setMultiLangComment()
     * @param \StructType\MultiLangComment[] $multiLangComment
     */
    public function __construct(array $multiLangComment = array())
    {
        $this
            ->setMultiLangComment($multiLangComment);
    }
    /**
     * Get MultiLangComment value
     * @return \StructType\MultiLangComment[]|null
     */
    public function getMultiLangComment()
    {
        return $this->MultiLangComment;
    }
    /**
     * This method is responsible for validating the values passed to the setMultiLangComment method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMultiLangComment method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMultiLangCommentForArrayConstraintsFromSetMultiLangComment(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $multiLangCommentsMultiLangCommentItem) {
            // validation for constraint: itemType
            if (!$multiLangCommentsMultiLangCommentItem instanceof \StructType\MultiLangComment) {
                $invalidValues[] = is_object($multiLangCommentsMultiLangCommentItem) ? get_class($multiLangCommentsMultiLangCommentItem) : sprintf('%s(%s)', gettype($multiLangCommentsMultiLangCommentItem), var_export($multiLangCommentsMultiLangCommentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The MultiLangComment property can only contain items of type \StructType\MultiLangComment, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set MultiLangComment value
     * @throws \InvalidArgumentException
     * @param \StructType\MultiLangComment[] $multiLangComment
     * @return \StructType\MultiLangComments
     */
    public function setMultiLangComment(array $multiLangComment = array())
    {
        // validation for constraint: array
        if ('' !== ($multiLangCommentArrayErrorMessage = self::validateMultiLangCommentForArrayConstraintsFromSetMultiLangComment($multiLangComment))) {
            throw new \InvalidArgumentException($multiLangCommentArrayErrorMessage, __LINE__);
        }
        $this->MultiLangComment = $multiLangComment;
        return $this;
    }
    /**
     * Add item to MultiLangComment value
     * @throws \InvalidArgumentException
     * @param \StructType\MultiLangComment $item
     * @return \StructType\MultiLangComments
     */
    public function addToMultiLangComment(\StructType\MultiLangComment $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MultiLangComment) {
            throw new \InvalidArgumentException(sprintf('The MultiLangComment property can only contain items of type \StructType\MultiLangComment, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->MultiLangComment[] = $item;
        return $this;
    }
}
