<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MultiLangDescriptions StructType
 * @subpackage Structs
 */
class MultiLangDescriptions extends AbstractStructBase
{
    /**
     * The MultiLangDescription
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\MultiLangDescription[]
     */
    public $MultiLangDescription;
    /**
     * Constructor method for MultiLangDescriptions
     * @uses MultiLangDescriptions::setMultiLangDescription()
     * @param \StructType\MultiLangDescription[] $multiLangDescription
     */
    public function __construct(array $multiLangDescription = array())
    {
        $this
            ->setMultiLangDescription($multiLangDescription);
    }
    /**
     * Get MultiLangDescription value
     * @return \StructType\MultiLangDescription[]|null
     */
    public function getMultiLangDescription()
    {
        return $this->MultiLangDescription;
    }
    /**
     * This method is responsible for validating the values passed to the setMultiLangDescription method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMultiLangDescription method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMultiLangDescriptionForArrayConstraintsFromSetMultiLangDescription(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $multiLangDescriptionsMultiLangDescriptionItem) {
            // validation for constraint: itemType
            if (!$multiLangDescriptionsMultiLangDescriptionItem instanceof \StructType\MultiLangDescription) {
                $invalidValues[] = is_object($multiLangDescriptionsMultiLangDescriptionItem) ? get_class($multiLangDescriptionsMultiLangDescriptionItem) : sprintf('%s(%s)', gettype($multiLangDescriptionsMultiLangDescriptionItem), var_export($multiLangDescriptionsMultiLangDescriptionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The MultiLangDescription property can only contain items of type \StructType\MultiLangDescription, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set MultiLangDescription value
     * @throws \InvalidArgumentException
     * @param \StructType\MultiLangDescription[] $multiLangDescription
     * @return \StructType\MultiLangDescriptions
     */
    public function setMultiLangDescription(array $multiLangDescription = array())
    {
        // validation for constraint: array
        if ('' !== ($multiLangDescriptionArrayErrorMessage = self::validateMultiLangDescriptionForArrayConstraintsFromSetMultiLangDescription($multiLangDescription))) {
            throw new \InvalidArgumentException($multiLangDescriptionArrayErrorMessage, __LINE__);
        }
        $this->MultiLangDescription = $multiLangDescription;
        return $this;
    }
    /**
     * Add item to MultiLangDescription value
     * @throws \InvalidArgumentException
     * @param \StructType\MultiLangDescription $item
     * @return \StructType\MultiLangDescriptions
     */
    public function addToMultiLangDescription(\StructType\MultiLangDescription $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MultiLangDescription) {
            throw new \InvalidArgumentException(sprintf('The MultiLangDescription property can only contain items of type \StructType\MultiLangDescription, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->MultiLangDescription[] = $item;
        return $this;
    }
}
