<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MultiLanguageDescription StructType
 * @subpackage Structs
 */
class MultiLanguageDescription extends AbstractStructBase
{
    /**
     * The LanguageDescription
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\LanguageDescription[]
     */
    public $LanguageDescription;
    /**
     * Constructor method for MultiLanguageDescription
     * @uses MultiLanguageDescription::setLanguageDescription()
     * @param \StructType\LanguageDescription[] $languageDescription
     */
    public function __construct(array $languageDescription = array())
    {
        $this
            ->setLanguageDescription($languageDescription);
    }
    /**
     * Get LanguageDescription value
     * @return \StructType\LanguageDescription[]|null
     */
    public function getLanguageDescription()
    {
        return $this->LanguageDescription;
    }
    /**
     * This method is responsible for validating the values passed to the setLanguageDescription method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLanguageDescription method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLanguageDescriptionForArrayConstraintsFromSetLanguageDescription(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $multiLanguageDescriptionLanguageDescriptionItem) {
            // validation for constraint: itemType
            if (!$multiLanguageDescriptionLanguageDescriptionItem instanceof \StructType\LanguageDescription) {
                $invalidValues[] = is_object($multiLanguageDescriptionLanguageDescriptionItem) ? get_class($multiLanguageDescriptionLanguageDescriptionItem) : sprintf('%s(%s)', gettype($multiLanguageDescriptionLanguageDescriptionItem), var_export($multiLanguageDescriptionLanguageDescriptionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The LanguageDescription property can only contain items of type \StructType\LanguageDescription, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set LanguageDescription value
     * @throws \InvalidArgumentException
     * @param \StructType\LanguageDescription[] $languageDescription
     * @return \StructType\MultiLanguageDescription
     */
    public function setLanguageDescription(array $languageDescription = array())
    {
        // validation for constraint: array
        if ('' !== ($languageDescriptionArrayErrorMessage = self::validateLanguageDescriptionForArrayConstraintsFromSetLanguageDescription($languageDescription))) {
            throw new \InvalidArgumentException($languageDescriptionArrayErrorMessage, __LINE__);
        }
        $this->LanguageDescription = $languageDescription;
        return $this;
    }
    /**
     * Add item to LanguageDescription value
     * @throws \InvalidArgumentException
     * @param \StructType\LanguageDescription $item
     * @return \StructType\MultiLanguageDescription
     */
    public function addToLanguageDescription(\StructType\LanguageDescription $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LanguageDescription) {
            throw new \InvalidArgumentException(sprintf('The LanguageDescription property can only contain items of type \StructType\LanguageDescription, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->LanguageDescription[] = $item;
        return $this;
    }
}
