<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PAYMENTS StructType
 * @subpackage Structs
 */
class PAYMENTS_1 extends AbstractStructBase
{
    /**
     * The PAYMENT
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\PAYMENT_1[]
     */
    public $PAYMENT;
    /**
     * Constructor method for PAYMENTS
     * @uses PAYMENTS_1::setPAYMENT()
     * @param \StructType\PAYMENT_1[] $pAYMENT
     */
    public function __construct(array $pAYMENT = array())
    {
        $this
            ->setPAYMENT($pAYMENT);
    }
    /**
     * Get PAYMENT value
     * @return \StructType\PAYMENT_1[]|null
     */
    public function getPAYMENT()
    {
        return $this->PAYMENT;
    }
    /**
     * This method is responsible for validating the values passed to the setPAYMENT method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPAYMENT method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePAYMENTForArrayConstraintsFromSetPAYMENT(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $pAYMENTSPAYMENTItem) {
            // validation for constraint: itemType
            if (!$pAYMENTSPAYMENTItem instanceof \StructType\PAYMENT_1) {
                $invalidValues[] = is_object($pAYMENTSPAYMENTItem) ? get_class($pAYMENTSPAYMENTItem) : sprintf('%s(%s)', gettype($pAYMENTSPAYMENTItem), var_export($pAYMENTSPAYMENTItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PAYMENT property can only contain items of type \StructType\PAYMENT_1, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PAYMENT value
     * @throws \InvalidArgumentException
     * @param \StructType\PAYMENT_1[] $pAYMENT
     * @return \StructType\PAYMENTS_1
     */
    public function setPAYMENT(array $pAYMENT = array())
    {
        // validation for constraint: array
        if ('' !== ($pAYMENTArrayErrorMessage = self::validatePAYMENTForArrayConstraintsFromSetPAYMENT($pAYMENT))) {
            throw new \InvalidArgumentException($pAYMENTArrayErrorMessage, __LINE__);
        }
        $this->PAYMENT = $pAYMENT;
        return $this;
    }
    /**
     * Add item to PAYMENT value
     * @throws \InvalidArgumentException
     * @param \StructType\PAYMENT_1 $item
     * @return \StructType\PAYMENTS_1
     */
    public function addToPAYMENT(\StructType\PAYMENT_1 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PAYMENT_1) {
            throw new \InvalidArgumentException(sprintf('The PAYMENT property can only contain items of type \StructType\PAYMENT_1, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PAYMENT[] = $item;
        return $this;
    }
}
