<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PAYMENT-INSTRUCTIONS StructType
 * @subpackage Structs
 */
class PAYMENT_INSTRUCTIONS extends AbstractStructBase
{
    /**
     * The GUEST_ACCOUNT
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\GUEST_ACCOUNT
     */
    public $GUEST_ACCOUNT;
    /**
     * The CLIENT_ACCOUNT
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\CLIENT_ACCOUNT
     */
    public $CLIENT_ACCOUNT;
    /**
     * The GROUP_ACCOUNT
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\GROUP_ACCOUNT
     */
    public $GROUP_ACCOUNT;
    /**
     * The GUEST
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\GUEST[]
     */
    public $GUEST;
    /**
     * The ORDERER
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ORDERER[]
     */
    public $ORDERER;
    /**
     * The GROUP
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\GROUP[]
     */
    public $GROUP;
    /**
     * Constructor method for PAYMENT-INSTRUCTIONS
     * @uses PAYMENT_INSTRUCTIONS::setGUEST_ACCOUNT()
     * @uses PAYMENT_INSTRUCTIONS::setCLIENT_ACCOUNT()
     * @uses PAYMENT_INSTRUCTIONS::setGROUP_ACCOUNT()
     * @uses PAYMENT_INSTRUCTIONS::setGUEST()
     * @uses PAYMENT_INSTRUCTIONS::setORDERER()
     * @uses PAYMENT_INSTRUCTIONS::setGROUP()
     * @param \StructType\GUEST_ACCOUNT $gUEST_ACCOUNT
     * @param \StructType\CLIENT_ACCOUNT $cLIENT_ACCOUNT
     * @param \StructType\GROUP_ACCOUNT $gROUP_ACCOUNT
     * @param \StructType\GUEST[] $gUEST
     * @param \StructType\ORDERER[] $oRDERER
     * @param \StructType\GROUP[] $gROUP
     */
    public function __construct(\StructType\GUEST_ACCOUNT $gUEST_ACCOUNT = null, \StructType\CLIENT_ACCOUNT $cLIENT_ACCOUNT = null, \StructType\GROUP_ACCOUNT $gROUP_ACCOUNT = null, array $gUEST = array(), array $oRDERER = array(), array $gROUP = array())
    {
        $this
            ->setGUEST_ACCOUNT($gUEST_ACCOUNT)
            ->setCLIENT_ACCOUNT($cLIENT_ACCOUNT)
            ->setGROUP_ACCOUNT($gROUP_ACCOUNT)
            ->setGUEST($gUEST)
            ->setORDERER($oRDERER)
            ->setGROUP($gROUP);
    }
    /**
     * Get GUEST_ACCOUNT value
     * @return \StructType\GUEST_ACCOUNT|null
     */
    public function getGUEST_ACCOUNT()
    {
        return $this->{'GUEST-ACCOUNT'};
    }
    /**
     * Set GUEST_ACCOUNT value
     * @param \StructType\GUEST_ACCOUNT $gUEST_ACCOUNT
     * @return \StructType\PAYMENT_INSTRUCTIONS
     */
    public function setGUEST_ACCOUNT(\StructType\GUEST_ACCOUNT $gUEST_ACCOUNT = null)
    {
        $this->GUEST_ACCOUNT = $this->{'GUEST-ACCOUNT'} = $gUEST_ACCOUNT;
        return $this;
    }
    /**
     * Get CLIENT_ACCOUNT value
     * @return \StructType\CLIENT_ACCOUNT|null
     */
    public function getCLIENT_ACCOUNT()
    {
        return $this->{'CLIENT-ACCOUNT'};
    }
    /**
     * Set CLIENT_ACCOUNT value
     * @param \StructType\CLIENT_ACCOUNT $cLIENT_ACCOUNT
     * @return \StructType\PAYMENT_INSTRUCTIONS
     */
    public function setCLIENT_ACCOUNT(\StructType\CLIENT_ACCOUNT $cLIENT_ACCOUNT = null)
    {
        $this->CLIENT_ACCOUNT = $this->{'CLIENT-ACCOUNT'} = $cLIENT_ACCOUNT;
        return $this;
    }
    /**
     * Get GROUP_ACCOUNT value
     * @return \StructType\GROUP_ACCOUNT|null
     */
    public function getGROUP_ACCOUNT()
    {
        return $this->{'GROUP-ACCOUNT'};
    }
    /**
     * Set GROUP_ACCOUNT value
     * @param \StructType\GROUP_ACCOUNT $gROUP_ACCOUNT
     * @return \StructType\PAYMENT_INSTRUCTIONS
     */
    public function setGROUP_ACCOUNT(\StructType\GROUP_ACCOUNT $gROUP_ACCOUNT = null)
    {
        $this->GROUP_ACCOUNT = $this->{'GROUP-ACCOUNT'} = $gROUP_ACCOUNT;
        return $this;
    }
    /**
     * Get GUEST value
     * @return \StructType\GUEST[]|null
     */
    public function getGUEST()
    {
        return $this->GUEST;
    }
    /**
     * This method is responsible for validating the values passed to the setGUEST method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGUEST method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGUESTForArrayConstraintsFromSetGUEST(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $pAYMENT_INSTRUCTIONSGUESTItem) {
            // validation for constraint: itemType
            if (!$pAYMENT_INSTRUCTIONSGUESTItem instanceof \StructType\GUEST) {
                $invalidValues[] = is_object($pAYMENT_INSTRUCTIONSGUESTItem) ? get_class($pAYMENT_INSTRUCTIONSGUESTItem) : sprintf('%s(%s)', gettype($pAYMENT_INSTRUCTIONSGUESTItem), var_export($pAYMENT_INSTRUCTIONSGUESTItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The GUEST property can only contain items of type \StructType\GUEST, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GUEST value
     * @throws \InvalidArgumentException
     * @param \StructType\GUEST[] $gUEST
     * @return \StructType\PAYMENT_INSTRUCTIONS
     */
    public function setGUEST(array $gUEST = array())
    {
        // validation for constraint: array
        if ('' !== ($gUESTArrayErrorMessage = self::validateGUESTForArrayConstraintsFromSetGUEST($gUEST))) {
            throw new \InvalidArgumentException($gUESTArrayErrorMessage, __LINE__);
        }
        $this->GUEST = $gUEST;
        return $this;
    }
    /**
     * Add item to GUEST value
     * @throws \InvalidArgumentException
     * @param \StructType\GUEST $item
     * @return \StructType\PAYMENT_INSTRUCTIONS
     */
    public function addToGUEST(\StructType\GUEST $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GUEST) {
            throw new \InvalidArgumentException(sprintf('The GUEST property can only contain items of type \StructType\GUEST, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->GUEST[] = $item;
        return $this;
    }
    /**
     * Get ORDERER value
     * @return \StructType\ORDERER[]|null
     */
    public function getORDERER()
    {
        return $this->ORDERER;
    }
    /**
     * This method is responsible for validating the values passed to the setORDERER method
     * This method is willingly generated in order to preserve the one-line inline validation within the setORDERER method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateORDERERForArrayConstraintsFromSetORDERER(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $pAYMENT_INSTRUCTIONSORDERERItem) {
            // validation for constraint: itemType
            if (!$pAYMENT_INSTRUCTIONSORDERERItem instanceof \StructType\ORDERER) {
                $invalidValues[] = is_object($pAYMENT_INSTRUCTIONSORDERERItem) ? get_class($pAYMENT_INSTRUCTIONSORDERERItem) : sprintf('%s(%s)', gettype($pAYMENT_INSTRUCTIONSORDERERItem), var_export($pAYMENT_INSTRUCTIONSORDERERItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ORDERER property can only contain items of type \StructType\ORDERER, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ORDERER value
     * @throws \InvalidArgumentException
     * @param \StructType\ORDERER[] $oRDERER
     * @return \StructType\PAYMENT_INSTRUCTIONS
     */
    public function setORDERER(array $oRDERER = array())
    {
        // validation for constraint: array
        if ('' !== ($oRDERERArrayErrorMessage = self::validateORDERERForArrayConstraintsFromSetORDERER($oRDERER))) {
            throw new \InvalidArgumentException($oRDERERArrayErrorMessage, __LINE__);
        }
        $this->ORDERER = $oRDERER;
        return $this;
    }
    /**
     * Add item to ORDERER value
     * @throws \InvalidArgumentException
     * @param \StructType\ORDERER $item
     * @return \StructType\PAYMENT_INSTRUCTIONS
     */
    public function addToORDERER(\StructType\ORDERER $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ORDERER) {
            throw new \InvalidArgumentException(sprintf('The ORDERER property can only contain items of type \StructType\ORDERER, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ORDERER[] = $item;
        return $this;
    }
    /**
     * Get GROUP value
     * @return \StructType\GROUP[]|null
     */
    public function getGROUP()
    {
        return $this->GROUP;
    }
    /**
     * This method is responsible for validating the values passed to the setGROUP method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGROUP method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGROUPForArrayConstraintsFromSetGROUP(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $pAYMENT_INSTRUCTIONSGROUPItem) {
            // validation for constraint: itemType
            if (!$pAYMENT_INSTRUCTIONSGROUPItem instanceof \StructType\GROUP) {
                $invalidValues[] = is_object($pAYMENT_INSTRUCTIONSGROUPItem) ? get_class($pAYMENT_INSTRUCTIONSGROUPItem) : sprintf('%s(%s)', gettype($pAYMENT_INSTRUCTIONSGROUPItem), var_export($pAYMENT_INSTRUCTIONSGROUPItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The GROUP property can only contain items of type \StructType\GROUP, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GROUP value
     * @throws \InvalidArgumentException
     * @param \StructType\GROUP[] $gROUP
     * @return \StructType\PAYMENT_INSTRUCTIONS
     */
    public function setGROUP(array $gROUP = array())
    {
        // validation for constraint: array
        if ('' !== ($gROUPArrayErrorMessage = self::validateGROUPForArrayConstraintsFromSetGROUP($gROUP))) {
            throw new \InvalidArgumentException($gROUPArrayErrorMessage, __LINE__);
        }
        $this->GROUP = $gROUP;
        return $this;
    }
    /**
     * Add item to GROUP value
     * @throws \InvalidArgumentException
     * @param \StructType\GROUP $item
     * @return \StructType\PAYMENT_INSTRUCTIONS
     */
    public function addToGROUP(\StructType\GROUP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GROUP) {
            throw new \InvalidArgumentException(sprintf('The GROUP property can only contain items of type \StructType\GROUP, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->GROUP[] = $item;
        return $this;
    }
}
