<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PAYMENT-POSTINGS StructType
 * @subpackage Structs
 */
class PAYMENT_POSTINGS extends AbstractStructBase
{
    /**
     * The PAYMENT_POSTING
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\PAYMENT_POSTING[]
     */
    public $PAYMENT_POSTING;
    /**
     * Constructor method for PAYMENT-POSTINGS
     * @uses PAYMENT_POSTINGS::setPAYMENT_POSTING()
     * @param \StructType\PAYMENT_POSTING[] $pAYMENT_POSTING
     */
    public function __construct(array $pAYMENT_POSTING = array())
    {
        $this
            ->setPAYMENT_POSTING($pAYMENT_POSTING);
    }
    /**
     * Get PAYMENT_POSTING value
     * @return \StructType\PAYMENT_POSTING[]|null
     */
    public function getPAYMENT_POSTING()
    {
        return $this->{'PAYMENT-POSTING'};
    }
    /**
     * This method is responsible for validating the values passed to the setPAYMENT_POSTING method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPAYMENT_POSTING method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePAYMENT_POSTINGForArrayConstraintsFromSetPAYMENT_POSTING(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $pAYMENT_POSTINGSPAYMENT_POSTINGItem) {
            // validation for constraint: itemType
            if (!$pAYMENT_POSTINGSPAYMENT_POSTINGItem instanceof \StructType\PAYMENT_POSTING) {
                $invalidValues[] = is_object($pAYMENT_POSTINGSPAYMENT_POSTINGItem) ? get_class($pAYMENT_POSTINGSPAYMENT_POSTINGItem) : sprintf('%s(%s)', gettype($pAYMENT_POSTINGSPAYMENT_POSTINGItem), var_export($pAYMENT_POSTINGSPAYMENT_POSTINGItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PAYMENT_POSTING property can only contain items of type \StructType\PAYMENT_POSTING, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PAYMENT_POSTING value
     * @throws \InvalidArgumentException
     * @param \StructType\PAYMENT_POSTING[] $pAYMENT_POSTING
     * @return \StructType\PAYMENT_POSTINGS
     */
    public function setPAYMENT_POSTING(array $pAYMENT_POSTING = array())
    {
        // validation for constraint: array
        if ('' !== ($pAYMENT_POSTINGArrayErrorMessage = self::validatePAYMENT_POSTINGForArrayConstraintsFromSetPAYMENT_POSTING($pAYMENT_POSTING))) {
            throw new \InvalidArgumentException($pAYMENT_POSTINGArrayErrorMessage, __LINE__);
        }
        $this->PAYMENT_POSTING = $this->{'PAYMENT-POSTING'} = $pAYMENT_POSTING;
        return $this;
    }
    /**
     * Add item to PAYMENT_POSTING value
     * @throws \InvalidArgumentException
     * @param \StructType\PAYMENT_POSTING $item
     * @return \StructType\PAYMENT_POSTINGS
     */
    public function addToPAYMENT_POSTING(\StructType\PAYMENT_POSTING $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PAYMENT_POSTING) {
            throw new \InvalidArgumentException(sprintf('The PAYMENT_POSTING property can only contain items of type \StructType\PAYMENT_POSTING, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PAYMENT_POSTING[] = $this->{'PAYMENT-POSTING'}[] = $item;
        return $this;
    }
}
