<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PIGuest StructType
 * @subpackage Structs
 */
class PIGuest extends AbstractStructBase
{
    /**
     * The GuestFolio
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\GuestFolio[]
     */
    public $GuestFolio;
    /**
     * Constructor method for PIGuest
     * @uses PIGuest::setGuestFolio()
     * @param \StructType\GuestFolio[] $guestFolio
     */
    public function __construct(array $guestFolio = array())
    {
        $this
            ->setGuestFolio($guestFolio);
    }
    /**
     * Get GuestFolio value
     * @return \StructType\GuestFolio[]|null
     */
    public function getGuestFolio()
    {
        return $this->GuestFolio;
    }
    /**
     * This method is responsible for validating the values passed to the setGuestFolio method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGuestFolio method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGuestFolioForArrayConstraintsFromSetGuestFolio(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $pIGuestGuestFolioItem) {
            // validation for constraint: itemType
            if (!$pIGuestGuestFolioItem instanceof \StructType\GuestFolio) {
                $invalidValues[] = is_object($pIGuestGuestFolioItem) ? get_class($pIGuestGuestFolioItem) : sprintf('%s(%s)', gettype($pIGuestGuestFolioItem), var_export($pIGuestGuestFolioItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The GuestFolio property can only contain items of type \StructType\GuestFolio, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GuestFolio value
     * @throws \InvalidArgumentException
     * @param \StructType\GuestFolio[] $guestFolio
     * @return \StructType\PIGuest
     */
    public function setGuestFolio(array $guestFolio = array())
    {
        // validation for constraint: array
        if ('' !== ($guestFolioArrayErrorMessage = self::validateGuestFolioForArrayConstraintsFromSetGuestFolio($guestFolio))) {
            throw new \InvalidArgumentException($guestFolioArrayErrorMessage, __LINE__);
        }
        $this->GuestFolio = $guestFolio;
        return $this;
    }
    /**
     * Add item to GuestFolio value
     * @throws \InvalidArgumentException
     * @param \StructType\GuestFolio $item
     * @return \StructType\PIGuest
     */
    public function addToGuestFolio(\StructType\GuestFolio $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GuestFolio) {
            throw new \InvalidArgumentException(sprintf('The GuestFolio property can only contain items of type \StructType\GuestFolio, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->GuestFolio[] = $item;
        return $this;
    }
}
