<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PINamelistGroup StructType
 * @subpackage Structs
 */
class PINamelistGroup extends AbstractStructBase
{
    /**
     * The PIGuest
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\PIGuest[]
     */
    public $PIGuest;
    /**
     * The PIOrderer
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\PIOrderer[]
     */
    public $PIOrderer;
    /**
     * Constructor method for PINamelistGroup
     * @uses PINamelistGroup::setPIGuest()
     * @uses PINamelistGroup::setPIOrderer()
     * @param \StructType\PIGuest[] $pIGuest
     * @param \StructType\PIOrderer[] $pIOrderer
     */
    public function __construct(array $pIGuest = array(), array $pIOrderer = array())
    {
        $this
            ->setPIGuest($pIGuest)
            ->setPIOrderer($pIOrderer);
    }
    /**
     * Get PIGuest value
     * @return \StructType\PIGuest[]|null
     */
    public function getPIGuest()
    {
        return $this->PIGuest;
    }
    /**
     * This method is responsible for validating the values passed to the setPIGuest method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPIGuest method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePIGuestForArrayConstraintsFromSetPIGuest(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $pINamelistGroupPIGuestItem) {
            // validation for constraint: itemType
            if (!$pINamelistGroupPIGuestItem instanceof \StructType\PIGuest) {
                $invalidValues[] = is_object($pINamelistGroupPIGuestItem) ? get_class($pINamelistGroupPIGuestItem) : sprintf('%s(%s)', gettype($pINamelistGroupPIGuestItem), var_export($pINamelistGroupPIGuestItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PIGuest property can only contain items of type \StructType\PIGuest, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PIGuest value
     * @throws \InvalidArgumentException
     * @param \StructType\PIGuest[] $pIGuest
     * @return \StructType\PINamelistGroup
     */
    public function setPIGuest(array $pIGuest = array())
    {
        // validation for constraint: array
        if ('' !== ($pIGuestArrayErrorMessage = self::validatePIGuestForArrayConstraintsFromSetPIGuest($pIGuest))) {
            throw new \InvalidArgumentException($pIGuestArrayErrorMessage, __LINE__);
        }
        $this->PIGuest = $pIGuest;
        return $this;
    }
    /**
     * Add item to PIGuest value
     * @throws \InvalidArgumentException
     * @param \StructType\PIGuest $item
     * @return \StructType\PINamelistGroup
     */
    public function addToPIGuest(\StructType\PIGuest $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PIGuest) {
            throw new \InvalidArgumentException(sprintf('The PIGuest property can only contain items of type \StructType\PIGuest, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PIGuest[] = $item;
        return $this;
    }
    /**
     * Get PIOrderer value
     * @return \StructType\PIOrderer[]|null
     */
    public function getPIOrderer()
    {
        return $this->PIOrderer;
    }
    /**
     * This method is responsible for validating the values passed to the setPIOrderer method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPIOrderer method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePIOrdererForArrayConstraintsFromSetPIOrderer(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $pINamelistGroupPIOrdererItem) {
            // validation for constraint: itemType
            if (!$pINamelistGroupPIOrdererItem instanceof \StructType\PIOrderer) {
                $invalidValues[] = is_object($pINamelistGroupPIOrdererItem) ? get_class($pINamelistGroupPIOrdererItem) : sprintf('%s(%s)', gettype($pINamelistGroupPIOrdererItem), var_export($pINamelistGroupPIOrdererItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PIOrderer property can only contain items of type \StructType\PIOrderer, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PIOrderer value
     * @throws \InvalidArgumentException
     * @param \StructType\PIOrderer[] $pIOrderer
     * @return \StructType\PINamelistGroup
     */
    public function setPIOrderer(array $pIOrderer = array())
    {
        // validation for constraint: array
        if ('' !== ($pIOrdererArrayErrorMessage = self::validatePIOrdererForArrayConstraintsFromSetPIOrderer($pIOrderer))) {
            throw new \InvalidArgumentException($pIOrdererArrayErrorMessage, __LINE__);
        }
        $this->PIOrderer = $pIOrderer;
        return $this;
    }
    /**
     * Add item to PIOrderer value
     * @throws \InvalidArgumentException
     * @param \StructType\PIOrderer $item
     * @return \StructType\PINamelistGroup
     */
    public function addToPIOrderer(\StructType\PIOrderer $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PIOrderer) {
            throw new \InvalidArgumentException(sprintf('The PIOrderer property can only contain items of type \StructType\PIOrderer, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PIOrderer[] = $item;
        return $this;
    }
}
