<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PIOrderer StructType
 * @subpackage Structs
 */
class PIOrderer extends AbstractStructBase
{
    /**
     * The OrdererFolio
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\OrdererFolio[]
     */
    public $OrdererFolio;
    /**
     * Constructor method for PIOrderer
     * @uses PIOrderer::setOrdererFolio()
     * @param \StructType\OrdererFolio[] $ordererFolio
     */
    public function __construct(array $ordererFolio = array())
    {
        $this
            ->setOrdererFolio($ordererFolio);
    }
    /**
     * Get OrdererFolio value
     * @return \StructType\OrdererFolio[]|null
     */
    public function getOrdererFolio()
    {
        return $this->OrdererFolio;
    }
    /**
     * This method is responsible for validating the values passed to the setOrdererFolio method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOrdererFolio method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOrdererFolioForArrayConstraintsFromSetOrdererFolio(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $pIOrdererOrdererFolioItem) {
            // validation for constraint: itemType
            if (!$pIOrdererOrdererFolioItem instanceof \StructType\OrdererFolio) {
                $invalidValues[] = is_object($pIOrdererOrdererFolioItem) ? get_class($pIOrdererOrdererFolioItem) : sprintf('%s(%s)', gettype($pIOrdererOrdererFolioItem), var_export($pIOrdererOrdererFolioItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OrdererFolio property can only contain items of type \StructType\OrdererFolio, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OrdererFolio value
     * @throws \InvalidArgumentException
     * @param \StructType\OrdererFolio[] $ordererFolio
     * @return \StructType\PIOrderer
     */
    public function setOrdererFolio(array $ordererFolio = array())
    {
        // validation for constraint: array
        if ('' !== ($ordererFolioArrayErrorMessage = self::validateOrdererFolioForArrayConstraintsFromSetOrdererFolio($ordererFolio))) {
            throw new \InvalidArgumentException($ordererFolioArrayErrorMessage, __LINE__);
        }
        $this->OrdererFolio = $ordererFolio;
        return $this;
    }
    /**
     * Add item to OrdererFolio value
     * @throws \InvalidArgumentException
     * @param \StructType\OrdererFolio $item
     * @return \StructType\PIOrderer
     */
    public function addToOrdererFolio(\StructType\OrdererFolio $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OrdererFolio) {
            throw new \InvalidArgumentException(sprintf('The OrdererFolio property can only contain items of type \StructType\OrdererFolio, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OrdererFolio[] = $item;
        return $this;
    }
}
