<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PRINTDOCUMENT StructType
 * @subpackage Structs
 */
class PRINTDOCUMENT extends AbstractStructBase
{
    /**
     * The PdfBase64
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $PdfBase64;
    /**
     * Constructor method for PRINTDOCUMENT
     * @uses PRINTDOCUMENT::setPdfBase64()
     * @param string $pdfBase64
     */
    public function __construct($pdfBase64 = null)
    {
        $this
            ->setPdfBase64($pdfBase64);
    }
    /**
     * Get PdfBase64 value
     * @return string
     */
    public function getPdfBase64()
    {
        return $this->PdfBase64;
    }
    /**
     * Set PdfBase64 value
     * @param string $pdfBase64
     * @return \StructType\PRINTDOCUMENT
     */
    public function setPdfBase64($pdfBase64 = null)
    {
        // validation for constraint: string
        if (!is_null($pdfBase64) && !is_string($pdfBase64)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pdfBase64, true), gettype($pdfBase64)), __LINE__);
        }
        $this->PdfBase64 = $pdfBase64;
        return $this;
    }
}
