<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PackageMasterFiles StructType
 * @subpackage Structs
 */
class PackageMasterFiles extends AbstractStructBase
{
    /**
     * The PackageMasterFile
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\PackageMasterFile[]
     */
    public $PackageMasterFile;
    /**
     * Constructor method for PackageMasterFiles
     * @uses PackageMasterFiles::setPackageMasterFile()
     * @param \StructType\PackageMasterFile[] $packageMasterFile
     */
    public function __construct(array $packageMasterFile = array())
    {
        $this
            ->setPackageMasterFile($packageMasterFile);
    }
    /**
     * Get PackageMasterFile value
     * @return \StructType\PackageMasterFile[]|null
     */
    public function getPackageMasterFile()
    {
        return $this->PackageMasterFile;
    }
    /**
     * This method is responsible for validating the values passed to the setPackageMasterFile method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPackageMasterFile method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePackageMasterFileForArrayConstraintsFromSetPackageMasterFile(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $packageMasterFilesPackageMasterFileItem) {
            // validation for constraint: itemType
            if (!$packageMasterFilesPackageMasterFileItem instanceof \StructType\PackageMasterFile) {
                $invalidValues[] = is_object($packageMasterFilesPackageMasterFileItem) ? get_class($packageMasterFilesPackageMasterFileItem) : sprintf('%s(%s)', gettype($packageMasterFilesPackageMasterFileItem), var_export($packageMasterFilesPackageMasterFileItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PackageMasterFile property can only contain items of type \StructType\PackageMasterFile, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PackageMasterFile value
     * @throws \InvalidArgumentException
     * @param \StructType\PackageMasterFile[] $packageMasterFile
     * @return \StructType\PackageMasterFiles
     */
    public function setPackageMasterFile(array $packageMasterFile = array())
    {
        // validation for constraint: array
        if ('' !== ($packageMasterFileArrayErrorMessage = self::validatePackageMasterFileForArrayConstraintsFromSetPackageMasterFile($packageMasterFile))) {
            throw new \InvalidArgumentException($packageMasterFileArrayErrorMessage, __LINE__);
        }
        $this->PackageMasterFile = $packageMasterFile;
        return $this;
    }
    /**
     * Add item to PackageMasterFile value
     * @throws \InvalidArgumentException
     * @param \StructType\PackageMasterFile $item
     * @return \StructType\PackageMasterFiles
     */
    public function addToPackageMasterFile(\StructType\PackageMasterFile $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PackageMasterFile) {
            throw new \InvalidArgumentException(sprintf('The PackageMasterFile property can only contain items of type \StructType\PackageMasterFile, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PackageMasterFile[] = $item;
        return $this;
    }
}
