<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PackageReservations StructType
 * @subpackage Structs
 */
class PackageReservations extends AbstractStructBase
{
    /**
     * The PackageReservation
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\PackageReservation[]
     */
    public $PackageReservation;
    /**
     * Constructor method for PackageReservations
     * @uses PackageReservations::setPackageReservation()
     * @param \StructType\PackageReservation[] $packageReservation
     */
    public function __construct(array $packageReservation = array())
    {
        $this
            ->setPackageReservation($packageReservation);
    }
    /**
     * Get PackageReservation value
     * @return \StructType\PackageReservation[]|null
     */
    public function getPackageReservation()
    {
        return $this->PackageReservation;
    }
    /**
     * This method is responsible for validating the values passed to the setPackageReservation method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPackageReservation method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePackageReservationForArrayConstraintsFromSetPackageReservation(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $packageReservationsPackageReservationItem) {
            // validation for constraint: itemType
            if (!$packageReservationsPackageReservationItem instanceof \StructType\PackageReservation) {
                $invalidValues[] = is_object($packageReservationsPackageReservationItem) ? get_class($packageReservationsPackageReservationItem) : sprintf('%s(%s)', gettype($packageReservationsPackageReservationItem), var_export($packageReservationsPackageReservationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PackageReservation property can only contain items of type \StructType\PackageReservation, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PackageReservation value
     * @throws \InvalidArgumentException
     * @param \StructType\PackageReservation[] $packageReservation
     * @return \StructType\PackageReservations
     */
    public function setPackageReservation(array $packageReservation = array())
    {
        // validation for constraint: array
        if ('' !== ($packageReservationArrayErrorMessage = self::validatePackageReservationForArrayConstraintsFromSetPackageReservation($packageReservation))) {
            throw new \InvalidArgumentException($packageReservationArrayErrorMessage, __LINE__);
        }
        $this->PackageReservation = $packageReservation;
        return $this;
    }
    /**
     * Add item to PackageReservation value
     * @throws \InvalidArgumentException
     * @param \StructType\PackageReservation $item
     * @return \StructType\PackageReservations
     */
    public function addToPackageReservation(\StructType\PackageReservation $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PackageReservation) {
            throw new \InvalidArgumentException(sprintf('The PackageReservation property can only contain items of type \StructType\PackageReservation, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PackageReservation[] = $item;
        return $this;
    }
}
