<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PostFOServiceForOutput StructType
 * @subpackage Structs
 */
class PostFOServiceForOutput extends AbstractStructBase
{
    /**
     * The PostedServicesForOutput
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\PostedServicesForOutput[]
     */
    public $PostedServicesForOutput;
    /**
     * Constructor method for PostFOServiceForOutput
     * @uses PostFOServiceForOutput::setPostedServicesForOutput()
     * @param \StructType\PostedServicesForOutput[] $postedServicesForOutput
     */
    public function __construct(array $postedServicesForOutput = array())
    {
        $this
            ->setPostedServicesForOutput($postedServicesForOutput);
    }
    /**
     * Get PostedServicesForOutput value
     * @return \StructType\PostedServicesForOutput[]|null
     */
    public function getPostedServicesForOutput()
    {
        return $this->PostedServicesForOutput;
    }
    /**
     * This method is responsible for validating the values passed to the setPostedServicesForOutput method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPostedServicesForOutput method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePostedServicesForOutputForArrayConstraintsFromSetPostedServicesForOutput(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $postFOServiceForOutputPostedServicesForOutputItem) {
            // validation for constraint: itemType
            if (!$postFOServiceForOutputPostedServicesForOutputItem instanceof \StructType\PostedServicesForOutput) {
                $invalidValues[] = is_object($postFOServiceForOutputPostedServicesForOutputItem) ? get_class($postFOServiceForOutputPostedServicesForOutputItem) : sprintf('%s(%s)', gettype($postFOServiceForOutputPostedServicesForOutputItem), var_export($postFOServiceForOutputPostedServicesForOutputItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PostedServicesForOutput property can only contain items of type \StructType\PostedServicesForOutput, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PostedServicesForOutput value
     * @throws \InvalidArgumentException
     * @param \StructType\PostedServicesForOutput[] $postedServicesForOutput
     * @return \StructType\PostFOServiceForOutput
     */
    public function setPostedServicesForOutput(array $postedServicesForOutput = array())
    {
        // validation for constraint: array
        if ('' !== ($postedServicesForOutputArrayErrorMessage = self::validatePostedServicesForOutputForArrayConstraintsFromSetPostedServicesForOutput($postedServicesForOutput))) {
            throw new \InvalidArgumentException($postedServicesForOutputArrayErrorMessage, __LINE__);
        }
        $this->PostedServicesForOutput = $postedServicesForOutput;
        return $this;
    }
    /**
     * Add item to PostedServicesForOutput value
     * @throws \InvalidArgumentException
     * @param \StructType\PostedServicesForOutput $item
     * @return \StructType\PostFOServiceForOutput
     */
    public function addToPostedServicesForOutput(\StructType\PostedServicesForOutput $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PostedServicesForOutput) {
            throw new \InvalidArgumentException(sprintf('The PostedServicesForOutput property can only contain items of type \StructType\PostedServicesForOutput, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PostedServicesForOutput[] = $item;
        return $this;
    }
}
