<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PreferredHotels StructType
 * @subpackage Structs
 */
class PreferredHotels extends AbstractStructBase
{
    /**
     * The PreferredHotel
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\PreferredHotel[]
     */
    public $PreferredHotel;
    /**
     * Constructor method for PreferredHotels
     * @uses PreferredHotels::setPreferredHotel()
     * @param \StructType\PreferredHotel[] $preferredHotel
     */
    public function __construct(array $preferredHotel = array())
    {
        $this
            ->setPreferredHotel($preferredHotel);
    }
    /**
     * Get PreferredHotel value
     * @return \StructType\PreferredHotel[]|null
     */
    public function getPreferredHotel()
    {
        return $this->PreferredHotel;
    }
    /**
     * This method is responsible for validating the values passed to the setPreferredHotel method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPreferredHotel method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePreferredHotelForArrayConstraintsFromSetPreferredHotel(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $preferredHotelsPreferredHotelItem) {
            // validation for constraint: itemType
            if (!$preferredHotelsPreferredHotelItem instanceof \StructType\PreferredHotel) {
                $invalidValues[] = is_object($preferredHotelsPreferredHotelItem) ? get_class($preferredHotelsPreferredHotelItem) : sprintf('%s(%s)', gettype($preferredHotelsPreferredHotelItem), var_export($preferredHotelsPreferredHotelItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PreferredHotel property can only contain items of type \StructType\PreferredHotel, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PreferredHotel value
     * @throws \InvalidArgumentException
     * @param \StructType\PreferredHotel[] $preferredHotel
     * @return \StructType\PreferredHotels
     */
    public function setPreferredHotel(array $preferredHotel = array())
    {
        // validation for constraint: array
        if ('' !== ($preferredHotelArrayErrorMessage = self::validatePreferredHotelForArrayConstraintsFromSetPreferredHotel($preferredHotel))) {
            throw new \InvalidArgumentException($preferredHotelArrayErrorMessage, __LINE__);
        }
        $this->PreferredHotel = $preferredHotel;
        return $this;
    }
    /**
     * Add item to PreferredHotel value
     * @throws \InvalidArgumentException
     * @param \StructType\PreferredHotel $item
     * @return \StructType\PreferredHotels
     */
    public function addToPreferredHotel(\StructType\PreferredHotel $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PreferredHotel) {
            throw new \InvalidArgumentException(sprintf('The PreferredHotel property can only contain items of type \StructType\PreferredHotel, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PreferredHotel[] = $item;
        return $this;
    }
}
