<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ROOMS StructType
 * @subpackage Structs
 */
class ROOMS extends AbstractStructBase
{
    /**
     * The ROOM
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ROOM_2[]
     */
    public $ROOM;
    /**
     * Constructor method for ROOMS
     * @uses ROOMS::setROOM()
     * @param \StructType\ROOM_2[] $rOOM
     */
    public function __construct(array $rOOM = array())
    {
        $this
            ->setROOM($rOOM);
    }
    /**
     * Get ROOM value
     * @return \StructType\ROOM_2[]|null
     */
    public function getROOM()
    {
        return $this->ROOM;
    }
    /**
     * This method is responsible for validating the values passed to the setROOM method
     * This method is willingly generated in order to preserve the one-line inline validation within the setROOM method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateROOMForArrayConstraintsFromSetROOM(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $rOOMSROOMItem) {
            // validation for constraint: itemType
            if (!$rOOMSROOMItem instanceof \StructType\ROOM_2) {
                $invalidValues[] = is_object($rOOMSROOMItem) ? get_class($rOOMSROOMItem) : sprintf('%s(%s)', gettype($rOOMSROOMItem), var_export($rOOMSROOMItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ROOM property can only contain items of type \StructType\ROOM_2, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ROOM value
     * @throws \InvalidArgumentException
     * @param \StructType\ROOM_2[] $rOOM
     * @return \StructType\ROOMS
     */
    public function setROOM(array $rOOM = array())
    {
        // validation for constraint: array
        if ('' !== ($rOOMArrayErrorMessage = self::validateROOMForArrayConstraintsFromSetROOM($rOOM))) {
            throw new \InvalidArgumentException($rOOMArrayErrorMessage, __LINE__);
        }
        $this->ROOM = $rOOM;
        return $this;
    }
    /**
     * Add item to ROOM value
     * @throws \InvalidArgumentException
     * @param \StructType\ROOM_2 $item
     * @return \StructType\ROOMS
     */
    public function addToROOM(\StructType\ROOM_2 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ROOM_2) {
            throw new \InvalidArgumentException(sprintf('The ROOM property can only contain items of type \StructType\ROOM_2, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ROOM[] = $item;
        return $this;
    }
}
