<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ResGroupReservations StructType
 * @subpackage Structs
 */
class ResGroupReservations extends AbstractStructBase
{
    /**
     * The ResGroupReservation
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ResGroupReservation[]
     */
    public $ResGroupReservation;
    /**
     * Constructor method for ResGroupReservations
     * @uses ResGroupReservations::setResGroupReservation()
     * @param \StructType\ResGroupReservation[] $resGroupReservation
     */
    public function __construct(array $resGroupReservation = array())
    {
        $this
            ->setResGroupReservation($resGroupReservation);
    }
    /**
     * Get ResGroupReservation value
     * @return \StructType\ResGroupReservation[]|null
     */
    public function getResGroupReservation()
    {
        return $this->ResGroupReservation;
    }
    /**
     * This method is responsible for validating the values passed to the setResGroupReservation method
     * This method is willingly generated in order to preserve the one-line inline validation within the setResGroupReservation method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateResGroupReservationForArrayConstraintsFromSetResGroupReservation(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $resGroupReservationsResGroupReservationItem) {
            // validation for constraint: itemType
            if (!$resGroupReservationsResGroupReservationItem instanceof \StructType\ResGroupReservation) {
                $invalidValues[] = is_object($resGroupReservationsResGroupReservationItem) ? get_class($resGroupReservationsResGroupReservationItem) : sprintf('%s(%s)', gettype($resGroupReservationsResGroupReservationItem), var_export($resGroupReservationsResGroupReservationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ResGroupReservation property can only contain items of type \StructType\ResGroupReservation, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ResGroupReservation value
     * @throws \InvalidArgumentException
     * @param \StructType\ResGroupReservation[] $resGroupReservation
     * @return \StructType\ResGroupReservations
     */
    public function setResGroupReservation(array $resGroupReservation = array())
    {
        // validation for constraint: array
        if ('' !== ($resGroupReservationArrayErrorMessage = self::validateResGroupReservationForArrayConstraintsFromSetResGroupReservation($resGroupReservation))) {
            throw new \InvalidArgumentException($resGroupReservationArrayErrorMessage, __LINE__);
        }
        $this->ResGroupReservation = $resGroupReservation;
        return $this;
    }
    /**
     * Add item to ResGroupReservation value
     * @throws \InvalidArgumentException
     * @param \StructType\ResGroupReservation $item
     * @return \StructType\ResGroupReservations
     */
    public function addToResGroupReservation(\StructType\ResGroupReservation $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ResGroupReservation) {
            throw new \InvalidArgumentException(sprintf('The ResGroupReservation property can only contain items of type \StructType\ResGroupReservation, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ResGroupReservation[] = $item;
        return $this;
    }
}
