<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RoomCategoryMasterFiles StructType
 * @subpackage Structs
 */
class RoomCategoryMasterFiles extends AbstractStructBase
{
    /**
     * The RoomCategoryMasterFile
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\RoomCategoryMasterFile[]
     */
    public $RoomCategoryMasterFile;
    /**
     * Constructor method for RoomCategoryMasterFiles
     * @uses RoomCategoryMasterFiles::setRoomCategoryMasterFile()
     * @param \StructType\RoomCategoryMasterFile[] $roomCategoryMasterFile
     */
    public function __construct(array $roomCategoryMasterFile = array())
    {
        $this
            ->setRoomCategoryMasterFile($roomCategoryMasterFile);
    }
    /**
     * Get RoomCategoryMasterFile value
     * @return \StructType\RoomCategoryMasterFile[]|null
     */
    public function getRoomCategoryMasterFile()
    {
        return $this->RoomCategoryMasterFile;
    }
    /**
     * This method is responsible for validating the values passed to the setRoomCategoryMasterFile method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRoomCategoryMasterFile method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRoomCategoryMasterFileForArrayConstraintsFromSetRoomCategoryMasterFile(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $roomCategoryMasterFilesRoomCategoryMasterFileItem) {
            // validation for constraint: itemType
            if (!$roomCategoryMasterFilesRoomCategoryMasterFileItem instanceof \StructType\RoomCategoryMasterFile) {
                $invalidValues[] = is_object($roomCategoryMasterFilesRoomCategoryMasterFileItem) ? get_class($roomCategoryMasterFilesRoomCategoryMasterFileItem) : sprintf('%s(%s)', gettype($roomCategoryMasterFilesRoomCategoryMasterFileItem), var_export($roomCategoryMasterFilesRoomCategoryMasterFileItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RoomCategoryMasterFile property can only contain items of type \StructType\RoomCategoryMasterFile, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RoomCategoryMasterFile value
     * @throws \InvalidArgumentException
     * @param \StructType\RoomCategoryMasterFile[] $roomCategoryMasterFile
     * @return \StructType\RoomCategoryMasterFiles
     */
    public function setRoomCategoryMasterFile(array $roomCategoryMasterFile = array())
    {
        // validation for constraint: array
        if ('' !== ($roomCategoryMasterFileArrayErrorMessage = self::validateRoomCategoryMasterFileForArrayConstraintsFromSetRoomCategoryMasterFile($roomCategoryMasterFile))) {
            throw new \InvalidArgumentException($roomCategoryMasterFileArrayErrorMessage, __LINE__);
        }
        $this->RoomCategoryMasterFile = $roomCategoryMasterFile;
        return $this;
    }
    /**
     * Add item to RoomCategoryMasterFile value
     * @throws \InvalidArgumentException
     * @param \StructType\RoomCategoryMasterFile $item
     * @return \StructType\RoomCategoryMasterFiles
     */
    public function addToRoomCategoryMasterFile(\StructType\RoomCategoryMasterFile $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RoomCategoryMasterFile) {
            throw new \InvalidArgumentException(sprintf('The RoomCategoryMasterFile property can only contain items of type \StructType\RoomCategoryMasterFile, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RoomCategoryMasterFile[] = $item;
        return $this;
    }
}
