<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RoomReservations StructType
 * @subpackage Structs
 */
class RoomReservations extends AbstractStructBase
{
    /**
     * The RoomReservation
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\RoomReservation[]
     */
    public $RoomReservation;
    /**
     * Constructor method for RoomReservations
     * @uses RoomReservations::setRoomReservation()
     * @param \StructType\RoomReservation[] $roomReservation
     */
    public function __construct(array $roomReservation = array())
    {
        $this
            ->setRoomReservation($roomReservation);
    }
    /**
     * Get RoomReservation value
     * @return \StructType\RoomReservation[]|null
     */
    public function getRoomReservation()
    {
        return $this->RoomReservation;
    }
    /**
     * This method is responsible for validating the values passed to the setRoomReservation method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRoomReservation method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRoomReservationForArrayConstraintsFromSetRoomReservation(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $roomReservationsRoomReservationItem) {
            // validation for constraint: itemType
            if (!$roomReservationsRoomReservationItem instanceof \StructType\RoomReservation) {
                $invalidValues[] = is_object($roomReservationsRoomReservationItem) ? get_class($roomReservationsRoomReservationItem) : sprintf('%s(%s)', gettype($roomReservationsRoomReservationItem), var_export($roomReservationsRoomReservationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RoomReservation property can only contain items of type \StructType\RoomReservation, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RoomReservation value
     * @throws \InvalidArgumentException
     * @param \StructType\RoomReservation[] $roomReservation
     * @return \StructType\RoomReservations
     */
    public function setRoomReservation(array $roomReservation = array())
    {
        // validation for constraint: array
        if ('' !== ($roomReservationArrayErrorMessage = self::validateRoomReservationForArrayConstraintsFromSetRoomReservation($roomReservation))) {
            throw new \InvalidArgumentException($roomReservationArrayErrorMessage, __LINE__);
        }
        $this->RoomReservation = $roomReservation;
        return $this;
    }
    /**
     * Add item to RoomReservation value
     * @throws \InvalidArgumentException
     * @param \StructType\RoomReservation $item
     * @return \StructType\RoomReservations
     */
    public function addToRoomReservation(\StructType\RoomReservation $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RoomReservation) {
            throw new \InvalidArgumentException(sprintf('The RoomReservation property can only contain items of type \StructType\RoomReservation, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RoomReservation[] = $item;
        return $this;
    }
}
