<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_ACTIVITY_REMOVE_V001Request StructType
 * @subpackage Structs
 */
class S_ACTIVITY_REMOVE_V001Request extends AbstractStructBase
{
    /**
     * The Authentication
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Authentication
     */
    public $Authentication;
    /**
     * The RemoveActivity
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\RemoveActivity
     */
    public $RemoveActivity;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * Constructor method for S_ACTIVITY_REMOVE_V001Request
     * @uses S_ACTIVITY_REMOVE_V001Request::setAuthentication()
     * @uses S_ACTIVITY_REMOVE_V001Request::setRemoveActivity()
     * @uses S_ACTIVITY_REMOVE_V001Request::setTransactionID()
     * @param \StructType\Authentication $authentication
     * @param \StructType\RemoveActivity $removeActivity
     * @param string $transactionID
     */
    public function __construct(\StructType\Authentication $authentication = null, \StructType\RemoveActivity $removeActivity = null, $transactionID = null)
    {
        $this
            ->setAuthentication($authentication)
            ->setRemoveActivity($removeActivity)
            ->setTransactionID($transactionID);
    }
    /**
     * Get Authentication value
     * @return \StructType\Authentication
     */
    public function getAuthentication()
    {
        return $this->Authentication;
    }
    /**
     * Set Authentication value
     * @param \StructType\Authentication $authentication
     * @return \StructType\S_ACTIVITY_REMOVE_V001Request
     */
    public function setAuthentication(\StructType\Authentication $authentication = null)
    {
        $this->Authentication = $authentication;
        return $this;
    }
    /**
     * Get RemoveActivity value
     * @return \StructType\RemoveActivity
     */
    public function getRemoveActivity()
    {
        return $this->RemoveActivity;
    }
    /**
     * Set RemoveActivity value
     * @param \StructType\RemoveActivity $removeActivity
     * @return \StructType\S_ACTIVITY_REMOVE_V001Request
     */
    public function setRemoveActivity(\StructType\RemoveActivity $removeActivity = null)
    {
        $this->RemoveActivity = $removeActivity;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_ACTIVITY_REMOVE_V001Request
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
}
