<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_ALLOTMENT_RESTRICTION_SEARCH_V002Request StructType
 * @subpackage Structs
 */
class S_ALLOTMENT_RESTRICTION_SEARCH_V002Request extends AbstractStructBase
{
    /**
     * The Authentication
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Authentication
     */
    public $Authentication;
    /**
     * The ALLOTMENTRESTRICTION_SEARCH
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\ALLOTMENTRESTRICTION_SEARCH
     */
    public $ALLOTMENTRESTRICTION_SEARCH;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * Constructor method for S_ALLOTMENT_RESTRICTION_SEARCH_V002Request
     * @uses S_ALLOTMENT_RESTRICTION_SEARCH_V002Request::setAuthentication()
     * @uses S_ALLOTMENT_RESTRICTION_SEARCH_V002Request::setALLOTMENTRESTRICTION_SEARCH()
     * @uses S_ALLOTMENT_RESTRICTION_SEARCH_V002Request::setTransactionID()
     * @param \StructType\Authentication $authentication
     * @param \StructType\ALLOTMENTRESTRICTION_SEARCH $aLLOTMENTRESTRICTION_SEARCH
     * @param string $transactionID
     */
    public function __construct(\StructType\Authentication $authentication = null, \StructType\ALLOTMENTRESTRICTION_SEARCH $aLLOTMENTRESTRICTION_SEARCH = null, $transactionID = null)
    {
        $this
            ->setAuthentication($authentication)
            ->setALLOTMENTRESTRICTION_SEARCH($aLLOTMENTRESTRICTION_SEARCH)
            ->setTransactionID($transactionID);
    }
    /**
     * Get Authentication value
     * @return \StructType\Authentication
     */
    public function getAuthentication()
    {
        return $this->Authentication;
    }
    /**
     * Set Authentication value
     * @param \StructType\Authentication $authentication
     * @return \StructType\S_ALLOTMENT_RESTRICTION_SEARCH_V002Request
     */
    public function setAuthentication(\StructType\Authentication $authentication = null)
    {
        $this->Authentication = $authentication;
        return $this;
    }
    /**
     * Get ALLOTMENTRESTRICTION_SEARCH value
     * @return \StructType\ALLOTMENTRESTRICTION_SEARCH
     */
    public function getALLOTMENTRESTRICTION_SEARCH()
    {
        return $this->{'ALLOTMENTRESTRICTION-SEARCH'};
    }
    /**
     * Set ALLOTMENTRESTRICTION_SEARCH value
     * @param \StructType\ALLOTMENTRESTRICTION_SEARCH $aLLOTMENTRESTRICTION_SEARCH
     * @return \StructType\S_ALLOTMENT_RESTRICTION_SEARCH_V002Request
     */
    public function setALLOTMENTRESTRICTION_SEARCH(\StructType\ALLOTMENTRESTRICTION_SEARCH $aLLOTMENTRESTRICTION_SEARCH = null)
    {
        $this->ALLOTMENTRESTRICTION_SEARCH = $this->{'ALLOTMENTRESTRICTION-SEARCH'} = $aLLOTMENTRESTRICTION_SEARCH;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_ALLOTMENT_RESTRICTION_SEARCH_V002Request
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
}
