<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_AUTHORISATION_COMMIT_V001Request StructType
 * @subpackage Structs
 */
class S_AUTHORISATION_COMMIT_V001Request extends AbstractStructBase
{
    /**
     * The Authentication
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Authentication
     */
    public $Authentication;
    /**
     * The AuthCommit
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\AuthCommit
     */
    public $AuthCommit;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * Constructor method for S_AUTHORISATION_COMMIT_V001Request
     * @uses S_AUTHORISATION_COMMIT_V001Request::setAuthentication()
     * @uses S_AUTHORISATION_COMMIT_V001Request::setAuthCommit()
     * @uses S_AUTHORISATION_COMMIT_V001Request::setTransactionID()
     * @param \StructType\Authentication $authentication
     * @param \StructType\AuthCommit $authCommit
     * @param string $transactionID
     */
    public function __construct(\StructType\Authentication $authentication = null, \StructType\AuthCommit $authCommit = null, $transactionID = null)
    {
        $this
            ->setAuthentication($authentication)
            ->setAuthCommit($authCommit)
            ->setTransactionID($transactionID);
    }
    /**
     * Get Authentication value
     * @return \StructType\Authentication
     */
    public function getAuthentication()
    {
        return $this->Authentication;
    }
    /**
     * Set Authentication value
     * @param \StructType\Authentication $authentication
     * @return \StructType\S_AUTHORISATION_COMMIT_V001Request
     */
    public function setAuthentication(\StructType\Authentication $authentication = null)
    {
        $this->Authentication = $authentication;
        return $this;
    }
    /**
     * Get AuthCommit value
     * @return \StructType\AuthCommit
     */
    public function getAuthCommit()
    {
        return $this->AuthCommit;
    }
    /**
     * Set AuthCommit value
     * @param \StructType\AuthCommit $authCommit
     * @return \StructType\S_AUTHORISATION_COMMIT_V001Request
     */
    public function setAuthCommit(\StructType\AuthCommit $authCommit = null)
    {
        $this->AuthCommit = $authCommit;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_AUTHORISATION_COMMIT_V001Request
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
}
