<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_AUTOTASK_ERROR_SET_V001Request StructType
 * @subpackage Structs
 */
class S_AUTOTASK_ERROR_SET_V001Request extends AbstractStructBase
{
    /**
     * The Authentication
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Authentication
     */
    public $Authentication;
    /**
     * The AutoTaskSetError
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\AutoTaskSetError
     */
    public $AutoTaskSetError;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * Constructor method for S_AUTOTASK_ERROR_SET_V001Request
     * @uses S_AUTOTASK_ERROR_SET_V001Request::setAuthentication()
     * @uses S_AUTOTASK_ERROR_SET_V001Request::setAutoTaskSetError()
     * @uses S_AUTOTASK_ERROR_SET_V001Request::setTransactionID()
     * @param \StructType\Authentication $authentication
     * @param \StructType\AutoTaskSetError $autoTaskSetError
     * @param string $transactionID
     */
    public function __construct(\StructType\Authentication $authentication = null, \StructType\AutoTaskSetError $autoTaskSetError = null, $transactionID = null)
    {
        $this
            ->setAuthentication($authentication)
            ->setAutoTaskSetError($autoTaskSetError)
            ->setTransactionID($transactionID);
    }
    /**
     * Get Authentication value
     * @return \StructType\Authentication
     */
    public function getAuthentication()
    {
        return $this->Authentication;
    }
    /**
     * Set Authentication value
     * @param \StructType\Authentication $authentication
     * @return \StructType\S_AUTOTASK_ERROR_SET_V001Request
     */
    public function setAuthentication(\StructType\Authentication $authentication = null)
    {
        $this->Authentication = $authentication;
        return $this;
    }
    /**
     * Get AutoTaskSetError value
     * @return \StructType\AutoTaskSetError
     */
    public function getAutoTaskSetError()
    {
        return $this->AutoTaskSetError;
    }
    /**
     * Set AutoTaskSetError value
     * @param \StructType\AutoTaskSetError $autoTaskSetError
     * @return \StructType\S_AUTOTASK_ERROR_SET_V001Request
     */
    public function setAutoTaskSetError(\StructType\AutoTaskSetError $autoTaskSetError = null)
    {
        $this->AutoTaskSetError = $autoTaskSetError;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_AUTOTASK_ERROR_SET_V001Request
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
}
