<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_BED_CATEGORY_MASTER_FILE_COMMENT_GET_V001Response
 * StructType
 * @subpackage Structs
 */
class S_BED_CATEGORY_MASTER_FILE_COMMENT_GET_V001Response extends AbstractStructBase
{
    /**
     * The Result
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Result
     */
    public $Result;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * The CATEGORY
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CATEGORY[]
     */
    public $CATEGORY;
    /**
     * Constructor method for S_BED_CATEGORY_MASTER_FILE_COMMENT_GET_V001Response
     * @uses S_BED_CATEGORY_MASTER_FILE_COMMENT_GET_V001Response::setResult()
     * @uses S_BED_CATEGORY_MASTER_FILE_COMMENT_GET_V001Response::setTransactionID()
     * @uses S_BED_CATEGORY_MASTER_FILE_COMMENT_GET_V001Response::setCATEGORY()
     * @param \StructType\Result $result
     * @param string $transactionID
     * @param \StructType\CATEGORY[] $cATEGORY
     */
    public function __construct(\StructType\Result $result = null, $transactionID = null, array $cATEGORY = array())
    {
        $this
            ->setResult($result)
            ->setTransactionID($transactionID)
            ->setCATEGORY($cATEGORY);
    }
    /**
     * Get Result value
     * @return \StructType\Result
     */
    public function getResult()
    {
        return $this->Result;
    }
    /**
     * Set Result value
     * @param \StructType\Result $result
     * @return \StructType\S_BED_CATEGORY_MASTER_FILE_COMMENT_GET_V001Response
     */
    public function setResult(\StructType\Result $result = null)
    {
        $this->Result = $result;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_BED_CATEGORY_MASTER_FILE_COMMENT_GET_V001Response
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
    /**
     * Get CATEGORY value
     * @return \StructType\CATEGORY[]|null
     */
    public function getCATEGORY()
    {
        return $this->CATEGORY;
    }
    /**
     * This method is responsible for validating the values passed to the setCATEGORY method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCATEGORY method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCATEGORYForArrayConstraintsFromSetCATEGORY(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $s_BED_CATEGORY_MASTER_FILE_COMMENT_GET_V001ResponseCATEGORYItem) {
            // validation for constraint: itemType
            if (!$s_BED_CATEGORY_MASTER_FILE_COMMENT_GET_V001ResponseCATEGORYItem instanceof \StructType\CATEGORY) {
                $invalidValues[] = is_object($s_BED_CATEGORY_MASTER_FILE_COMMENT_GET_V001ResponseCATEGORYItem) ? get_class($s_BED_CATEGORY_MASTER_FILE_COMMENT_GET_V001ResponseCATEGORYItem) : sprintf('%s(%s)', gettype($s_BED_CATEGORY_MASTER_FILE_COMMENT_GET_V001ResponseCATEGORYItem), var_export($s_BED_CATEGORY_MASTER_FILE_COMMENT_GET_V001ResponseCATEGORYItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CATEGORY property can only contain items of type \StructType\CATEGORY, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CATEGORY value
     * @throws \InvalidArgumentException
     * @param \StructType\CATEGORY[] $cATEGORY
     * @return \StructType\S_BED_CATEGORY_MASTER_FILE_COMMENT_GET_V001Response
     */
    public function setCATEGORY(array $cATEGORY = array())
    {
        // validation for constraint: array
        if ('' !== ($cATEGORYArrayErrorMessage = self::validateCATEGORYForArrayConstraintsFromSetCATEGORY($cATEGORY))) {
            throw new \InvalidArgumentException($cATEGORYArrayErrorMessage, __LINE__);
        }
        $this->CATEGORY = $cATEGORY;
        return $this;
    }
    /**
     * Add item to CATEGORY value
     * @throws \InvalidArgumentException
     * @param \StructType\CATEGORY $item
     * @return \StructType\S_BED_CATEGORY_MASTER_FILE_COMMENT_GET_V001Response
     */
    public function addToCATEGORY(\StructType\CATEGORY $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CATEGORY) {
            throw new \InvalidArgumentException(sprintf('The CATEGORY property can only contain items of type \StructType\CATEGORY, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CATEGORY[] = $item;
        return $this;
    }
}
