<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_CATEGORY_MASTER_FILE_SEARCH_V001Response StructType
 * @subpackage Structs
 */
class S_CATEGORY_MASTER_FILE_SEARCH_V001Response extends AbstractStructBase
{
    /**
     * The Result
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Result
     */
    public $Result;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * The CATEGORIES
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CATEGORIES[]
     */
    public $CATEGORIES;
    /**
     * Constructor method for S_CATEGORY_MASTER_FILE_SEARCH_V001Response
     * @uses S_CATEGORY_MASTER_FILE_SEARCH_V001Response::setResult()
     * @uses S_CATEGORY_MASTER_FILE_SEARCH_V001Response::setTransactionID()
     * @uses S_CATEGORY_MASTER_FILE_SEARCH_V001Response::setCATEGORIES()
     * @param \StructType\Result $result
     * @param string $transactionID
     * @param \StructType\CATEGORIES[] $cATEGORIES
     */
    public function __construct(\StructType\Result $result = null, $transactionID = null, array $cATEGORIES = array())
    {
        $this
            ->setResult($result)
            ->setTransactionID($transactionID)
            ->setCATEGORIES($cATEGORIES);
    }
    /**
     * Get Result value
     * @return \StructType\Result
     */
    public function getResult()
    {
        return $this->Result;
    }
    /**
     * Set Result value
     * @param \StructType\Result $result
     * @return \StructType\S_CATEGORY_MASTER_FILE_SEARCH_V001Response
     */
    public function setResult(\StructType\Result $result = null)
    {
        $this->Result = $result;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_CATEGORY_MASTER_FILE_SEARCH_V001Response
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
    /**
     * Get CATEGORIES value
     * @return \StructType\CATEGORIES[]|null
     */
    public function getCATEGORIES()
    {
        return $this->CATEGORIES;
    }
    /**
     * This method is responsible for validating the values passed to the setCATEGORIES method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCATEGORIES method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCATEGORIESForArrayConstraintsFromSetCATEGORIES(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $s_CATEGORY_MASTER_FILE_SEARCH_V001ResponseCATEGORIESItem) {
            // validation for constraint: itemType
            if (!$s_CATEGORY_MASTER_FILE_SEARCH_V001ResponseCATEGORIESItem instanceof \StructType\CATEGORIES) {
                $invalidValues[] = is_object($s_CATEGORY_MASTER_FILE_SEARCH_V001ResponseCATEGORIESItem) ? get_class($s_CATEGORY_MASTER_FILE_SEARCH_V001ResponseCATEGORIESItem) : sprintf('%s(%s)', gettype($s_CATEGORY_MASTER_FILE_SEARCH_V001ResponseCATEGORIESItem), var_export($s_CATEGORY_MASTER_FILE_SEARCH_V001ResponseCATEGORIESItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CATEGORIES property can only contain items of type \StructType\CATEGORIES, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CATEGORIES value
     * @throws \InvalidArgumentException
     * @param \StructType\CATEGORIES[] $cATEGORIES
     * @return \StructType\S_CATEGORY_MASTER_FILE_SEARCH_V001Response
     */
    public function setCATEGORIES(array $cATEGORIES = array())
    {
        // validation for constraint: array
        if ('' !== ($cATEGORIESArrayErrorMessage = self::validateCATEGORIESForArrayConstraintsFromSetCATEGORIES($cATEGORIES))) {
            throw new \InvalidArgumentException($cATEGORIESArrayErrorMessage, __LINE__);
        }
        $this->CATEGORIES = $cATEGORIES;
        return $this;
    }
    /**
     * Add item to CATEGORIES value
     * @throws \InvalidArgumentException
     * @param \StructType\CATEGORIES $item
     * @return \StructType\S_CATEGORY_MASTER_FILE_SEARCH_V001Response
     */
    public function addToCATEGORIES(\StructType\CATEGORIES $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CATEGORIES) {
            throw new \InvalidArgumentException(sprintf('The CATEGORIES property can only contain items of type \StructType\CATEGORIES, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CATEGORIES[] = $item;
        return $this;
    }
}
