<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_CATEGORY_RESTRICTION_SEARCH_V002Request StructType
 * @subpackage Structs
 */
class S_CATEGORY_RESTRICTION_SEARCH_V002Request extends AbstractStructBase
{
    /**
     * The Authentication
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Authentication
     */
    public $Authentication;
    /**
     * The CATEGORYRESTRICTION_SEARCH
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\CATEGORYRESTRICTION_SEARCH
     */
    public $CATEGORYRESTRICTION_SEARCH;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * Constructor method for S_CATEGORY_RESTRICTION_SEARCH_V002Request
     * @uses S_CATEGORY_RESTRICTION_SEARCH_V002Request::setAuthentication()
     * @uses S_CATEGORY_RESTRICTION_SEARCH_V002Request::setCATEGORYRESTRICTION_SEARCH()
     * @uses S_CATEGORY_RESTRICTION_SEARCH_V002Request::setTransactionID()
     * @param \StructType\Authentication $authentication
     * @param \StructType\CATEGORYRESTRICTION_SEARCH $cATEGORYRESTRICTION_SEARCH
     * @param string $transactionID
     */
    public function __construct(\StructType\Authentication $authentication = null, \StructType\CATEGORYRESTRICTION_SEARCH $cATEGORYRESTRICTION_SEARCH = null, $transactionID = null)
    {
        $this
            ->setAuthentication($authentication)
            ->setCATEGORYRESTRICTION_SEARCH($cATEGORYRESTRICTION_SEARCH)
            ->setTransactionID($transactionID);
    }
    /**
     * Get Authentication value
     * @return \StructType\Authentication
     */
    public function getAuthentication()
    {
        return $this->Authentication;
    }
    /**
     * Set Authentication value
     * @param \StructType\Authentication $authentication
     * @return \StructType\S_CATEGORY_RESTRICTION_SEARCH_V002Request
     */
    public function setAuthentication(\StructType\Authentication $authentication = null)
    {
        $this->Authentication = $authentication;
        return $this;
    }
    /**
     * Get CATEGORYRESTRICTION_SEARCH value
     * @return \StructType\CATEGORYRESTRICTION_SEARCH
     */
    public function getCATEGORYRESTRICTION_SEARCH()
    {
        return $this->{'CATEGORYRESTRICTION-SEARCH'};
    }
    /**
     * Set CATEGORYRESTRICTION_SEARCH value
     * @param \StructType\CATEGORYRESTRICTION_SEARCH $cATEGORYRESTRICTION_SEARCH
     * @return \StructType\S_CATEGORY_RESTRICTION_SEARCH_V002Request
     */
    public function setCATEGORYRESTRICTION_SEARCH(\StructType\CATEGORYRESTRICTION_SEARCH $cATEGORYRESTRICTION_SEARCH = null)
    {
        $this->CATEGORYRESTRICTION_SEARCH = $this->{'CATEGORYRESTRICTION-SEARCH'} = $cATEGORYRESTRICTION_SEARCH;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_CATEGORY_RESTRICTION_SEARCH_V002Request
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
}
