<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_CITY_LEDGER_ACCOUNT_SEARCH_V001Request StructType
 * @subpackage Structs
 */
class S_CITY_LEDGER_ACCOUNT_SEARCH_V001Request extends AbstractStructBase
{
    /**
     * The Authentication
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Authentication
     */
    public $Authentication;
    /**
     * The CITYLEDGER_ACCOUNT_SEARCH
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\CITYLEDGER_ACCOUNT_SEARCH
     */
    public $CITYLEDGER_ACCOUNT_SEARCH;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * Constructor method for S_CITY_LEDGER_ACCOUNT_SEARCH_V001Request
     * @uses S_CITY_LEDGER_ACCOUNT_SEARCH_V001Request::setAuthentication()
     * @uses S_CITY_LEDGER_ACCOUNT_SEARCH_V001Request::setCITYLEDGER_ACCOUNT_SEARCH()
     * @uses S_CITY_LEDGER_ACCOUNT_SEARCH_V001Request::setTransactionID()
     * @param \StructType\Authentication $authentication
     * @param \StructType\CITYLEDGER_ACCOUNT_SEARCH $cITYLEDGER_ACCOUNT_SEARCH
     * @param string $transactionID
     */
    public function __construct(\StructType\Authentication $authentication = null, \StructType\CITYLEDGER_ACCOUNT_SEARCH $cITYLEDGER_ACCOUNT_SEARCH = null, $transactionID = null)
    {
        $this
            ->setAuthentication($authentication)
            ->setCITYLEDGER_ACCOUNT_SEARCH($cITYLEDGER_ACCOUNT_SEARCH)
            ->setTransactionID($transactionID);
    }
    /**
     * Get Authentication value
     * @return \StructType\Authentication
     */
    public function getAuthentication()
    {
        return $this->Authentication;
    }
    /**
     * Set Authentication value
     * @param \StructType\Authentication $authentication
     * @return \StructType\S_CITY_LEDGER_ACCOUNT_SEARCH_V001Request
     */
    public function setAuthentication(\StructType\Authentication $authentication = null)
    {
        $this->Authentication = $authentication;
        return $this;
    }
    /**
     * Get CITYLEDGER_ACCOUNT_SEARCH value
     * @return \StructType\CITYLEDGER_ACCOUNT_SEARCH
     */
    public function getCITYLEDGER_ACCOUNT_SEARCH()
    {
        return $this->{'CITYLEDGER-ACCOUNT-SEARCH'};
    }
    /**
     * Set CITYLEDGER_ACCOUNT_SEARCH value
     * @param \StructType\CITYLEDGER_ACCOUNT_SEARCH $cITYLEDGER_ACCOUNT_SEARCH
     * @return \StructType\S_CITY_LEDGER_ACCOUNT_SEARCH_V001Request
     */
    public function setCITYLEDGER_ACCOUNT_SEARCH(\StructType\CITYLEDGER_ACCOUNT_SEARCH $cITYLEDGER_ACCOUNT_SEARCH = null)
    {
        $this->CITYLEDGER_ACCOUNT_SEARCH = $this->{'CITYLEDGER-ACCOUNT-SEARCH'} = $cITYLEDGER_ACCOUNT_SEARCH;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_CITY_LEDGER_ACCOUNT_SEARCH_V001Request
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
}
