<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_CITY_LEDGER_PAYMENT_APPLY_V001Request StructType
 * @subpackage Structs
 */
class S_CITY_LEDGER_PAYMENT_APPLY_V001Request extends AbstractStructBase
{
    /**
     * The Authentication
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Authentication
     */
    public $Authentication;
    /**
     * The CITYLEDGER_APPLY
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\CITYLEDGER_APPLY
     */
    public $CITYLEDGER_APPLY;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * Constructor method for S_CITY_LEDGER_PAYMENT_APPLY_V001Request
     * @uses S_CITY_LEDGER_PAYMENT_APPLY_V001Request::setAuthentication()
     * @uses S_CITY_LEDGER_PAYMENT_APPLY_V001Request::setCITYLEDGER_APPLY()
     * @uses S_CITY_LEDGER_PAYMENT_APPLY_V001Request::setTransactionID()
     * @param \StructType\Authentication $authentication
     * @param \StructType\CITYLEDGER_APPLY $cITYLEDGER_APPLY
     * @param string $transactionID
     */
    public function __construct(\StructType\Authentication $authentication = null, \StructType\CITYLEDGER_APPLY $cITYLEDGER_APPLY = null, $transactionID = null)
    {
        $this
            ->setAuthentication($authentication)
            ->setCITYLEDGER_APPLY($cITYLEDGER_APPLY)
            ->setTransactionID($transactionID);
    }
    /**
     * Get Authentication value
     * @return \StructType\Authentication
     */
    public function getAuthentication()
    {
        return $this->Authentication;
    }
    /**
     * Set Authentication value
     * @param \StructType\Authentication $authentication
     * @return \StructType\S_CITY_LEDGER_PAYMENT_APPLY_V001Request
     */
    public function setAuthentication(\StructType\Authentication $authentication = null)
    {
        $this->Authentication = $authentication;
        return $this;
    }
    /**
     * Get CITYLEDGER_APPLY value
     * @return \StructType\CITYLEDGER_APPLY
     */
    public function getCITYLEDGER_APPLY()
    {
        return $this->{'CITYLEDGER-APPLY'};
    }
    /**
     * Set CITYLEDGER_APPLY value
     * @param \StructType\CITYLEDGER_APPLY $cITYLEDGER_APPLY
     * @return \StructType\S_CITY_LEDGER_PAYMENT_APPLY_V001Request
     */
    public function setCITYLEDGER_APPLY(\StructType\CITYLEDGER_APPLY $cITYLEDGER_APPLY = null)
    {
        $this->CITYLEDGER_APPLY = $this->{'CITYLEDGER-APPLY'} = $cITYLEDGER_APPLY;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_CITY_LEDGER_PAYMENT_APPLY_V001Request
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
}
