<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_DISCOUNT_SEARCH_V001Response StructType
 * @subpackage Structs
 */
class S_DISCOUNT_SEARCH_V001Response extends AbstractStructBase
{
    /**
     * The Result
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Result
     */
    public $Result;
    /**
     * The DISCOUNTS
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\DISCOUNTS
     */
    public $DISCOUNTS;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * Constructor method for S_DISCOUNT_SEARCH_V001Response
     * @uses S_DISCOUNT_SEARCH_V001Response::setResult()
     * @uses S_DISCOUNT_SEARCH_V001Response::setDISCOUNTS()
     * @uses S_DISCOUNT_SEARCH_V001Response::setTransactionID()
     * @param \StructType\Result $result
     * @param \StructType\DISCOUNTS $dISCOUNTS
     * @param string $transactionID
     */
    public function __construct(\StructType\Result $result = null, \StructType\DISCOUNTS $dISCOUNTS = null, $transactionID = null)
    {
        $this
            ->setResult($result)
            ->setDISCOUNTS($dISCOUNTS)
            ->setTransactionID($transactionID);
    }
    /**
     * Get Result value
     * @return \StructType\Result
     */
    public function getResult()
    {
        return $this->Result;
    }
    /**
     * Set Result value
     * @param \StructType\Result $result
     * @return \StructType\S_DISCOUNT_SEARCH_V001Response
     */
    public function setResult(\StructType\Result $result = null)
    {
        $this->Result = $result;
        return $this;
    }
    /**
     * Get DISCOUNTS value
     * @return \StructType\DISCOUNTS
     */
    public function getDISCOUNTS()
    {
        return $this->DISCOUNTS;
    }
    /**
     * Set DISCOUNTS value
     * @param \StructType\DISCOUNTS $dISCOUNTS
     * @return \StructType\S_DISCOUNT_SEARCH_V001Response
     */
    public function setDISCOUNTS(\StructType\DISCOUNTS $dISCOUNTS = null)
    {
        $this->DISCOUNTS = $dISCOUNTS;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_DISCOUNT_SEARCH_V001Response
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
}
