<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_EVENT_RESERVATION_GET_V001Response StructType
 * @subpackage Structs
 */
class S_EVENT_RESERVATION_GET_V001Response extends AbstractStructBase
{
    /**
     * The Result
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Result
     */
    public $Result;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * The EVENT_RESERVATION
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\EVENT_RESERVATION[]
     */
    public $EVENT_RESERVATION;
    /**
     * Constructor method for S_EVENT_RESERVATION_GET_V001Response
     * @uses S_EVENT_RESERVATION_GET_V001Response::setResult()
     * @uses S_EVENT_RESERVATION_GET_V001Response::setTransactionID()
     * @uses S_EVENT_RESERVATION_GET_V001Response::setEVENT_RESERVATION()
     * @param \StructType\Result $result
     * @param string $transactionID
     * @param \StructType\EVENT_RESERVATION[] $eVENT_RESERVATION
     */
    public function __construct(\StructType\Result $result = null, $transactionID = null, array $eVENT_RESERVATION = array())
    {
        $this
            ->setResult($result)
            ->setTransactionID($transactionID)
            ->setEVENT_RESERVATION($eVENT_RESERVATION);
    }
    /**
     * Get Result value
     * @return \StructType\Result
     */
    public function getResult()
    {
        return $this->Result;
    }
    /**
     * Set Result value
     * @param \StructType\Result $result
     * @return \StructType\S_EVENT_RESERVATION_GET_V001Response
     */
    public function setResult(\StructType\Result $result = null)
    {
        $this->Result = $result;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_EVENT_RESERVATION_GET_V001Response
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
    /**
     * Get EVENT_RESERVATION value
     * @return \StructType\EVENT_RESERVATION[]|null
     */
    public function getEVENT_RESERVATION()
    {
        return $this->{'EVENT-RESERVATION'};
    }
    /**
     * This method is responsible for validating the values passed to the setEVENT_RESERVATION method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEVENT_RESERVATION method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEVENT_RESERVATIONForArrayConstraintsFromSetEVENT_RESERVATION(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $s_EVENT_RESERVATION_GET_V001ResponseEVENT_RESERVATIONItem) {
            // validation for constraint: itemType
            if (!$s_EVENT_RESERVATION_GET_V001ResponseEVENT_RESERVATIONItem instanceof \StructType\EVENT_RESERVATION) {
                $invalidValues[] = is_object($s_EVENT_RESERVATION_GET_V001ResponseEVENT_RESERVATIONItem) ? get_class($s_EVENT_RESERVATION_GET_V001ResponseEVENT_RESERVATIONItem) : sprintf('%s(%s)', gettype($s_EVENT_RESERVATION_GET_V001ResponseEVENT_RESERVATIONItem), var_export($s_EVENT_RESERVATION_GET_V001ResponseEVENT_RESERVATIONItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EVENT_RESERVATION property can only contain items of type \StructType\EVENT_RESERVATION, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EVENT_RESERVATION value
     * @throws \InvalidArgumentException
     * @param \StructType\EVENT_RESERVATION[] $eVENT_RESERVATION
     * @return \StructType\S_EVENT_RESERVATION_GET_V001Response
     */
    public function setEVENT_RESERVATION(array $eVENT_RESERVATION = array())
    {
        // validation for constraint: array
        if ('' !== ($eVENT_RESERVATIONArrayErrorMessage = self::validateEVENT_RESERVATIONForArrayConstraintsFromSetEVENT_RESERVATION($eVENT_RESERVATION))) {
            throw new \InvalidArgumentException($eVENT_RESERVATIONArrayErrorMessage, __LINE__);
        }
        $this->EVENT_RESERVATION = $this->{'EVENT-RESERVATION'} = $eVENT_RESERVATION;
        return $this;
    }
    /**
     * Add item to EVENT_RESERVATION value
     * @throws \InvalidArgumentException
     * @param \StructType\EVENT_RESERVATION $item
     * @return \StructType\S_EVENT_RESERVATION_GET_V001Response
     */
    public function addToEVENT_RESERVATION(\StructType\EVENT_RESERVATION $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EVENT_RESERVATION) {
            throw new \InvalidArgumentException(sprintf('The EVENT_RESERVATION property can only contain items of type \StructType\EVENT_RESERVATION, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EVENT_RESERVATION[] = $this->{'EVENT-RESERVATION'}[] = $item;
        return $this;
    }
}
