<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_EVENT_RESERVATION_NODE_STRUCTURE_GET_V001Response
 * StructType
 * @subpackage Structs
 */
class S_EVENT_RESERVATION_NODE_STRUCTURE_GET_V001Response extends AbstractStructBase
{
    /**
     * The Result
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Result
     */
    public $Result;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * The EventReservation
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\EventReservation[]
     */
    public $EventReservation;
    /**
     * Constructor method for S_EVENT_RESERVATION_NODE_STRUCTURE_GET_V001Response
     * @uses S_EVENT_RESERVATION_NODE_STRUCTURE_GET_V001Response::setResult()
     * @uses S_EVENT_RESERVATION_NODE_STRUCTURE_GET_V001Response::setTransactionID()
     * @uses S_EVENT_RESERVATION_NODE_STRUCTURE_GET_V001Response::setEventReservation()
     * @param \StructType\Result $result
     * @param string $transactionID
     * @param \StructType\EventReservation[] $eventReservation
     */
    public function __construct(\StructType\Result $result = null, $transactionID = null, array $eventReservation = array())
    {
        $this
            ->setResult($result)
            ->setTransactionID($transactionID)
            ->setEventReservation($eventReservation);
    }
    /**
     * Get Result value
     * @return \StructType\Result
     */
    public function getResult()
    {
        return $this->Result;
    }
    /**
     * Set Result value
     * @param \StructType\Result $result
     * @return \StructType\S_EVENT_RESERVATION_NODE_STRUCTURE_GET_V001Response
     */
    public function setResult(\StructType\Result $result = null)
    {
        $this->Result = $result;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_EVENT_RESERVATION_NODE_STRUCTURE_GET_V001Response
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
    /**
     * Get EventReservation value
     * @return \StructType\EventReservation[]|null
     */
    public function getEventReservation()
    {
        return $this->EventReservation;
    }
    /**
     * This method is responsible for validating the values passed to the setEventReservation method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEventReservation method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEventReservationForArrayConstraintsFromSetEventReservation(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $s_EVENT_RESERVATION_NODE_STRUCTURE_GET_V001ResponseEventReservationItem) {
            // validation for constraint: itemType
            if (!$s_EVENT_RESERVATION_NODE_STRUCTURE_GET_V001ResponseEventReservationItem instanceof \StructType\EventReservation) {
                $invalidValues[] = is_object($s_EVENT_RESERVATION_NODE_STRUCTURE_GET_V001ResponseEventReservationItem) ? get_class($s_EVENT_RESERVATION_NODE_STRUCTURE_GET_V001ResponseEventReservationItem) : sprintf('%s(%s)', gettype($s_EVENT_RESERVATION_NODE_STRUCTURE_GET_V001ResponseEventReservationItem), var_export($s_EVENT_RESERVATION_NODE_STRUCTURE_GET_V001ResponseEventReservationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EventReservation property can only contain items of type \StructType\EventReservation, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EventReservation value
     * @throws \InvalidArgumentException
     * @param \StructType\EventReservation[] $eventReservation
     * @return \StructType\S_EVENT_RESERVATION_NODE_STRUCTURE_GET_V001Response
     */
    public function setEventReservation(array $eventReservation = array())
    {
        // validation for constraint: array
        if ('' !== ($eventReservationArrayErrorMessage = self::validateEventReservationForArrayConstraintsFromSetEventReservation($eventReservation))) {
            throw new \InvalidArgumentException($eventReservationArrayErrorMessage, __LINE__);
        }
        $this->EventReservation = $eventReservation;
        return $this;
    }
    /**
     * Add item to EventReservation value
     * @throws \InvalidArgumentException
     * @param \StructType\EventReservation $item
     * @return \StructType\S_EVENT_RESERVATION_NODE_STRUCTURE_GET_V001Response
     */
    public function addToEventReservation(\StructType\EventReservation $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EventReservation) {
            throw new \InvalidArgumentException(sprintf('The EventReservation property can only contain items of type \StructType\EventReservation, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EventReservation[] = $item;
        return $this;
    }
}
