<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_EVENT_RESERVATION_ROOM_GET_V001Response StructType
 * @subpackage Structs
 */
class S_EVENT_RESERVATION_ROOM_GET_V001Response extends AbstractStructBase
{
    /**
     * The Result
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Result
     */
    public $Result;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * The EVENT_ROOMS
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\EVENT_ROOMS[]
     */
    public $EVENT_ROOMS;
    /**
     * Constructor method for S_EVENT_RESERVATION_ROOM_GET_V001Response
     * @uses S_EVENT_RESERVATION_ROOM_GET_V001Response::setResult()
     * @uses S_EVENT_RESERVATION_ROOM_GET_V001Response::setTransactionID()
     * @uses S_EVENT_RESERVATION_ROOM_GET_V001Response::setEVENT_ROOMS()
     * @param \StructType\Result $result
     * @param string $transactionID
     * @param \StructType\EVENT_ROOMS[] $eVENT_ROOMS
     */
    public function __construct(\StructType\Result $result = null, $transactionID = null, array $eVENT_ROOMS = array())
    {
        $this
            ->setResult($result)
            ->setTransactionID($transactionID)
            ->setEVENT_ROOMS($eVENT_ROOMS);
    }
    /**
     * Get Result value
     * @return \StructType\Result
     */
    public function getResult()
    {
        return $this->Result;
    }
    /**
     * Set Result value
     * @param \StructType\Result $result
     * @return \StructType\S_EVENT_RESERVATION_ROOM_GET_V001Response
     */
    public function setResult(\StructType\Result $result = null)
    {
        $this->Result = $result;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_EVENT_RESERVATION_ROOM_GET_V001Response
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
    /**
     * Get EVENT_ROOMS value
     * @return \StructType\EVENT_ROOMS[]|null
     */
    public function getEVENT_ROOMS()
    {
        return $this->{'EVENT-ROOMS'};
    }
    /**
     * This method is responsible for validating the values passed to the setEVENT_ROOMS method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEVENT_ROOMS method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEVENT_ROOMSForArrayConstraintsFromSetEVENT_ROOMS(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $s_EVENT_RESERVATION_ROOM_GET_V001ResponseEVENT_ROOMSItem) {
            // validation for constraint: itemType
            if (!$s_EVENT_RESERVATION_ROOM_GET_V001ResponseEVENT_ROOMSItem instanceof \StructType\EVENT_ROOMS) {
                $invalidValues[] = is_object($s_EVENT_RESERVATION_ROOM_GET_V001ResponseEVENT_ROOMSItem) ? get_class($s_EVENT_RESERVATION_ROOM_GET_V001ResponseEVENT_ROOMSItem) : sprintf('%s(%s)', gettype($s_EVENT_RESERVATION_ROOM_GET_V001ResponseEVENT_ROOMSItem), var_export($s_EVENT_RESERVATION_ROOM_GET_V001ResponseEVENT_ROOMSItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EVENT_ROOMS property can only contain items of type \StructType\EVENT_ROOMS, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EVENT_ROOMS value
     * @throws \InvalidArgumentException
     * @param \StructType\EVENT_ROOMS[] $eVENT_ROOMS
     * @return \StructType\S_EVENT_RESERVATION_ROOM_GET_V001Response
     */
    public function setEVENT_ROOMS(array $eVENT_ROOMS = array())
    {
        // validation for constraint: array
        if ('' !== ($eVENT_ROOMSArrayErrorMessage = self::validateEVENT_ROOMSForArrayConstraintsFromSetEVENT_ROOMS($eVENT_ROOMS))) {
            throw new \InvalidArgumentException($eVENT_ROOMSArrayErrorMessage, __LINE__);
        }
        $this->EVENT_ROOMS = $this->{'EVENT-ROOMS'} = $eVENT_ROOMS;
        return $this;
    }
    /**
     * Add item to EVENT_ROOMS value
     * @throws \InvalidArgumentException
     * @param \StructType\EVENT_ROOMS $item
     * @return \StructType\S_EVENT_RESERVATION_ROOM_GET_V001Response
     */
    public function addToEVENT_ROOMS(\StructType\EVENT_ROOMS $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EVENT_ROOMS) {
            throw new \InvalidArgumentException(sprintf('The EVENT_ROOMS property can only contain items of type \StructType\EVENT_ROOMS, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EVENT_ROOMS[] = $this->{'EVENT-ROOMS'}[] = $item;
        return $this;
    }
}
