<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_EVENT_RESERVATION_SEARCH_V001Response StructType
 * @subpackage Structs
 */
class S_EVENT_RESERVATION_SEARCH_V001Response extends AbstractStructBase
{
    /**
     * The Result
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Result
     */
    public $Result;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * The EVENT_RESERVATIONS
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\EVENT_RESERVATIONS[]
     */
    public $EVENT_RESERVATIONS;
    /**
     * Constructor method for S_EVENT_RESERVATION_SEARCH_V001Response
     * @uses S_EVENT_RESERVATION_SEARCH_V001Response::setResult()
     * @uses S_EVENT_RESERVATION_SEARCH_V001Response::setTransactionID()
     * @uses S_EVENT_RESERVATION_SEARCH_V001Response::setEVENT_RESERVATIONS()
     * @param \StructType\Result $result
     * @param string $transactionID
     * @param \StructType\EVENT_RESERVATIONS[] $eVENT_RESERVATIONS
     */
    public function __construct(\StructType\Result $result = null, $transactionID = null, array $eVENT_RESERVATIONS = array())
    {
        $this
            ->setResult($result)
            ->setTransactionID($transactionID)
            ->setEVENT_RESERVATIONS($eVENT_RESERVATIONS);
    }
    /**
     * Get Result value
     * @return \StructType\Result
     */
    public function getResult()
    {
        return $this->Result;
    }
    /**
     * Set Result value
     * @param \StructType\Result $result
     * @return \StructType\S_EVENT_RESERVATION_SEARCH_V001Response
     */
    public function setResult(\StructType\Result $result = null)
    {
        $this->Result = $result;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_EVENT_RESERVATION_SEARCH_V001Response
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
    /**
     * Get EVENT_RESERVATIONS value
     * @return \StructType\EVENT_RESERVATIONS[]|null
     */
    public function getEVENT_RESERVATIONS()
    {
        return $this->{'EVENT-RESERVATIONS'};
    }
    /**
     * This method is responsible for validating the values passed to the setEVENT_RESERVATIONS method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEVENT_RESERVATIONS method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEVENT_RESERVATIONSForArrayConstraintsFromSetEVENT_RESERVATIONS(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $s_EVENT_RESERVATION_SEARCH_V001ResponseEVENT_RESERVATIONSItem) {
            // validation for constraint: itemType
            if (!$s_EVENT_RESERVATION_SEARCH_V001ResponseEVENT_RESERVATIONSItem instanceof \StructType\EVENT_RESERVATIONS) {
                $invalidValues[] = is_object($s_EVENT_RESERVATION_SEARCH_V001ResponseEVENT_RESERVATIONSItem) ? get_class($s_EVENT_RESERVATION_SEARCH_V001ResponseEVENT_RESERVATIONSItem) : sprintf('%s(%s)', gettype($s_EVENT_RESERVATION_SEARCH_V001ResponseEVENT_RESERVATIONSItem), var_export($s_EVENT_RESERVATION_SEARCH_V001ResponseEVENT_RESERVATIONSItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EVENT_RESERVATIONS property can only contain items of type \StructType\EVENT_RESERVATIONS, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EVENT_RESERVATIONS value
     * @throws \InvalidArgumentException
     * @param \StructType\EVENT_RESERVATIONS[] $eVENT_RESERVATIONS
     * @return \StructType\S_EVENT_RESERVATION_SEARCH_V001Response
     */
    public function setEVENT_RESERVATIONS(array $eVENT_RESERVATIONS = array())
    {
        // validation for constraint: array
        if ('' !== ($eVENT_RESERVATIONSArrayErrorMessage = self::validateEVENT_RESERVATIONSForArrayConstraintsFromSetEVENT_RESERVATIONS($eVENT_RESERVATIONS))) {
            throw new \InvalidArgumentException($eVENT_RESERVATIONSArrayErrorMessage, __LINE__);
        }
        $this->EVENT_RESERVATIONS = $this->{'EVENT-RESERVATIONS'} = $eVENT_RESERVATIONS;
        return $this;
    }
    /**
     * Add item to EVENT_RESERVATIONS value
     * @throws \InvalidArgumentException
     * @param \StructType\EVENT_RESERVATIONS $item
     * @return \StructType\S_EVENT_RESERVATION_SEARCH_V001Response
     */
    public function addToEVENT_RESERVATIONS(\StructType\EVENT_RESERVATIONS $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EVENT_RESERVATIONS) {
            throw new \InvalidArgumentException(sprintf('The EVENT_RESERVATIONS property can only contain items of type \StructType\EVENT_RESERVATIONS, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EVENT_RESERVATIONS[] = $this->{'EVENT-RESERVATIONS'}[] = $item;
        return $this;
    }
}
