<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_EVENT_RESERVATION_SERVICE_ADD_V001Request StructType
 * @subpackage Structs
 */
class S_EVENT_RESERVATION_SERVICE_ADD_V001Request extends AbstractStructBase
{
    /**
     * The Authentication
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Authentication
     */
    public $Authentication;
    /**
     * The EventRes
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\EventRes
     */
    public $EventRes;
    /**
     * The Service
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Service
     */
    public $Service;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * Constructor method for S_EVENT_RESERVATION_SERVICE_ADD_V001Request
     * @uses S_EVENT_RESERVATION_SERVICE_ADD_V001Request::setAuthentication()
     * @uses S_EVENT_RESERVATION_SERVICE_ADD_V001Request::setEventRes()
     * @uses S_EVENT_RESERVATION_SERVICE_ADD_V001Request::setService()
     * @uses S_EVENT_RESERVATION_SERVICE_ADD_V001Request::setTransactionID()
     * @param \StructType\Authentication $authentication
     * @param \StructType\EventRes $eventRes
     * @param \StructType\Service $service
     * @param string $transactionID
     */
    public function __construct(\StructType\Authentication $authentication = null, \StructType\EventRes $eventRes = null, \StructType\Service $service = null, $transactionID = null)
    {
        $this
            ->setAuthentication($authentication)
            ->setEventRes($eventRes)
            ->setService($service)
            ->setTransactionID($transactionID);
    }
    /**
     * Get Authentication value
     * @return \StructType\Authentication
     */
    public function getAuthentication()
    {
        return $this->Authentication;
    }
    /**
     * Set Authentication value
     * @param \StructType\Authentication $authentication
     * @return \StructType\S_EVENT_RESERVATION_SERVICE_ADD_V001Request
     */
    public function setAuthentication(\StructType\Authentication $authentication = null)
    {
        $this->Authentication = $authentication;
        return $this;
    }
    /**
     * Get EventRes value
     * @return \StructType\EventRes
     */
    public function getEventRes()
    {
        return $this->EventRes;
    }
    /**
     * Set EventRes value
     * @param \StructType\EventRes $eventRes
     * @return \StructType\S_EVENT_RESERVATION_SERVICE_ADD_V001Request
     */
    public function setEventRes(\StructType\EventRes $eventRes = null)
    {
        $this->EventRes = $eventRes;
        return $this;
    }
    /**
     * Get Service value
     * @return \StructType\Service
     */
    public function getService()
    {
        return $this->Service;
    }
    /**
     * Set Service value
     * @param \StructType\Service $service
     * @return \StructType\S_EVENT_RESERVATION_SERVICE_ADD_V001Request
     */
    public function setService(\StructType\Service $service = null)
    {
        $this->Service = $service;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_EVENT_RESERVATION_SERVICE_ADD_V001Request
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
}
