<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for
 * S_EVENT_ROOM_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001Response StructType
 * @subpackage Structs
 */
class S_EVENT_ROOM_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001Response extends AbstractStructBase
{
    /**
     * The Result
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Result
     */
    public $Result;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * The EventRoomMasterFiles
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\EventRoomMasterFiles[]
     */
    public $EventRoomMasterFiles;
    /**
     * Constructor method for
     * S_EVENT_ROOM_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001Response
     * @uses S_EVENT_ROOM_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001Response::setResult()
     * @uses S_EVENT_ROOM_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001Response::setTransactionID()
     * @uses S_EVENT_ROOM_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001Response::setEventRoomMasterFiles()
     * @param \StructType\Result $result
     * @param string $transactionID
     * @param \StructType\EventRoomMasterFiles[] $eventRoomMasterFiles
     */
    public function __construct(\StructType\Result $result = null, $transactionID = null, array $eventRoomMasterFiles = array())
    {
        $this
            ->setResult($result)
            ->setTransactionID($transactionID)
            ->setEventRoomMasterFiles($eventRoomMasterFiles);
    }
    /**
     * Get Result value
     * @return \StructType\Result
     */
    public function getResult()
    {
        return $this->Result;
    }
    /**
     * Set Result value
     * @param \StructType\Result $result
     * @return \StructType\S_EVENT_ROOM_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001Response
     */
    public function setResult(\StructType\Result $result = null)
    {
        $this->Result = $result;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_EVENT_ROOM_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001Response
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
    /**
     * Get EventRoomMasterFiles value
     * @return \StructType\EventRoomMasterFiles[]|null
     */
    public function getEventRoomMasterFiles()
    {
        return $this->EventRoomMasterFiles;
    }
    /**
     * This method is responsible for validating the values passed to the setEventRoomMasterFiles method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEventRoomMasterFiles method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEventRoomMasterFilesForArrayConstraintsFromSetEventRoomMasterFiles(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $s_EVENT_ROOM_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001ResponseEventRoomMasterFilesItem) {
            // validation for constraint: itemType
            if (!$s_EVENT_ROOM_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001ResponseEventRoomMasterFilesItem instanceof \StructType\EventRoomMasterFiles) {
                $invalidValues[] = is_object($s_EVENT_ROOM_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001ResponseEventRoomMasterFilesItem) ? get_class($s_EVENT_ROOM_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001ResponseEventRoomMasterFilesItem) : sprintf('%s(%s)', gettype($s_EVENT_ROOM_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001ResponseEventRoomMasterFilesItem), var_export($s_EVENT_ROOM_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001ResponseEventRoomMasterFilesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EventRoomMasterFiles property can only contain items of type \StructType\EventRoomMasterFiles, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EventRoomMasterFiles value
     * @throws \InvalidArgumentException
     * @param \StructType\EventRoomMasterFiles[] $eventRoomMasterFiles
     * @return \StructType\S_EVENT_ROOM_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001Response
     */
    public function setEventRoomMasterFiles(array $eventRoomMasterFiles = array())
    {
        // validation for constraint: array
        if ('' !== ($eventRoomMasterFilesArrayErrorMessage = self::validateEventRoomMasterFilesForArrayConstraintsFromSetEventRoomMasterFiles($eventRoomMasterFiles))) {
            throw new \InvalidArgumentException($eventRoomMasterFilesArrayErrorMessage, __LINE__);
        }
        $this->EventRoomMasterFiles = $eventRoomMasterFiles;
        return $this;
    }
    /**
     * Add item to EventRoomMasterFiles value
     * @throws \InvalidArgumentException
     * @param \StructType\EventRoomMasterFiles $item
     * @return \StructType\S_EVENT_ROOM_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001Response
     */
    public function addToEventRoomMasterFiles(\StructType\EventRoomMasterFiles $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EventRoomMasterFiles) {
            throw new \InvalidArgumentException(sprintf('The EventRoomMasterFiles property can only contain items of type \StructType\EventRoomMasterFiles, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EventRoomMasterFiles[] = $item;
        return $this;
    }
}
