<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_GIFTVOUCHER_SEARCH_V002Response StructType
 * @subpackage Structs
 */
class S_GIFTVOUCHER_SEARCH_V002Response extends AbstractStructBase
{
    /**
     * The Result
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Result
     */
    public $Result;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * The Giftvoucher
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Giftvoucher[]
     */
    public $Giftvoucher;
    /**
     * Constructor method for S_GIFTVOUCHER_SEARCH_V002Response
     * @uses S_GIFTVOUCHER_SEARCH_V002Response::setResult()
     * @uses S_GIFTVOUCHER_SEARCH_V002Response::setTransactionID()
     * @uses S_GIFTVOUCHER_SEARCH_V002Response::setGiftvoucher()
     * @param \StructType\Result $result
     * @param string $transactionID
     * @param \StructType\Giftvoucher[] $giftvoucher
     */
    public function __construct(\StructType\Result $result = null, $transactionID = null, array $giftvoucher = array())
    {
        $this
            ->setResult($result)
            ->setTransactionID($transactionID)
            ->setGiftvoucher($giftvoucher);
    }
    /**
     * Get Result value
     * @return \StructType\Result
     */
    public function getResult()
    {
        return $this->Result;
    }
    /**
     * Set Result value
     * @param \StructType\Result $result
     * @return \StructType\S_GIFTVOUCHER_SEARCH_V002Response
     */
    public function setResult(\StructType\Result $result = null)
    {
        $this->Result = $result;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_GIFTVOUCHER_SEARCH_V002Response
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
    /**
     * Get Giftvoucher value
     * @return \StructType\Giftvoucher[]|null
     */
    public function getGiftvoucher()
    {
        return $this->Giftvoucher;
    }
    /**
     * This method is responsible for validating the values passed to the setGiftvoucher method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGiftvoucher method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGiftvoucherForArrayConstraintsFromSetGiftvoucher(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $s_GIFTVOUCHER_SEARCH_V002ResponseGiftvoucherItem) {
            // validation for constraint: itemType
            if (!$s_GIFTVOUCHER_SEARCH_V002ResponseGiftvoucherItem instanceof \StructType\Giftvoucher) {
                $invalidValues[] = is_object($s_GIFTVOUCHER_SEARCH_V002ResponseGiftvoucherItem) ? get_class($s_GIFTVOUCHER_SEARCH_V002ResponseGiftvoucherItem) : sprintf('%s(%s)', gettype($s_GIFTVOUCHER_SEARCH_V002ResponseGiftvoucherItem), var_export($s_GIFTVOUCHER_SEARCH_V002ResponseGiftvoucherItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Giftvoucher property can only contain items of type \StructType\Giftvoucher, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Giftvoucher value
     * @throws \InvalidArgumentException
     * @param \StructType\Giftvoucher[] $giftvoucher
     * @return \StructType\S_GIFTVOUCHER_SEARCH_V002Response
     */
    public function setGiftvoucher(array $giftvoucher = array())
    {
        // validation for constraint: array
        if ('' !== ($giftvoucherArrayErrorMessage = self::validateGiftvoucherForArrayConstraintsFromSetGiftvoucher($giftvoucher))) {
            throw new \InvalidArgumentException($giftvoucherArrayErrorMessage, __LINE__);
        }
        $this->Giftvoucher = $giftvoucher;
        return $this;
    }
    /**
     * Add item to Giftvoucher value
     * @throws \InvalidArgumentException
     * @param \StructType\Giftvoucher $item
     * @return \StructType\S_GIFTVOUCHER_SEARCH_V002Response
     */
    public function addToGiftvoucher(\StructType\Giftvoucher $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Giftvoucher) {
            throw new \InvalidArgumentException(sprintf('The Giftvoucher property can only contain items of type \StructType\Giftvoucher, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Giftvoucher[] = $item;
        return $this;
    }
}
