<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_GIFT_VOUCHER_REDEEM_V001Response StructType
 * @subpackage Structs
 */
class S_GIFT_VOUCHER_REDEEM_V001Response extends AbstractStructBase
{
    /**
     * The Result
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Result
     */
    public $Result;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * The RedeemedGiftvoucher
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\RedeemedGiftvoucher[]
     */
    public $RedeemedGiftvoucher;
    /**
     * Constructor method for S_GIFT_VOUCHER_REDEEM_V001Response
     * @uses S_GIFT_VOUCHER_REDEEM_V001Response::setResult()
     * @uses S_GIFT_VOUCHER_REDEEM_V001Response::setTransactionID()
     * @uses S_GIFT_VOUCHER_REDEEM_V001Response::setRedeemedGiftvoucher()
     * @param \StructType\Result $result
     * @param string $transactionID
     * @param \StructType\RedeemedGiftvoucher[] $redeemedGiftvoucher
     */
    public function __construct(\StructType\Result $result = null, $transactionID = null, array $redeemedGiftvoucher = array())
    {
        $this
            ->setResult($result)
            ->setTransactionID($transactionID)
            ->setRedeemedGiftvoucher($redeemedGiftvoucher);
    }
    /**
     * Get Result value
     * @return \StructType\Result
     */
    public function getResult()
    {
        return $this->Result;
    }
    /**
     * Set Result value
     * @param \StructType\Result $result
     * @return \StructType\S_GIFT_VOUCHER_REDEEM_V001Response
     */
    public function setResult(\StructType\Result $result = null)
    {
        $this->Result = $result;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_GIFT_VOUCHER_REDEEM_V001Response
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
    /**
     * Get RedeemedGiftvoucher value
     * @return \StructType\RedeemedGiftvoucher[]|null
     */
    public function getRedeemedGiftvoucher()
    {
        return $this->RedeemedGiftvoucher;
    }
    /**
     * This method is responsible for validating the values passed to the setRedeemedGiftvoucher method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRedeemedGiftvoucher method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRedeemedGiftvoucherForArrayConstraintsFromSetRedeemedGiftvoucher(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $s_GIFT_VOUCHER_REDEEM_V001ResponseRedeemedGiftvoucherItem) {
            // validation for constraint: itemType
            if (!$s_GIFT_VOUCHER_REDEEM_V001ResponseRedeemedGiftvoucherItem instanceof \StructType\RedeemedGiftvoucher) {
                $invalidValues[] = is_object($s_GIFT_VOUCHER_REDEEM_V001ResponseRedeemedGiftvoucherItem) ? get_class($s_GIFT_VOUCHER_REDEEM_V001ResponseRedeemedGiftvoucherItem) : sprintf('%s(%s)', gettype($s_GIFT_VOUCHER_REDEEM_V001ResponseRedeemedGiftvoucherItem), var_export($s_GIFT_VOUCHER_REDEEM_V001ResponseRedeemedGiftvoucherItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RedeemedGiftvoucher property can only contain items of type \StructType\RedeemedGiftvoucher, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RedeemedGiftvoucher value
     * @throws \InvalidArgumentException
     * @param \StructType\RedeemedGiftvoucher[] $redeemedGiftvoucher
     * @return \StructType\S_GIFT_VOUCHER_REDEEM_V001Response
     */
    public function setRedeemedGiftvoucher(array $redeemedGiftvoucher = array())
    {
        // validation for constraint: array
        if ('' !== ($redeemedGiftvoucherArrayErrorMessage = self::validateRedeemedGiftvoucherForArrayConstraintsFromSetRedeemedGiftvoucher($redeemedGiftvoucher))) {
            throw new \InvalidArgumentException($redeemedGiftvoucherArrayErrorMessage, __LINE__);
        }
        $this->RedeemedGiftvoucher = $redeemedGiftvoucher;
        return $this;
    }
    /**
     * Add item to RedeemedGiftvoucher value
     * @throws \InvalidArgumentException
     * @param \StructType\RedeemedGiftvoucher $item
     * @return \StructType\S_GIFT_VOUCHER_REDEEM_V001Response
     */
    public function addToRedeemedGiftvoucher(\StructType\RedeemedGiftvoucher $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RedeemedGiftvoucher) {
            throw new \InvalidArgumentException(sprintf('The RedeemedGiftvoucher property can only contain items of type \StructType\RedeemedGiftvoucher, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RedeemedGiftvoucher[] = $item;
        return $this;
    }
}
