<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_GO_GST_EXTERNALID_DELETE_V001Request StructType
 * @subpackage Structs
 */
class S_GO_GST_EXTERNALID_DELETE_V001Request extends AbstractStructBase
{
    /**
     * The Authentication
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Authentication
     */
    public $Authentication;
    /**
     * The Gst
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Gst
     */
    public $Gst;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * Constructor method for S_GO_GST_EXTERNALID_DELETE_V001Request
     * @uses S_GO_GST_EXTERNALID_DELETE_V001Request::setAuthentication()
     * @uses S_GO_GST_EXTERNALID_DELETE_V001Request::setGst()
     * @uses S_GO_GST_EXTERNALID_DELETE_V001Request::setTransactionID()
     * @param \StructType\Authentication $authentication
     * @param \StructType\Gst $gst
     * @param string $transactionID
     */
    public function __construct(\StructType\Authentication $authentication = null, \StructType\Gst $gst = null, $transactionID = null)
    {
        $this
            ->setAuthentication($authentication)
            ->setGst($gst)
            ->setTransactionID($transactionID);
    }
    /**
     * Get Authentication value
     * @return \StructType\Authentication
     */
    public function getAuthentication()
    {
        return $this->Authentication;
    }
    /**
     * Set Authentication value
     * @param \StructType\Authentication $authentication
     * @return \StructType\S_GO_GST_EXTERNALID_DELETE_V001Request
     */
    public function setAuthentication(\StructType\Authentication $authentication = null)
    {
        $this->Authentication = $authentication;
        return $this;
    }
    /**
     * Get Gst value
     * @return \StructType\Gst
     */
    public function getGst()
    {
        return $this->Gst;
    }
    /**
     * Set Gst value
     * @param \StructType\Gst $gst
     * @return \StructType\S_GO_GST_EXTERNALID_DELETE_V001Request
     */
    public function setGst(\StructType\Gst $gst = null)
    {
        $this->Gst = $gst;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_GO_GST_EXTERNALID_DELETE_V001Request
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
}
