<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_GO_GST_EXTERNALID_DELETE_V001Response StructType
 * @subpackage Structs
 */
class S_GO_GST_EXTERNALID_DELETE_V001Response extends AbstractStructBase
{
    /**
     * The Result
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Result
     */
    public $Result;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * The Gst
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Gst[]
     */
    public $Gst;
    /**
     * Constructor method for S_GO_GST_EXTERNALID_DELETE_V001Response
     * @uses S_GO_GST_EXTERNALID_DELETE_V001Response::setResult()
     * @uses S_GO_GST_EXTERNALID_DELETE_V001Response::setTransactionID()
     * @uses S_GO_GST_EXTERNALID_DELETE_V001Response::setGst()
     * @param \StructType\Result $result
     * @param string $transactionID
     * @param \StructType\Gst[] $gst
     */
    public function __construct(\StructType\Result $result = null, $transactionID = null, array $gst = array())
    {
        $this
            ->setResult($result)
            ->setTransactionID($transactionID)
            ->setGst($gst);
    }
    /**
     * Get Result value
     * @return \StructType\Result
     */
    public function getResult()
    {
        return $this->Result;
    }
    /**
     * Set Result value
     * @param \StructType\Result $result
     * @return \StructType\S_GO_GST_EXTERNALID_DELETE_V001Response
     */
    public function setResult(\StructType\Result $result = null)
    {
        $this->Result = $result;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_GO_GST_EXTERNALID_DELETE_V001Response
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
    /**
     * Get Gst value
     * @return \StructType\Gst[]|null
     */
    public function getGst()
    {
        return $this->Gst;
    }
    /**
     * This method is responsible for validating the values passed to the setGst method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGst method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGstForArrayConstraintsFromSetGst(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $s_GO_GST_EXTERNALID_DELETE_V001ResponseGstItem) {
            // validation for constraint: itemType
            if (!$s_GO_GST_EXTERNALID_DELETE_V001ResponseGstItem instanceof \StructType\Gst) {
                $invalidValues[] = is_object($s_GO_GST_EXTERNALID_DELETE_V001ResponseGstItem) ? get_class($s_GO_GST_EXTERNALID_DELETE_V001ResponseGstItem) : sprintf('%s(%s)', gettype($s_GO_GST_EXTERNALID_DELETE_V001ResponseGstItem), var_export($s_GO_GST_EXTERNALID_DELETE_V001ResponseGstItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Gst property can only contain items of type \StructType\Gst, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Gst value
     * @throws \InvalidArgumentException
     * @param \StructType\Gst[] $gst
     * @return \StructType\S_GO_GST_EXTERNALID_DELETE_V001Response
     */
    public function setGst(array $gst = array())
    {
        // validation for constraint: array
        if ('' !== ($gstArrayErrorMessage = self::validateGstForArrayConstraintsFromSetGst($gst))) {
            throw new \InvalidArgumentException($gstArrayErrorMessage, __LINE__);
        }
        $this->Gst = $gst;
        return $this;
    }
    /**
     * Add item to Gst value
     * @throws \InvalidArgumentException
     * @param \StructType\Gst $item
     * @return \StructType\S_GO_GST_EXTERNALID_DELETE_V001Response
     */
    public function addToGst(\StructType\Gst $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Gst) {
            throw new \InvalidArgumentException(sprintf('The Gst property can only contain items of type \StructType\Gst, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Gst[] = $item;
        return $this;
    }
}
