<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_GO_UPSELLSERVICES_POSSIBLE_V001Response StructType
 * @subpackage Structs
 */
class S_GO_UPSELLSERVICES_POSSIBLE_V001Response extends AbstractStructBase
{
    /**
     * The Result
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Result
     */
    public $Result;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * The Person
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Person[]
     */
    public $Person;
    /**
     * Constructor method for S_GO_UPSELLSERVICES_POSSIBLE_V001Response
     * @uses S_GO_UPSELLSERVICES_POSSIBLE_V001Response::setResult()
     * @uses S_GO_UPSELLSERVICES_POSSIBLE_V001Response::setTransactionID()
     * @uses S_GO_UPSELLSERVICES_POSSIBLE_V001Response::setPerson()
     * @param \StructType\Result $result
     * @param string $transactionID
     * @param \StructType\Person[] $person
     */
    public function __construct(\StructType\Result $result = null, $transactionID = null, array $person = array())
    {
        $this
            ->setResult($result)
            ->setTransactionID($transactionID)
            ->setPerson($person);
    }
    /**
     * Get Result value
     * @return \StructType\Result
     */
    public function getResult()
    {
        return $this->Result;
    }
    /**
     * Set Result value
     * @param \StructType\Result $result
     * @return \StructType\S_GO_UPSELLSERVICES_POSSIBLE_V001Response
     */
    public function setResult(\StructType\Result $result = null)
    {
        $this->Result = $result;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_GO_UPSELLSERVICES_POSSIBLE_V001Response
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
    /**
     * Get Person value
     * @return \StructType\Person[]|null
     */
    public function getPerson()
    {
        return $this->Person;
    }
    /**
     * This method is responsible for validating the values passed to the setPerson method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPerson method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePersonForArrayConstraintsFromSetPerson(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $s_GO_UPSELLSERVICES_POSSIBLE_V001ResponsePersonItem) {
            // validation for constraint: itemType
            if (!$s_GO_UPSELLSERVICES_POSSIBLE_V001ResponsePersonItem instanceof \StructType\Person) {
                $invalidValues[] = is_object($s_GO_UPSELLSERVICES_POSSIBLE_V001ResponsePersonItem) ? get_class($s_GO_UPSELLSERVICES_POSSIBLE_V001ResponsePersonItem) : sprintf('%s(%s)', gettype($s_GO_UPSELLSERVICES_POSSIBLE_V001ResponsePersonItem), var_export($s_GO_UPSELLSERVICES_POSSIBLE_V001ResponsePersonItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Person property can only contain items of type \StructType\Person, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Person value
     * @throws \InvalidArgumentException
     * @param \StructType\Person[] $person
     * @return \StructType\S_GO_UPSELLSERVICES_POSSIBLE_V001Response
     */
    public function setPerson(array $person = array())
    {
        // validation for constraint: array
        if ('' !== ($personArrayErrorMessage = self::validatePersonForArrayConstraintsFromSetPerson($person))) {
            throw new \InvalidArgumentException($personArrayErrorMessage, __LINE__);
        }
        $this->Person = $person;
        return $this;
    }
    /**
     * Add item to Person value
     * @throws \InvalidArgumentException
     * @param \StructType\Person $item
     * @return \StructType\S_GO_UPSELLSERVICES_POSSIBLE_V001Response
     */
    public function addToPerson(\StructType\Person $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Person) {
            throw new \InvalidArgumentException(sprintf('The Person property can only contain items of type \StructType\Person, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Person[] = $item;
        return $this;
    }
}
