<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_GUEST_CRITERIA_SEARCH_V001Request StructType
 * @subpackage Structs
 */
class S_GUEST_CRITERIA_SEARCH_V001Request extends AbstractStructBase
{
    /**
     * The Authentication
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Authentication
     */
    public $Authentication;
    /**
     * The SearchCriteria
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\SearchCriteria
     */
    public $SearchCriteria;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * The SearchCriteria1
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\SearchCriteria1
     */
    public $SearchCriteria1;
    /**
     * The SearchCriteria2
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\SearchCriteria2
     */
    public $SearchCriteria2;
    /**
     * Constructor method for S_GUEST_CRITERIA_SEARCH_V001Request
     * @uses S_GUEST_CRITERIA_SEARCH_V001Request::setAuthentication()
     * @uses S_GUEST_CRITERIA_SEARCH_V001Request::setSearchCriteria()
     * @uses S_GUEST_CRITERIA_SEARCH_V001Request::setTransactionID()
     * @uses S_GUEST_CRITERIA_SEARCH_V001Request::setSearchCriteria1()
     * @uses S_GUEST_CRITERIA_SEARCH_V001Request::setSearchCriteria2()
     * @param \StructType\Authentication $authentication
     * @param \StructType\SearchCriteria $searchCriteria
     * @param string $transactionID
     * @param \StructType\SearchCriteria1 $searchCriteria1
     * @param \StructType\SearchCriteria2 $searchCriteria2
     */
    public function __construct(\StructType\Authentication $authentication = null, \StructType\SearchCriteria $searchCriteria = null, $transactionID = null, \StructType\SearchCriteria1 $searchCriteria1 = null, \StructType\SearchCriteria2 $searchCriteria2 = null)
    {
        $this
            ->setAuthentication($authentication)
            ->setSearchCriteria($searchCriteria)
            ->setTransactionID($transactionID)
            ->setSearchCriteria1($searchCriteria1)
            ->setSearchCriteria2($searchCriteria2);
    }
    /**
     * Get Authentication value
     * @return \StructType\Authentication
     */
    public function getAuthentication()
    {
        return $this->Authentication;
    }
    /**
     * Set Authentication value
     * @param \StructType\Authentication $authentication
     * @return \StructType\S_GUEST_CRITERIA_SEARCH_V001Request
     */
    public function setAuthentication(\StructType\Authentication $authentication = null)
    {
        $this->Authentication = $authentication;
        return $this;
    }
    /**
     * Get SearchCriteria value
     * @return \StructType\SearchCriteria
     */
    public function getSearchCriteria()
    {
        return $this->SearchCriteria;
    }
    /**
     * Set SearchCriteria value
     * @param \StructType\SearchCriteria $searchCriteria
     * @return \StructType\S_GUEST_CRITERIA_SEARCH_V001Request
     */
    public function setSearchCriteria(\StructType\SearchCriteria $searchCriteria = null)
    {
        $this->SearchCriteria = $searchCriteria;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_GUEST_CRITERIA_SEARCH_V001Request
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
    /**
     * Get SearchCriteria1 value
     * @return \StructType\SearchCriteria1|null
     */
    public function getSearchCriteria1()
    {
        return $this->SearchCriteria1;
    }
    /**
     * Set SearchCriteria1 value
     * @param \StructType\SearchCriteria1 $searchCriteria1
     * @return \StructType\S_GUEST_CRITERIA_SEARCH_V001Request
     */
    public function setSearchCriteria1(\StructType\SearchCriteria1 $searchCriteria1 = null)
    {
        $this->SearchCriteria1 = $searchCriteria1;
        return $this;
    }
    /**
     * Get SearchCriteria2 value
     * @return \StructType\SearchCriteria2|null
     */
    public function getSearchCriteria2()
    {
        return $this->SearchCriteria2;
    }
    /**
     * Set SearchCriteria2 value
     * @param \StructType\SearchCriteria2 $searchCriteria2
     * @return \StructType\S_GUEST_CRITERIA_SEARCH_V001Request
     */
    public function setSearchCriteria2(\StructType\SearchCriteria2 $searchCriteria2 = null)
    {
        $this->SearchCriteria2 = $searchCriteria2;
        return $this;
    }
}
