<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_GUEST_HIERARCHY_GET_V001Response StructType
 * @subpackage Structs
 */
class S_GUEST_HIERARCHY_GET_V001Response extends AbstractStructBase
{
    /**
     * The Result
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Result
     */
    public $Result;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * The GuestHierarchyLevel0
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\GuestHierarchyLevel0[]
     */
    public $GuestHierarchyLevel0;
    /**
     * Constructor method for S_GUEST_HIERARCHY_GET_V001Response
     * @uses S_GUEST_HIERARCHY_GET_V001Response::setResult()
     * @uses S_GUEST_HIERARCHY_GET_V001Response::setTransactionID()
     * @uses S_GUEST_HIERARCHY_GET_V001Response::setGuestHierarchyLevel0()
     * @param \StructType\Result $result
     * @param string $transactionID
     * @param \StructType\GuestHierarchyLevel0[] $guestHierarchyLevel0
     */
    public function __construct(\StructType\Result $result = null, $transactionID = null, array $guestHierarchyLevel0 = array())
    {
        $this
            ->setResult($result)
            ->setTransactionID($transactionID)
            ->setGuestHierarchyLevel0($guestHierarchyLevel0);
    }
    /**
     * Get Result value
     * @return \StructType\Result
     */
    public function getResult()
    {
        return $this->Result;
    }
    /**
     * Set Result value
     * @param \StructType\Result $result
     * @return \StructType\S_GUEST_HIERARCHY_GET_V001Response
     */
    public function setResult(\StructType\Result $result = null)
    {
        $this->Result = $result;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_GUEST_HIERARCHY_GET_V001Response
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
    /**
     * Get GuestHierarchyLevel0 value
     * @return \StructType\GuestHierarchyLevel0[]|null
     */
    public function getGuestHierarchyLevel0()
    {
        return $this->GuestHierarchyLevel0;
    }
    /**
     * This method is responsible for validating the values passed to the setGuestHierarchyLevel0 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGuestHierarchyLevel0 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGuestHierarchyLevel0ForArrayConstraintsFromSetGuestHierarchyLevel0(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $s_GUEST_HIERARCHY_GET_V001ResponseGuestHierarchyLevel0Item) {
            // validation for constraint: itemType
            if (!$s_GUEST_HIERARCHY_GET_V001ResponseGuestHierarchyLevel0Item instanceof \StructType\GuestHierarchyLevel0) {
                $invalidValues[] = is_object($s_GUEST_HIERARCHY_GET_V001ResponseGuestHierarchyLevel0Item) ? get_class($s_GUEST_HIERARCHY_GET_V001ResponseGuestHierarchyLevel0Item) : sprintf('%s(%s)', gettype($s_GUEST_HIERARCHY_GET_V001ResponseGuestHierarchyLevel0Item), var_export($s_GUEST_HIERARCHY_GET_V001ResponseGuestHierarchyLevel0Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The GuestHierarchyLevel0 property can only contain items of type \StructType\GuestHierarchyLevel0, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GuestHierarchyLevel0 value
     * @throws \InvalidArgumentException
     * @param \StructType\GuestHierarchyLevel0[] $guestHierarchyLevel0
     * @return \StructType\S_GUEST_HIERARCHY_GET_V001Response
     */
    public function setGuestHierarchyLevel0(array $guestHierarchyLevel0 = array())
    {
        // validation for constraint: array
        if ('' !== ($guestHierarchyLevel0ArrayErrorMessage = self::validateGuestHierarchyLevel0ForArrayConstraintsFromSetGuestHierarchyLevel0($guestHierarchyLevel0))) {
            throw new \InvalidArgumentException($guestHierarchyLevel0ArrayErrorMessage, __LINE__);
        }
        $this->GuestHierarchyLevel0 = $guestHierarchyLevel0;
        return $this;
    }
    /**
     * Add item to GuestHierarchyLevel0 value
     * @throws \InvalidArgumentException
     * @param \StructType\GuestHierarchyLevel0 $item
     * @return \StructType\S_GUEST_HIERARCHY_GET_V001Response
     */
    public function addToGuestHierarchyLevel0(\StructType\GuestHierarchyLevel0 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GuestHierarchyLevel0) {
            throw new \InvalidArgumentException(sprintf('The GuestHierarchyLevel0 property can only contain items of type \StructType\GuestHierarchyLevel0, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->GuestHierarchyLevel0[] = $item;
        return $this;
    }
}
