<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_GUEST_LOYALTY_CARDS_GET_V001Response StructType
 * @subpackage Structs
 */
class S_GUEST_LOYALTY_CARDS_GET_V001Response extends AbstractStructBase
{
    /**
     * The Result
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Result
     */
    public $Result;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * The LOYALTY_CARD
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\LOYALTY_CARD[]
     */
    public $LOYALTY_CARD;
    /**
     * Constructor method for S_GUEST_LOYALTY_CARDS_GET_V001Response
     * @uses S_GUEST_LOYALTY_CARDS_GET_V001Response::setResult()
     * @uses S_GUEST_LOYALTY_CARDS_GET_V001Response::setTransactionID()
     * @uses S_GUEST_LOYALTY_CARDS_GET_V001Response::setLOYALTY_CARD()
     * @param \StructType\Result $result
     * @param string $transactionID
     * @param \StructType\LOYALTY_CARD[] $lOYALTY_CARD
     */
    public function __construct(\StructType\Result $result = null, $transactionID = null, array $lOYALTY_CARD = array())
    {
        $this
            ->setResult($result)
            ->setTransactionID($transactionID)
            ->setLOYALTY_CARD($lOYALTY_CARD);
    }
    /**
     * Get Result value
     * @return \StructType\Result
     */
    public function getResult()
    {
        return $this->Result;
    }
    /**
     * Set Result value
     * @param \StructType\Result $result
     * @return \StructType\S_GUEST_LOYALTY_CARDS_GET_V001Response
     */
    public function setResult(\StructType\Result $result = null)
    {
        $this->Result = $result;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_GUEST_LOYALTY_CARDS_GET_V001Response
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
    /**
     * Get LOYALTY_CARD value
     * @return \StructType\LOYALTY_CARD[]|null
     */
    public function getLOYALTY_CARD()
    {
        return $this->{'LOYALTY-CARD'};
    }
    /**
     * This method is responsible for validating the values passed to the setLOYALTY_CARD method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLOYALTY_CARD method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLOYALTY_CARDForArrayConstraintsFromSetLOYALTY_CARD(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $s_GUEST_LOYALTY_CARDS_GET_V001ResponseLOYALTY_CARDItem) {
            // validation for constraint: itemType
            if (!$s_GUEST_LOYALTY_CARDS_GET_V001ResponseLOYALTY_CARDItem instanceof \StructType\LOYALTY_CARD) {
                $invalidValues[] = is_object($s_GUEST_LOYALTY_CARDS_GET_V001ResponseLOYALTY_CARDItem) ? get_class($s_GUEST_LOYALTY_CARDS_GET_V001ResponseLOYALTY_CARDItem) : sprintf('%s(%s)', gettype($s_GUEST_LOYALTY_CARDS_GET_V001ResponseLOYALTY_CARDItem), var_export($s_GUEST_LOYALTY_CARDS_GET_V001ResponseLOYALTY_CARDItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The LOYALTY_CARD property can only contain items of type \StructType\LOYALTY_CARD, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set LOYALTY_CARD value
     * @throws \InvalidArgumentException
     * @param \StructType\LOYALTY_CARD[] $lOYALTY_CARD
     * @return \StructType\S_GUEST_LOYALTY_CARDS_GET_V001Response
     */
    public function setLOYALTY_CARD(array $lOYALTY_CARD = array())
    {
        // validation for constraint: array
        if ('' !== ($lOYALTY_CARDArrayErrorMessage = self::validateLOYALTY_CARDForArrayConstraintsFromSetLOYALTY_CARD($lOYALTY_CARD))) {
            throw new \InvalidArgumentException($lOYALTY_CARDArrayErrorMessage, __LINE__);
        }
        $this->LOYALTY_CARD = $this->{'LOYALTY-CARD'} = $lOYALTY_CARD;
        return $this;
    }
    /**
     * Add item to LOYALTY_CARD value
     * @throws \InvalidArgumentException
     * @param \StructType\LOYALTY_CARD $item
     * @return \StructType\S_GUEST_LOYALTY_CARDS_GET_V001Response
     */
    public function addToLOYALTY_CARD(\StructType\LOYALTY_CARD $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LOYALTY_CARD) {
            throw new \InvalidArgumentException(sprintf('The LOYALTY_CARD property can only contain items of type \StructType\LOYALTY_CARD, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->LOYALTY_CARD[] = $this->{'LOYALTY-CARD'}[] = $item;
        return $this;
    }
}
