<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_GUEST_MODIFY_V003Request StructType
 * @subpackage Structs
 */
class S_GUEST_MODIFY_V003Request extends AbstractStructBase
{
    /**
     * The Authentication
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Authentication
     */
    public $Authentication;
    /**
     * The GUEST
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\GUEST
     */
    public $GUEST;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * Constructor method for S_GUEST_MODIFY_V003Request
     * @uses S_GUEST_MODIFY_V003Request::setAuthentication()
     * @uses S_GUEST_MODIFY_V003Request::setGUEST()
     * @uses S_GUEST_MODIFY_V003Request::setTransactionID()
     * @param \StructType\Authentication $authentication
     * @param \StructType\GUEST $gUEST
     * @param string $transactionID
     */
    public function __construct(\StructType\Authentication $authentication = null, \StructType\GUEST $gUEST = null, $transactionID = null)
    {
        $this
            ->setAuthentication($authentication)
            ->setGUEST($gUEST)
            ->setTransactionID($transactionID);
    }
    /**
     * Get Authentication value
     * @return \StructType\Authentication
     */
    public function getAuthentication()
    {
        return $this->Authentication;
    }
    /**
     * Set Authentication value
     * @param \StructType\Authentication $authentication
     * @return \StructType\S_GUEST_MODIFY_V003Request
     */
    public function setAuthentication(\StructType\Authentication $authentication = null)
    {
        $this->Authentication = $authentication;
        return $this;
    }
    /**
     * Get GUEST value
     * @return \StructType\GUEST
     */
    public function getGUEST()
    {
        return $this->GUEST;
    }
    /**
     * Set GUEST value
     * @param \StructType\GUEST $gUEST
     * @return \StructType\S_GUEST_MODIFY_V003Request
     */
    public function setGUEST(\StructType\GUEST $gUEST = null)
    {
        $this->GUEST = $gUEST;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_GUEST_MODIFY_V003Request
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
}
