<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_HOTEL_RESTRICTION_SEARCH_V002Request StructType
 * @subpackage Structs
 */
class S_HOTEL_RESTRICTION_SEARCH_V002Request extends AbstractStructBase
{
    /**
     * The Authentication
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Authentication
     */
    public $Authentication;
    /**
     * The HOTELRESTRICTION_SEARCH
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\HOTELRESTRICTION_SEARCH
     */
    public $HOTELRESTRICTION_SEARCH;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * Constructor method for S_HOTEL_RESTRICTION_SEARCH_V002Request
     * @uses S_HOTEL_RESTRICTION_SEARCH_V002Request::setAuthentication()
     * @uses S_HOTEL_RESTRICTION_SEARCH_V002Request::setHOTELRESTRICTION_SEARCH()
     * @uses S_HOTEL_RESTRICTION_SEARCH_V002Request::setTransactionID()
     * @param \StructType\Authentication $authentication
     * @param \StructType\HOTELRESTRICTION_SEARCH $hOTELRESTRICTION_SEARCH
     * @param string $transactionID
     */
    public function __construct(\StructType\Authentication $authentication = null, \StructType\HOTELRESTRICTION_SEARCH $hOTELRESTRICTION_SEARCH = null, $transactionID = null)
    {
        $this
            ->setAuthentication($authentication)
            ->setHOTELRESTRICTION_SEARCH($hOTELRESTRICTION_SEARCH)
            ->setTransactionID($transactionID);
    }
    /**
     * Get Authentication value
     * @return \StructType\Authentication
     */
    public function getAuthentication()
    {
        return $this->Authentication;
    }
    /**
     * Set Authentication value
     * @param \StructType\Authentication $authentication
     * @return \StructType\S_HOTEL_RESTRICTION_SEARCH_V002Request
     */
    public function setAuthentication(\StructType\Authentication $authentication = null)
    {
        $this->Authentication = $authentication;
        return $this;
    }
    /**
     * Get HOTELRESTRICTION_SEARCH value
     * @return \StructType\HOTELRESTRICTION_SEARCH
     */
    public function getHOTELRESTRICTION_SEARCH()
    {
        return $this->{'HOTELRESTRICTION-SEARCH'};
    }
    /**
     * Set HOTELRESTRICTION_SEARCH value
     * @param \StructType\HOTELRESTRICTION_SEARCH $hOTELRESTRICTION_SEARCH
     * @return \StructType\S_HOTEL_RESTRICTION_SEARCH_V002Request
     */
    public function setHOTELRESTRICTION_SEARCH(\StructType\HOTELRESTRICTION_SEARCH $hOTELRESTRICTION_SEARCH = null)
    {
        $this->HOTELRESTRICTION_SEARCH = $this->{'HOTELRESTRICTION-SEARCH'} = $hOTELRESTRICTION_SEARCH;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_HOTEL_RESTRICTION_SEARCH_V002Request
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
}
