<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_MOBILE_LOST_AND_FOUND_ADD_V001Response StructType
 * @subpackage Structs
 */
class S_MOBILE_LOST_AND_FOUND_ADD_V001Response extends AbstractStructBase
{
    /**
     * The Result
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Result
     */
    public $Result;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * The LOST_AND_FOUND
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\LOST_AND_FOUND[]
     */
    public $LOST_AND_FOUND;
    /**
     * Constructor method for S_MOBILE_LOST_AND_FOUND_ADD_V001Response
     * @uses S_MOBILE_LOST_AND_FOUND_ADD_V001Response::setResult()
     * @uses S_MOBILE_LOST_AND_FOUND_ADD_V001Response::setTransactionID()
     * @uses S_MOBILE_LOST_AND_FOUND_ADD_V001Response::setLOST_AND_FOUND()
     * @param \StructType\Result $result
     * @param string $transactionID
     * @param \StructType\LOST_AND_FOUND[] $lOST_AND_FOUND
     */
    public function __construct(\StructType\Result $result = null, $transactionID = null, array $lOST_AND_FOUND = array())
    {
        $this
            ->setResult($result)
            ->setTransactionID($transactionID)
            ->setLOST_AND_FOUND($lOST_AND_FOUND);
    }
    /**
     * Get Result value
     * @return \StructType\Result
     */
    public function getResult()
    {
        return $this->Result;
    }
    /**
     * Set Result value
     * @param \StructType\Result $result
     * @return \StructType\S_MOBILE_LOST_AND_FOUND_ADD_V001Response
     */
    public function setResult(\StructType\Result $result = null)
    {
        $this->Result = $result;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_MOBILE_LOST_AND_FOUND_ADD_V001Response
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
    /**
     * Get LOST_AND_FOUND value
     * @return \StructType\LOST_AND_FOUND[]|null
     */
    public function getLOST_AND_FOUND()
    {
        return $this->{'LOST-AND-FOUND'};
    }
    /**
     * This method is responsible for validating the values passed to the setLOST_AND_FOUND method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLOST_AND_FOUND method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLOST_AND_FOUNDForArrayConstraintsFromSetLOST_AND_FOUND(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $s_MOBILE_LOST_AND_FOUND_ADD_V001ResponseLOST_AND_FOUNDItem) {
            // validation for constraint: itemType
            if (!$s_MOBILE_LOST_AND_FOUND_ADD_V001ResponseLOST_AND_FOUNDItem instanceof \StructType\LOST_AND_FOUND) {
                $invalidValues[] = is_object($s_MOBILE_LOST_AND_FOUND_ADD_V001ResponseLOST_AND_FOUNDItem) ? get_class($s_MOBILE_LOST_AND_FOUND_ADD_V001ResponseLOST_AND_FOUNDItem) : sprintf('%s(%s)', gettype($s_MOBILE_LOST_AND_FOUND_ADD_V001ResponseLOST_AND_FOUNDItem), var_export($s_MOBILE_LOST_AND_FOUND_ADD_V001ResponseLOST_AND_FOUNDItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The LOST_AND_FOUND property can only contain items of type \StructType\LOST_AND_FOUND, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set LOST_AND_FOUND value
     * @throws \InvalidArgumentException
     * @param \StructType\LOST_AND_FOUND[] $lOST_AND_FOUND
     * @return \StructType\S_MOBILE_LOST_AND_FOUND_ADD_V001Response
     */
    public function setLOST_AND_FOUND(array $lOST_AND_FOUND = array())
    {
        // validation for constraint: array
        if ('' !== ($lOST_AND_FOUNDArrayErrorMessage = self::validateLOST_AND_FOUNDForArrayConstraintsFromSetLOST_AND_FOUND($lOST_AND_FOUND))) {
            throw new \InvalidArgumentException($lOST_AND_FOUNDArrayErrorMessage, __LINE__);
        }
        $this->LOST_AND_FOUND = $this->{'LOST-AND-FOUND'} = $lOST_AND_FOUND;
        return $this;
    }
    /**
     * Add item to LOST_AND_FOUND value
     * @throws \InvalidArgumentException
     * @param \StructType\LOST_AND_FOUND $item
     * @return \StructType\S_MOBILE_LOST_AND_FOUND_ADD_V001Response
     */
    public function addToLOST_AND_FOUND(\StructType\LOST_AND_FOUND $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LOST_AND_FOUND) {
            throw new \InvalidArgumentException(sprintf('The LOST_AND_FOUND property can only contain items of type \StructType\LOST_AND_FOUND, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->LOST_AND_FOUND[] = $this->{'LOST-AND-FOUND'}[] = $item;
        return $this;
    }
}
