<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_MOBILE_LOST_AND_FOUND_IMAGE_GET_V001Request StructType
 * @subpackage Structs
 */
class S_MOBILE_LOST_AND_FOUND_IMAGE_GET_V001Request extends AbstractStructBase
{
    /**
     * The Authentication
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Authentication
     */
    public $Authentication;
    /**
     * The LOST_AND_FOUND
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\LOST_AND_FOUND
     */
    public $LOST_AND_FOUND;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * Constructor method for S_MOBILE_LOST_AND_FOUND_IMAGE_GET_V001Request
     * @uses S_MOBILE_LOST_AND_FOUND_IMAGE_GET_V001Request::setAuthentication()
     * @uses S_MOBILE_LOST_AND_FOUND_IMAGE_GET_V001Request::setLOST_AND_FOUND()
     * @uses S_MOBILE_LOST_AND_FOUND_IMAGE_GET_V001Request::setTransactionID()
     * @param \StructType\Authentication $authentication
     * @param \StructType\LOST_AND_FOUND $lOST_AND_FOUND
     * @param string $transactionID
     */
    public function __construct(\StructType\Authentication $authentication = null, \StructType\LOST_AND_FOUND $lOST_AND_FOUND = null, $transactionID = null)
    {
        $this
            ->setAuthentication($authentication)
            ->setLOST_AND_FOUND($lOST_AND_FOUND)
            ->setTransactionID($transactionID);
    }
    /**
     * Get Authentication value
     * @return \StructType\Authentication
     */
    public function getAuthentication()
    {
        return $this->Authentication;
    }
    /**
     * Set Authentication value
     * @param \StructType\Authentication $authentication
     * @return \StructType\S_MOBILE_LOST_AND_FOUND_IMAGE_GET_V001Request
     */
    public function setAuthentication(\StructType\Authentication $authentication = null)
    {
        $this->Authentication = $authentication;
        return $this;
    }
    /**
     * Get LOST_AND_FOUND value
     * @return \StructType\LOST_AND_FOUND
     */
    public function getLOST_AND_FOUND()
    {
        return $this->{'LOST-AND-FOUND'};
    }
    /**
     * Set LOST_AND_FOUND value
     * @param \StructType\LOST_AND_FOUND $lOST_AND_FOUND
     * @return \StructType\S_MOBILE_LOST_AND_FOUND_IMAGE_GET_V001Request
     */
    public function setLOST_AND_FOUND(\StructType\LOST_AND_FOUND $lOST_AND_FOUND = null)
    {
        $this->LOST_AND_FOUND = $this->{'LOST-AND-FOUND'} = $lOST_AND_FOUND;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_MOBILE_LOST_AND_FOUND_IMAGE_GET_V001Request
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
}
