<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_MOBILE_ROOMS_TO_CLEAN_INDIVIDUAL_GET_V001Response
 * StructType
 * @subpackage Structs
 */
class S_MOBILE_ROOMS_TO_CLEAN_INDIVIDUAL_GET_V001Response extends AbstractStructBase
{
    /**
     * The Result
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Result
     */
    public $Result;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * The ROOMTOCLEAN
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ROOMTOCLEAN[]
     */
    public $ROOMTOCLEAN;
    /**
     * Constructor method for S_MOBILE_ROOMS_TO_CLEAN_INDIVIDUAL_GET_V001Response
     * @uses S_MOBILE_ROOMS_TO_CLEAN_INDIVIDUAL_GET_V001Response::setResult()
     * @uses S_MOBILE_ROOMS_TO_CLEAN_INDIVIDUAL_GET_V001Response::setTransactionID()
     * @uses S_MOBILE_ROOMS_TO_CLEAN_INDIVIDUAL_GET_V001Response::setROOMTOCLEAN()
     * @param \StructType\Result $result
     * @param string $transactionID
     * @param \StructType\ROOMTOCLEAN[] $rOOMTOCLEAN
     */
    public function __construct(\StructType\Result $result = null, $transactionID = null, array $rOOMTOCLEAN = array())
    {
        $this
            ->setResult($result)
            ->setTransactionID($transactionID)
            ->setROOMTOCLEAN($rOOMTOCLEAN);
    }
    /**
     * Get Result value
     * @return \StructType\Result
     */
    public function getResult()
    {
        return $this->Result;
    }
    /**
     * Set Result value
     * @param \StructType\Result $result
     * @return \StructType\S_MOBILE_ROOMS_TO_CLEAN_INDIVIDUAL_GET_V001Response
     */
    public function setResult(\StructType\Result $result = null)
    {
        $this->Result = $result;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_MOBILE_ROOMS_TO_CLEAN_INDIVIDUAL_GET_V001Response
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
    /**
     * Get ROOMTOCLEAN value
     * @return \StructType\ROOMTOCLEAN[]|null
     */
    public function getROOMTOCLEAN()
    {
        return $this->ROOMTOCLEAN;
    }
    /**
     * This method is responsible for validating the values passed to the setROOMTOCLEAN method
     * This method is willingly generated in order to preserve the one-line inline validation within the setROOMTOCLEAN method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateROOMTOCLEANForArrayConstraintsFromSetROOMTOCLEAN(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $s_MOBILE_ROOMS_TO_CLEAN_INDIVIDUAL_GET_V001ResponseROOMTOCLEANItem) {
            // validation for constraint: itemType
            if (!$s_MOBILE_ROOMS_TO_CLEAN_INDIVIDUAL_GET_V001ResponseROOMTOCLEANItem instanceof \StructType\ROOMTOCLEAN) {
                $invalidValues[] = is_object($s_MOBILE_ROOMS_TO_CLEAN_INDIVIDUAL_GET_V001ResponseROOMTOCLEANItem) ? get_class($s_MOBILE_ROOMS_TO_CLEAN_INDIVIDUAL_GET_V001ResponseROOMTOCLEANItem) : sprintf('%s(%s)', gettype($s_MOBILE_ROOMS_TO_CLEAN_INDIVIDUAL_GET_V001ResponseROOMTOCLEANItem), var_export($s_MOBILE_ROOMS_TO_CLEAN_INDIVIDUAL_GET_V001ResponseROOMTOCLEANItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ROOMTOCLEAN property can only contain items of type \StructType\ROOMTOCLEAN, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ROOMTOCLEAN value
     * @throws \InvalidArgumentException
     * @param \StructType\ROOMTOCLEAN[] $rOOMTOCLEAN
     * @return \StructType\S_MOBILE_ROOMS_TO_CLEAN_INDIVIDUAL_GET_V001Response
     */
    public function setROOMTOCLEAN(array $rOOMTOCLEAN = array())
    {
        // validation for constraint: array
        if ('' !== ($rOOMTOCLEANArrayErrorMessage = self::validateROOMTOCLEANForArrayConstraintsFromSetROOMTOCLEAN($rOOMTOCLEAN))) {
            throw new \InvalidArgumentException($rOOMTOCLEANArrayErrorMessage, __LINE__);
        }
        $this->ROOMTOCLEAN = $rOOMTOCLEAN;
        return $this;
    }
    /**
     * Add item to ROOMTOCLEAN value
     * @throws \InvalidArgumentException
     * @param \StructType\ROOMTOCLEAN $item
     * @return \StructType\S_MOBILE_ROOMS_TO_CLEAN_INDIVIDUAL_GET_V001Response
     */
    public function addToROOMTOCLEAN(\StructType\ROOMTOCLEAN $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ROOMTOCLEAN) {
            throw new \InvalidArgumentException(sprintf('The ROOMTOCLEAN property can only contain items of type \StructType\ROOMTOCLEAN, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ROOMTOCLEAN[] = $item;
        return $this;
    }
}
