<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_NOTIFICATION_REGISTRATION_SEARCH_V001Request StructType
 * @subpackage Structs
 */
class S_NOTIFICATION_REGISTRATION_SEARCH_V001Request extends AbstractStructBase
{
    /**
     * The Authentication
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Authentication
     */
    public $Authentication;
    /**
     * The NOTIFICATION_REGISTRATION_SEARCH
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\NOTIFICATION_REGISTRATION_SEARCH
     */
    public $NOTIFICATION_REGISTRATION_SEARCH;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * Constructor method for S_NOTIFICATION_REGISTRATION_SEARCH_V001Request
     * @uses S_NOTIFICATION_REGISTRATION_SEARCH_V001Request::setAuthentication()
     * @uses S_NOTIFICATION_REGISTRATION_SEARCH_V001Request::setNOTIFICATION_REGISTRATION_SEARCH()
     * @uses S_NOTIFICATION_REGISTRATION_SEARCH_V001Request::setTransactionID()
     * @param \StructType\Authentication $authentication
     * @param \StructType\NOTIFICATION_REGISTRATION_SEARCH $nOTIFICATION_REGISTRATION_SEARCH
     * @param string $transactionID
     */
    public function __construct(\StructType\Authentication $authentication = null, \StructType\NOTIFICATION_REGISTRATION_SEARCH $nOTIFICATION_REGISTRATION_SEARCH = null, $transactionID = null)
    {
        $this
            ->setAuthentication($authentication)
            ->setNOTIFICATION_REGISTRATION_SEARCH($nOTIFICATION_REGISTRATION_SEARCH)
            ->setTransactionID($transactionID);
    }
    /**
     * Get Authentication value
     * @return \StructType\Authentication
     */
    public function getAuthentication()
    {
        return $this->Authentication;
    }
    /**
     * Set Authentication value
     * @param \StructType\Authentication $authentication
     * @return \StructType\S_NOTIFICATION_REGISTRATION_SEARCH_V001Request
     */
    public function setAuthentication(\StructType\Authentication $authentication = null)
    {
        $this->Authentication = $authentication;
        return $this;
    }
    /**
     * Get NOTIFICATION_REGISTRATION_SEARCH value
     * @return \StructType\NOTIFICATION_REGISTRATION_SEARCH
     */
    public function getNOTIFICATION_REGISTRATION_SEARCH()
    {
        return $this->{'NOTIFICATION-REGISTRATION-SEARCH'};
    }
    /**
     * Set NOTIFICATION_REGISTRATION_SEARCH value
     * @param \StructType\NOTIFICATION_REGISTRATION_SEARCH $nOTIFICATION_REGISTRATION_SEARCH
     * @return \StructType\S_NOTIFICATION_REGISTRATION_SEARCH_V001Request
     */
    public function setNOTIFICATION_REGISTRATION_SEARCH(\StructType\NOTIFICATION_REGISTRATION_SEARCH $nOTIFICATION_REGISTRATION_SEARCH = null)
    {
        $this->NOTIFICATION_REGISTRATION_SEARCH = $this->{'NOTIFICATION-REGISTRATION-SEARCH'} = $nOTIFICATION_REGISTRATION_SEARCH;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_NOTIFICATION_REGISTRATION_SEARCH_V001Request
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
}
