<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for
 * S_PACKAGE_MASTER_FILE_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001Response
 * StructType
 * @subpackage Structs
 */
class S_PACKAGE_MASTER_FILE_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001Response extends AbstractStructBase
{
    /**
     * The Result
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Result
     */
    public $Result;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * The PackageMasterFiles
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\PackageMasterFiles[]
     */
    public $PackageMasterFiles;
    /**
     * Constructor method for
     * S_PACKAGE_MASTER_FILE_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001Response
     * @uses S_PACKAGE_MASTER_FILE_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001Response::setResult()
     * @uses S_PACKAGE_MASTER_FILE_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001Response::setTransactionID()
     * @uses S_PACKAGE_MASTER_FILE_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001Response::setPackageMasterFiles()
     * @param \StructType\Result $result
     * @param string $transactionID
     * @param \StructType\PackageMasterFiles[] $packageMasterFiles
     */
    public function __construct(\StructType\Result $result = null, $transactionID = null, array $packageMasterFiles = array())
    {
        $this
            ->setResult($result)
            ->setTransactionID($transactionID)
            ->setPackageMasterFiles($packageMasterFiles);
    }
    /**
     * Get Result value
     * @return \StructType\Result
     */
    public function getResult()
    {
        return $this->Result;
    }
    /**
     * Set Result value
     * @param \StructType\Result $result
     * @return \StructType\S_PACKAGE_MASTER_FILE_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001Response
     */
    public function setResult(\StructType\Result $result = null)
    {
        $this->Result = $result;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_PACKAGE_MASTER_FILE_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001Response
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
    /**
     * Get PackageMasterFiles value
     * @return \StructType\PackageMasterFiles[]|null
     */
    public function getPackageMasterFiles()
    {
        return $this->PackageMasterFiles;
    }
    /**
     * This method is responsible for validating the values passed to the setPackageMasterFiles method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPackageMasterFiles method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePackageMasterFilesForArrayConstraintsFromSetPackageMasterFiles(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $s_PACKAGE_MASTER_FILE_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001ResponsePackageMasterFilesItem) {
            // validation for constraint: itemType
            if (!$s_PACKAGE_MASTER_FILE_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001ResponsePackageMasterFilesItem instanceof \StructType\PackageMasterFiles) {
                $invalidValues[] = is_object($s_PACKAGE_MASTER_FILE_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001ResponsePackageMasterFilesItem) ? get_class($s_PACKAGE_MASTER_FILE_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001ResponsePackageMasterFilesItem) : sprintf('%s(%s)', gettype($s_PACKAGE_MASTER_FILE_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001ResponsePackageMasterFilesItem), var_export($s_PACKAGE_MASTER_FILE_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001ResponsePackageMasterFilesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PackageMasterFiles property can only contain items of type \StructType\PackageMasterFiles, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PackageMasterFiles value
     * @throws \InvalidArgumentException
     * @param \StructType\PackageMasterFiles[] $packageMasterFiles
     * @return \StructType\S_PACKAGE_MASTER_FILE_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001Response
     */
    public function setPackageMasterFiles(array $packageMasterFiles = array())
    {
        // validation for constraint: array
        if ('' !== ($packageMasterFilesArrayErrorMessage = self::validatePackageMasterFilesForArrayConstraintsFromSetPackageMasterFiles($packageMasterFiles))) {
            throw new \InvalidArgumentException($packageMasterFilesArrayErrorMessage, __LINE__);
        }
        $this->PackageMasterFiles = $packageMasterFiles;
        return $this;
    }
    /**
     * Add item to PackageMasterFiles value
     * @throws \InvalidArgumentException
     * @param \StructType\PackageMasterFiles $item
     * @return \StructType\S_PACKAGE_MASTER_FILE_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001Response
     */
    public function addToPackageMasterFiles(\StructType\PackageMasterFiles $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PackageMasterFiles) {
            throw new \InvalidArgumentException(sprintf('The PackageMasterFiles property can only contain items of type \StructType\PackageMasterFiles, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PackageMasterFiles[] = $item;
        return $this;
    }
}
