<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_RESERVATION_CHANGE_PREVIEW_V001Request StructType
 * @subpackage Structs
 */
class S_RESERVATION_CHANGE_PREVIEW_V001Request extends AbstractStructBase
{
    /**
     * The Authentication
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Authentication
     */
    public $Authentication;
    /**
     * The ResForecast
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\ResForecast
     */
    public $ResForecast;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * Constructor method for S_RESERVATION_CHANGE_PREVIEW_V001Request
     * @uses S_RESERVATION_CHANGE_PREVIEW_V001Request::setAuthentication()
     * @uses S_RESERVATION_CHANGE_PREVIEW_V001Request::setResForecast()
     * @uses S_RESERVATION_CHANGE_PREVIEW_V001Request::setTransactionID()
     * @param \StructType\Authentication $authentication
     * @param \StructType\ResForecast $resForecast
     * @param string $transactionID
     */
    public function __construct(\StructType\Authentication $authentication = null, \StructType\ResForecast $resForecast = null, $transactionID = null)
    {
        $this
            ->setAuthentication($authentication)
            ->setResForecast($resForecast)
            ->setTransactionID($transactionID);
    }
    /**
     * Get Authentication value
     * @return \StructType\Authentication
     */
    public function getAuthentication()
    {
        return $this->Authentication;
    }
    /**
     * Set Authentication value
     * @param \StructType\Authentication $authentication
     * @return \StructType\S_RESERVATION_CHANGE_PREVIEW_V001Request
     */
    public function setAuthentication(\StructType\Authentication $authentication = null)
    {
        $this->Authentication = $authentication;
        return $this;
    }
    /**
     * Get ResForecast value
     * @return \StructType\ResForecast
     */
    public function getResForecast()
    {
        return $this->ResForecast;
    }
    /**
     * Set ResForecast value
     * @param \StructType\ResForecast $resForecast
     * @return \StructType\S_RESERVATION_CHANGE_PREVIEW_V001Request
     */
    public function setResForecast(\StructType\ResForecast $resForecast = null)
    {
        $this->ResForecast = $resForecast;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_RESERVATION_CHANGE_PREVIEW_V001Request
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
}
