<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_RESERVATION_CHECK_IN_V002Response StructType
 * @subpackage Structs
 */
class S_RESERVATION_CHECK_IN_V002Response extends AbstractStructBase
{
    /**
     * The Result
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Result
     */
    public $Result;
    /**
     * The ROOMS
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\ROOMS
     */
    public $ROOMS;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * Constructor method for S_RESERVATION_CHECK_IN_V002Response
     * @uses S_RESERVATION_CHECK_IN_V002Response::setResult()
     * @uses S_RESERVATION_CHECK_IN_V002Response::setROOMS()
     * @uses S_RESERVATION_CHECK_IN_V002Response::setTransactionID()
     * @param \StructType\Result $result
     * @param \StructType\ROOMS $rOOMS
     * @param string $transactionID
     */
    public function __construct(\StructType\Result $result = null, \StructType\ROOMS $rOOMS = null, $transactionID = null)
    {
        $this
            ->setResult($result)
            ->setROOMS($rOOMS)
            ->setTransactionID($transactionID);
    }
    /**
     * Get Result value
     * @return \StructType\Result
     */
    public function getResult()
    {
        return $this->Result;
    }
    /**
     * Set Result value
     * @param \StructType\Result $result
     * @return \StructType\S_RESERVATION_CHECK_IN_V002Response
     */
    public function setResult(\StructType\Result $result = null)
    {
        $this->Result = $result;
        return $this;
    }
    /**
     * Get ROOMS value
     * @return \StructType\ROOMS
     */
    public function getROOMS()
    {
        return $this->ROOMS;
    }
    /**
     * Set ROOMS value
     * @param \StructType\ROOMS $rOOMS
     * @return \StructType\S_RESERVATION_CHECK_IN_V002Response
     */
    public function setROOMS(\StructType\ROOMS $rOOMS = null)
    {
        $this->ROOMS = $rOOMS;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_RESERVATION_CHECK_IN_V002Response
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
}
