<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for
 * S_RESERVATION_DEPOSITIN_CREDIT_WITH_FORECAST_ADD_V002Response StructType
 * @subpackage Structs
 */
class S_RESERVATION_DEPOSITIN_CREDIT_WITH_FORECAST_ADD_V002Response extends AbstractStructBase
{
    /**
     * The Result
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Result
     */
    public $Result;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * The Output
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Output[]
     */
    public $Output;
    /**
     * Constructor method for
     * S_RESERVATION_DEPOSITIN_CREDIT_WITH_FORECAST_ADD_V002Response
     * @uses S_RESERVATION_DEPOSITIN_CREDIT_WITH_FORECAST_ADD_V002Response::setResult()
     * @uses S_RESERVATION_DEPOSITIN_CREDIT_WITH_FORECAST_ADD_V002Response::setTransactionID()
     * @uses S_RESERVATION_DEPOSITIN_CREDIT_WITH_FORECAST_ADD_V002Response::setOutput()
     * @param \StructType\Result $result
     * @param string $transactionID
     * @param \StructType\Output[] $output
     */
    public function __construct(\StructType\Result $result = null, $transactionID = null, array $output = array())
    {
        $this
            ->setResult($result)
            ->setTransactionID($transactionID)
            ->setOutput($output);
    }
    /**
     * Get Result value
     * @return \StructType\Result
     */
    public function getResult()
    {
        return $this->Result;
    }
    /**
     * Set Result value
     * @param \StructType\Result $result
     * @return \StructType\S_RESERVATION_DEPOSITIN_CREDIT_WITH_FORECAST_ADD_V002Response
     */
    public function setResult(\StructType\Result $result = null)
    {
        $this->Result = $result;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_RESERVATION_DEPOSITIN_CREDIT_WITH_FORECAST_ADD_V002Response
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
    /**
     * Get Output value
     * @return \StructType\Output[]|null
     */
    public function getOutput()
    {
        return $this->Output;
    }
    /**
     * This method is responsible for validating the values passed to the setOutput method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOutput method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOutputForArrayConstraintsFromSetOutput(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $s_RESERVATION_DEPOSITIN_CREDIT_WITH_FORECAST_ADD_V002ResponseOutputItem) {
            // validation for constraint: itemType
            if (!$s_RESERVATION_DEPOSITIN_CREDIT_WITH_FORECAST_ADD_V002ResponseOutputItem instanceof \StructType\Output) {
                $invalidValues[] = is_object($s_RESERVATION_DEPOSITIN_CREDIT_WITH_FORECAST_ADD_V002ResponseOutputItem) ? get_class($s_RESERVATION_DEPOSITIN_CREDIT_WITH_FORECAST_ADD_V002ResponseOutputItem) : sprintf('%s(%s)', gettype($s_RESERVATION_DEPOSITIN_CREDIT_WITH_FORECAST_ADD_V002ResponseOutputItem), var_export($s_RESERVATION_DEPOSITIN_CREDIT_WITH_FORECAST_ADD_V002ResponseOutputItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Output property can only contain items of type \StructType\Output, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Output value
     * @throws \InvalidArgumentException
     * @param \StructType\Output[] $output
     * @return \StructType\S_RESERVATION_DEPOSITIN_CREDIT_WITH_FORECAST_ADD_V002Response
     */
    public function setOutput(array $output = array())
    {
        // validation for constraint: array
        if ('' !== ($outputArrayErrorMessage = self::validateOutputForArrayConstraintsFromSetOutput($output))) {
            throw new \InvalidArgumentException($outputArrayErrorMessage, __LINE__);
        }
        $this->Output = $output;
        return $this;
    }
    /**
     * Add item to Output value
     * @throws \InvalidArgumentException
     * @param \StructType\Output $item
     * @return \StructType\S_RESERVATION_DEPOSITIN_CREDIT_WITH_FORECAST_ADD_V002Response
     */
    public function addToOutput(\StructType\Output $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Output) {
            throw new \InvalidArgumentException(sprintf('The Output property can only contain items of type \StructType\Output, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Output[] = $item;
        return $this;
    }
}
