<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_RESERVATION_GROUP_RESERVATION_ADD_V002Request StructType
 * @subpackage Structs
 */
class S_RESERVATION_GROUP_RESERVATION_ADD_V002Request extends AbstractStructBase
{
    /**
     * The Authentication
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Authentication
     */
    public $Authentication;
    /**
     * The ResGroup
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\ResGroup
     */
    public $ResGroup;
    /**
     * The ResNewGroupReservationDummy
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\ResNewGroupReservationDummy
     */
    public $ResNewGroupReservationDummy;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * Constructor method for S_RESERVATION_GROUP_RESERVATION_ADD_V002Request
     * @uses S_RESERVATION_GROUP_RESERVATION_ADD_V002Request::setAuthentication()
     * @uses S_RESERVATION_GROUP_RESERVATION_ADD_V002Request::setResGroup()
     * @uses S_RESERVATION_GROUP_RESERVATION_ADD_V002Request::setResNewGroupReservationDummy()
     * @uses S_RESERVATION_GROUP_RESERVATION_ADD_V002Request::setTransactionID()
     * @param \StructType\Authentication $authentication
     * @param \StructType\ResGroup $resGroup
     * @param \StructType\ResNewGroupReservationDummy $resNewGroupReservationDummy
     * @param string $transactionID
     */
    public function __construct(\StructType\Authentication $authentication = null, \StructType\ResGroup $resGroup = null, \StructType\ResNewGroupReservationDummy $resNewGroupReservationDummy = null, $transactionID = null)
    {
        $this
            ->setAuthentication($authentication)
            ->setResGroup($resGroup)
            ->setResNewGroupReservationDummy($resNewGroupReservationDummy)
            ->setTransactionID($transactionID);
    }
    /**
     * Get Authentication value
     * @return \StructType\Authentication
     */
    public function getAuthentication()
    {
        return $this->Authentication;
    }
    /**
     * Set Authentication value
     * @param \StructType\Authentication $authentication
     * @return \StructType\S_RESERVATION_GROUP_RESERVATION_ADD_V002Request
     */
    public function setAuthentication(\StructType\Authentication $authentication = null)
    {
        $this->Authentication = $authentication;
        return $this;
    }
    /**
     * Get ResGroup value
     * @return \StructType\ResGroup
     */
    public function getResGroup()
    {
        return $this->ResGroup;
    }
    /**
     * Set ResGroup value
     * @param \StructType\ResGroup $resGroup
     * @return \StructType\S_RESERVATION_GROUP_RESERVATION_ADD_V002Request
     */
    public function setResGroup(\StructType\ResGroup $resGroup = null)
    {
        $this->ResGroup = $resGroup;
        return $this;
    }
    /**
     * Get ResNewGroupReservationDummy value
     * @return \StructType\ResNewGroupReservationDummy
     */
    public function getResNewGroupReservationDummy()
    {
        return $this->ResNewGroupReservationDummy;
    }
    /**
     * Set ResNewGroupReservationDummy value
     * @param \StructType\ResNewGroupReservationDummy $resNewGroupReservationDummy
     * @return \StructType\S_RESERVATION_GROUP_RESERVATION_ADD_V002Request
     */
    public function setResNewGroupReservationDummy(\StructType\ResNewGroupReservationDummy $resNewGroupReservationDummy = null)
    {
        $this->ResNewGroupReservationDummy = $resNewGroupReservationDummy;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_RESERVATION_GROUP_RESERVATION_ADD_V002Request
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
}
