<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_RESERVATION_PREVIEW_POSTINGS_V001Response StructType
 * @subpackage Structs
 */
class S_RESERVATION_PREVIEW_POSTINGS_V001Response extends AbstractStructBase
{
    /**
     * The Result
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Result
     */
    public $Result;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * The RESERVATION_PREVIEW
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\RESERVATION_PREVIEW[]
     */
    public $RESERVATION_PREVIEW;
    /**
     * Constructor method for S_RESERVATION_PREVIEW_POSTINGS_V001Response
     * @uses S_RESERVATION_PREVIEW_POSTINGS_V001Response::setResult()
     * @uses S_RESERVATION_PREVIEW_POSTINGS_V001Response::setTransactionID()
     * @uses S_RESERVATION_PREVIEW_POSTINGS_V001Response::setRESERVATION_PREVIEW()
     * @param \StructType\Result $result
     * @param string $transactionID
     * @param \StructType\RESERVATION_PREVIEW[] $rESERVATION_PREVIEW
     */
    public function __construct(\StructType\Result $result = null, $transactionID = null, array $rESERVATION_PREVIEW = array())
    {
        $this
            ->setResult($result)
            ->setTransactionID($transactionID)
            ->setRESERVATION_PREVIEW($rESERVATION_PREVIEW);
    }
    /**
     * Get Result value
     * @return \StructType\Result
     */
    public function getResult()
    {
        return $this->Result;
    }
    /**
     * Set Result value
     * @param \StructType\Result $result
     * @return \StructType\S_RESERVATION_PREVIEW_POSTINGS_V001Response
     */
    public function setResult(\StructType\Result $result = null)
    {
        $this->Result = $result;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_RESERVATION_PREVIEW_POSTINGS_V001Response
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
    /**
     * Get RESERVATION_PREVIEW value
     * @return \StructType\RESERVATION_PREVIEW[]|null
     */
    public function getRESERVATION_PREVIEW()
    {
        return $this->{'RESERVATION-PREVIEW'};
    }
    /**
     * This method is responsible for validating the values passed to the setRESERVATION_PREVIEW method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRESERVATION_PREVIEW method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRESERVATION_PREVIEWForArrayConstraintsFromSetRESERVATION_PREVIEW(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $s_RESERVATION_PREVIEW_POSTINGS_V001ResponseRESERVATION_PREVIEWItem) {
            // validation for constraint: itemType
            if (!$s_RESERVATION_PREVIEW_POSTINGS_V001ResponseRESERVATION_PREVIEWItem instanceof \StructType\RESERVATION_PREVIEW) {
                $invalidValues[] = is_object($s_RESERVATION_PREVIEW_POSTINGS_V001ResponseRESERVATION_PREVIEWItem) ? get_class($s_RESERVATION_PREVIEW_POSTINGS_V001ResponseRESERVATION_PREVIEWItem) : sprintf('%s(%s)', gettype($s_RESERVATION_PREVIEW_POSTINGS_V001ResponseRESERVATION_PREVIEWItem), var_export($s_RESERVATION_PREVIEW_POSTINGS_V001ResponseRESERVATION_PREVIEWItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RESERVATION_PREVIEW property can only contain items of type \StructType\RESERVATION_PREVIEW, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RESERVATION_PREVIEW value
     * @throws \InvalidArgumentException
     * @param \StructType\RESERVATION_PREVIEW[] $rESERVATION_PREVIEW
     * @return \StructType\S_RESERVATION_PREVIEW_POSTINGS_V001Response
     */
    public function setRESERVATION_PREVIEW(array $rESERVATION_PREVIEW = array())
    {
        // validation for constraint: array
        if ('' !== ($rESERVATION_PREVIEWArrayErrorMessage = self::validateRESERVATION_PREVIEWForArrayConstraintsFromSetRESERVATION_PREVIEW($rESERVATION_PREVIEW))) {
            throw new \InvalidArgumentException($rESERVATION_PREVIEWArrayErrorMessage, __LINE__);
        }
        $this->RESERVATION_PREVIEW = $this->{'RESERVATION-PREVIEW'} = $rESERVATION_PREVIEW;
        return $this;
    }
    /**
     * Add item to RESERVATION_PREVIEW value
     * @throws \InvalidArgumentException
     * @param \StructType\RESERVATION_PREVIEW $item
     * @return \StructType\S_RESERVATION_PREVIEW_POSTINGS_V001Response
     */
    public function addToRESERVATION_PREVIEW(\StructType\RESERVATION_PREVIEW $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RESERVATION_PREVIEW) {
            throw new \InvalidArgumentException(sprintf('The RESERVATION_PREVIEW property can only contain items of type \StructType\RESERVATION_PREVIEW, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RESERVATION_PREVIEW[] = $this->{'RESERVATION-PREVIEW'}[] = $item;
        return $this;
    }
}
