<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_RESERVATION_SEARCH_V003Response StructType
 * @subpackage Structs
 */
class S_RESERVATION_SEARCH_V003Response extends AbstractStructBase
{
    /**
     * The Result
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Result
     */
    public $Result;
    /**
     * The RESERVATIONS
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\RESERVATIONS
     */
    public $RESERVATIONS;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * Constructor method for S_RESERVATION_SEARCH_V003Response
     * @uses S_RESERVATION_SEARCH_V003Response::setResult()
     * @uses S_RESERVATION_SEARCH_V003Response::setRESERVATIONS()
     * @uses S_RESERVATION_SEARCH_V003Response::setTransactionID()
     * @param \StructType\Result $result
     * @param \StructType\RESERVATIONS $rESERVATIONS
     * @param string $transactionID
     */
    public function __construct(\StructType\Result $result = null, \StructType\RESERVATIONS $rESERVATIONS = null, $transactionID = null)
    {
        $this
            ->setResult($result)
            ->setRESERVATIONS($rESERVATIONS)
            ->setTransactionID($transactionID);
    }
    /**
     * Get Result value
     * @return \StructType\Result
     */
    public function getResult()
    {
        return $this->Result;
    }
    /**
     * Set Result value
     * @param \StructType\Result $result
     * @return \StructType\S_RESERVATION_SEARCH_V003Response
     */
    public function setResult(\StructType\Result $result = null)
    {
        $this->Result = $result;
        return $this;
    }
    /**
     * Get RESERVATIONS value
     * @return \StructType\RESERVATIONS
     */
    public function getRESERVATIONS()
    {
        return $this->RESERVATIONS;
    }
    /**
     * Set RESERVATIONS value
     * @param \StructType\RESERVATIONS $rESERVATIONS
     * @return \StructType\S_RESERVATION_SEARCH_V003Response
     */
    public function setRESERVATIONS(\StructType\RESERVATIONS $rESERVATIONS = null)
    {
        $this->RESERVATIONS = $rESERVATIONS;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_RESERVATION_SEARCH_V003Response
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
}
