<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_ROOMINGLIST_ROOM_DELETE_V001Request StructType
 * @subpackage Structs
 */
class S_ROOMINGLIST_ROOM_DELETE_V001Request extends AbstractStructBase
{
    /**
     * The Authentication
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Authentication
     */
    public $Authentication;
    /**
     * The RoominglistSearch
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\RoominglistSearch
     */
    public $RoominglistSearch;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * Constructor method for S_ROOMINGLIST_ROOM_DELETE_V001Request
     * @uses S_ROOMINGLIST_ROOM_DELETE_V001Request::setAuthentication()
     * @uses S_ROOMINGLIST_ROOM_DELETE_V001Request::setRoominglistSearch()
     * @uses S_ROOMINGLIST_ROOM_DELETE_V001Request::setTransactionID()
     * @param \StructType\Authentication $authentication
     * @param \StructType\RoominglistSearch $roominglistSearch
     * @param string $transactionID
     */
    public function __construct(\StructType\Authentication $authentication = null, \StructType\RoominglistSearch $roominglistSearch = null, $transactionID = null)
    {
        $this
            ->setAuthentication($authentication)
            ->setRoominglistSearch($roominglistSearch)
            ->setTransactionID($transactionID);
    }
    /**
     * Get Authentication value
     * @return \StructType\Authentication
     */
    public function getAuthentication()
    {
        return $this->Authentication;
    }
    /**
     * Set Authentication value
     * @param \StructType\Authentication $authentication
     * @return \StructType\S_ROOMINGLIST_ROOM_DELETE_V001Request
     */
    public function setAuthentication(\StructType\Authentication $authentication = null)
    {
        $this->Authentication = $authentication;
        return $this;
    }
    /**
     * Get RoominglistSearch value
     * @return \StructType\RoominglistSearch
     */
    public function getRoominglistSearch()
    {
        return $this->RoominglistSearch;
    }
    /**
     * Set RoominglistSearch value
     * @param \StructType\RoominglistSearch $roominglistSearch
     * @return \StructType\S_ROOMINGLIST_ROOM_DELETE_V001Request
     */
    public function setRoominglistSearch(\StructType\RoominglistSearch $roominglistSearch = null)
    {
        $this->RoominglistSearch = $roominglistSearch;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_ROOMINGLIST_ROOM_DELETE_V001Request
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
}
