<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_ROOMINGLIST_ROOM_FORECAST_GET_V001Response StructType
 * @subpackage Structs
 */
class S_ROOMINGLIST_ROOM_FORECAST_GET_V001Response extends AbstractStructBase
{
    /**
     * The Result
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Result
     */
    public $Result;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * The ROOM
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ROOM_2[]
     */
    public $ROOM;
    /**
     * Constructor method for S_ROOMINGLIST_ROOM_FORECAST_GET_V001Response
     * @uses S_ROOMINGLIST_ROOM_FORECAST_GET_V001Response::setResult()
     * @uses S_ROOMINGLIST_ROOM_FORECAST_GET_V001Response::setTransactionID()
     * @uses S_ROOMINGLIST_ROOM_FORECAST_GET_V001Response::setROOM()
     * @param \StructType\Result $result
     * @param string $transactionID
     * @param \StructType\ROOM_2[] $rOOM
     */
    public function __construct(\StructType\Result $result = null, $transactionID = null, array $rOOM = array())
    {
        $this
            ->setResult($result)
            ->setTransactionID($transactionID)
            ->setROOM($rOOM);
    }
    /**
     * Get Result value
     * @return \StructType\Result
     */
    public function getResult()
    {
        return $this->Result;
    }
    /**
     * Set Result value
     * @param \StructType\Result $result
     * @return \StructType\S_ROOMINGLIST_ROOM_FORECAST_GET_V001Response
     */
    public function setResult(\StructType\Result $result = null)
    {
        $this->Result = $result;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_ROOMINGLIST_ROOM_FORECAST_GET_V001Response
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
    /**
     * Get ROOM value
     * @return \StructType\ROOM_2[]|null
     */
    public function getROOM()
    {
        return $this->ROOM;
    }
    /**
     * This method is responsible for validating the values passed to the setROOM method
     * This method is willingly generated in order to preserve the one-line inline validation within the setROOM method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateROOMForArrayConstraintsFromSetROOM(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $s_ROOMINGLIST_ROOM_FORECAST_GET_V001ResponseROOMItem) {
            // validation for constraint: itemType
            if (!$s_ROOMINGLIST_ROOM_FORECAST_GET_V001ResponseROOMItem instanceof \StructType\ROOM_2) {
                $invalidValues[] = is_object($s_ROOMINGLIST_ROOM_FORECAST_GET_V001ResponseROOMItem) ? get_class($s_ROOMINGLIST_ROOM_FORECAST_GET_V001ResponseROOMItem) : sprintf('%s(%s)', gettype($s_ROOMINGLIST_ROOM_FORECAST_GET_V001ResponseROOMItem), var_export($s_ROOMINGLIST_ROOM_FORECAST_GET_V001ResponseROOMItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ROOM property can only contain items of type \StructType\ROOM_2, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ROOM value
     * @throws \InvalidArgumentException
     * @param \StructType\ROOM_2[] $rOOM
     * @return \StructType\S_ROOMINGLIST_ROOM_FORECAST_GET_V001Response
     */
    public function setROOM(array $rOOM = array())
    {
        // validation for constraint: array
        if ('' !== ($rOOMArrayErrorMessage = self::validateROOMForArrayConstraintsFromSetROOM($rOOM))) {
            throw new \InvalidArgumentException($rOOMArrayErrorMessage, __LINE__);
        }
        $this->ROOM = $rOOM;
        return $this;
    }
    /**
     * Add item to ROOM value
     * @throws \InvalidArgumentException
     * @param \StructType\ROOM_2 $item
     * @return \StructType\S_ROOMINGLIST_ROOM_FORECAST_GET_V001Response
     */
    public function addToROOM(\StructType\ROOM_2 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ROOM_2) {
            throw new \InvalidArgumentException(sprintf('The ROOM property can only contain items of type \StructType\ROOM_2, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ROOM[] = $item;
        return $this;
    }
}
