<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_ROOM_BOOKING_OOI_LOCK_V001Request StructType
 * @subpackage Structs
 */
class S_ROOM_BOOKING_OOI_LOCK_V001Request extends AbstractStructBase
{
    /**
     * The Authentication
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Authentication
     */
    public $Authentication;
    /**
     * The RoomSearch
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\RoomSearch
     */
    public $RoomSearch;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * Constructor method for S_ROOM_BOOKING_OOI_LOCK_V001Request
     * @uses S_ROOM_BOOKING_OOI_LOCK_V001Request::setAuthentication()
     * @uses S_ROOM_BOOKING_OOI_LOCK_V001Request::setRoomSearch()
     * @uses S_ROOM_BOOKING_OOI_LOCK_V001Request::setTransactionID()
     * @param \StructType\Authentication $authentication
     * @param \StructType\RoomSearch $roomSearch
     * @param string $transactionID
     */
    public function __construct(\StructType\Authentication $authentication = null, \StructType\RoomSearch $roomSearch = null, $transactionID = null)
    {
        $this
            ->setAuthentication($authentication)
            ->setRoomSearch($roomSearch)
            ->setTransactionID($transactionID);
    }
    /**
     * Get Authentication value
     * @return \StructType\Authentication
     */
    public function getAuthentication()
    {
        return $this->Authentication;
    }
    /**
     * Set Authentication value
     * @param \StructType\Authentication $authentication
     * @return \StructType\S_ROOM_BOOKING_OOI_LOCK_V001Request
     */
    public function setAuthentication(\StructType\Authentication $authentication = null)
    {
        $this->Authentication = $authentication;
        return $this;
    }
    /**
     * Get RoomSearch value
     * @return \StructType\RoomSearch
     */
    public function getRoomSearch()
    {
        return $this->RoomSearch;
    }
    /**
     * Set RoomSearch value
     * @param \StructType\RoomSearch $roomSearch
     * @return \StructType\S_ROOM_BOOKING_OOI_LOCK_V001Request
     */
    public function setRoomSearch(\StructType\RoomSearch $roomSearch = null)
    {
        $this->RoomSearch = $roomSearch;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_ROOM_BOOKING_OOI_LOCK_V001Request
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
}
