<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_ROOM_BOOKING_STATE_V002Response StructType
 * @subpackage Structs
 */
class S_ROOM_BOOKING_STATE_V002Response extends AbstractStructBase
{
    /**
     * The Result
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Result
     */
    public $Result;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * The bookingstate
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Bookingstate[]
     */
    public $bookingstate;
    /**
     * Constructor method for S_ROOM_BOOKING_STATE_V002Response
     * @uses S_ROOM_BOOKING_STATE_V002Response::setResult()
     * @uses S_ROOM_BOOKING_STATE_V002Response::setTransactionID()
     * @uses S_ROOM_BOOKING_STATE_V002Response::setBookingstate()
     * @param \StructType\Result $result
     * @param string $transactionID
     * @param \StructType\Bookingstate[] $bookingstate
     */
    public function __construct(\StructType\Result $result = null, $transactionID = null, array $bookingstate = array())
    {
        $this
            ->setResult($result)
            ->setTransactionID($transactionID)
            ->setBookingstate($bookingstate);
    }
    /**
     * Get Result value
     * @return \StructType\Result
     */
    public function getResult()
    {
        return $this->Result;
    }
    /**
     * Set Result value
     * @param \StructType\Result $result
     * @return \StructType\S_ROOM_BOOKING_STATE_V002Response
     */
    public function setResult(\StructType\Result $result = null)
    {
        $this->Result = $result;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_ROOM_BOOKING_STATE_V002Response
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
    /**
     * Get bookingstate value
     * @return \StructType\Bookingstate[]|null
     */
    public function getBookingstate()
    {
        return $this->bookingstate;
    }
    /**
     * This method is responsible for validating the values passed to the setBookingstate method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBookingstate method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBookingstateForArrayConstraintsFromSetBookingstate(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $s_ROOM_BOOKING_STATE_V002ResponseBookingstateItem) {
            // validation for constraint: itemType
            if (!$s_ROOM_BOOKING_STATE_V002ResponseBookingstateItem instanceof \StructType\Bookingstate) {
                $invalidValues[] = is_object($s_ROOM_BOOKING_STATE_V002ResponseBookingstateItem) ? get_class($s_ROOM_BOOKING_STATE_V002ResponseBookingstateItem) : sprintf('%s(%s)', gettype($s_ROOM_BOOKING_STATE_V002ResponseBookingstateItem), var_export($s_ROOM_BOOKING_STATE_V002ResponseBookingstateItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The bookingstate property can only contain items of type \StructType\Bookingstate, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set bookingstate value
     * @throws \InvalidArgumentException
     * @param \StructType\Bookingstate[] $bookingstate
     * @return \StructType\S_ROOM_BOOKING_STATE_V002Response
     */
    public function setBookingstate(array $bookingstate = array())
    {
        // validation for constraint: array
        if ('' !== ($bookingstateArrayErrorMessage = self::validateBookingstateForArrayConstraintsFromSetBookingstate($bookingstate))) {
            throw new \InvalidArgumentException($bookingstateArrayErrorMessage, __LINE__);
        }
        $this->bookingstate = $bookingstate;
        return $this;
    }
    /**
     * Add item to bookingstate value
     * @throws \InvalidArgumentException
     * @param \StructType\Bookingstate $item
     * @return \StructType\S_ROOM_BOOKING_STATE_V002Response
     */
    public function addToBookingstate(\StructType\Bookingstate $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Bookingstate) {
            throw new \InvalidArgumentException(sprintf('The bookingstate property can only contain items of type \StructType\Bookingstate, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->bookingstate[] = $item;
        return $this;
    }
}
