<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for
 * S_ROOM_GET_MAINTENANCE_STATE_WITHOUT_IMAGE_MOBILE_V002Request StructType
 * @subpackage Structs
 */
class S_ROOM_GET_MAINTENANCE_STATE_WITHOUT_IMAGE_MOBILE_V002Request extends AbstractStructBase
{
    /**
     * The Authentication
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Authentication
     */
    public $Authentication;
    /**
     * The MaintenanceRequestSearch
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\MaintenanceRequestSearch
     */
    public $MaintenanceRequestSearch;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * Constructor method for
     * S_ROOM_GET_MAINTENANCE_STATE_WITHOUT_IMAGE_MOBILE_V002Request
     * @uses S_ROOM_GET_MAINTENANCE_STATE_WITHOUT_IMAGE_MOBILE_V002Request::setAuthentication()
     * @uses S_ROOM_GET_MAINTENANCE_STATE_WITHOUT_IMAGE_MOBILE_V002Request::setMaintenanceRequestSearch()
     * @uses S_ROOM_GET_MAINTENANCE_STATE_WITHOUT_IMAGE_MOBILE_V002Request::setTransactionID()
     * @param \StructType\Authentication $authentication
     * @param \StructType\MaintenanceRequestSearch $maintenanceRequestSearch
     * @param string $transactionID
     */
    public function __construct(\StructType\Authentication $authentication = null, \StructType\MaintenanceRequestSearch $maintenanceRequestSearch = null, $transactionID = null)
    {
        $this
            ->setAuthentication($authentication)
            ->setMaintenanceRequestSearch($maintenanceRequestSearch)
            ->setTransactionID($transactionID);
    }
    /**
     * Get Authentication value
     * @return \StructType\Authentication
     */
    public function getAuthentication()
    {
        return $this->Authentication;
    }
    /**
     * Set Authentication value
     * @param \StructType\Authentication $authentication
     * @return \StructType\S_ROOM_GET_MAINTENANCE_STATE_WITHOUT_IMAGE_MOBILE_V002Request
     */
    public function setAuthentication(\StructType\Authentication $authentication = null)
    {
        $this->Authentication = $authentication;
        return $this;
    }
    /**
     * Get MaintenanceRequestSearch value
     * @return \StructType\MaintenanceRequestSearch
     */
    public function getMaintenanceRequestSearch()
    {
        return $this->MaintenanceRequestSearch;
    }
    /**
     * Set MaintenanceRequestSearch value
     * @param \StructType\MaintenanceRequestSearch $maintenanceRequestSearch
     * @return \StructType\S_ROOM_GET_MAINTENANCE_STATE_WITHOUT_IMAGE_MOBILE_V002Request
     */
    public function setMaintenanceRequestSearch(\StructType\MaintenanceRequestSearch $maintenanceRequestSearch = null)
    {
        $this->MaintenanceRequestSearch = $maintenanceRequestSearch;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_ROOM_GET_MAINTENANCE_STATE_WITHOUT_IMAGE_MOBILE_V002Request
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
}
