<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_ROOM_LOCK_STATE_SEARCH_V001Response StructType
 * @subpackage Structs
 */
class S_ROOM_LOCK_STATE_SEARCH_V001Response extends AbstractStructBase
{
    /**
     * The Result
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Result
     */
    public $Result;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * The RoomFree
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\RoomFree[]
     */
    public $RoomFree;
    /**
     * The RoomOOS
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\RoomOOS[]
     */
    public $RoomOOS;
    /**
     * The RoomOOO
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\RoomOOO[]
     */
    public $RoomOOO;
    /**
     * The RoomOOI
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\RoomOOI[]
     */
    public $RoomOOI;
    /**
     * Constructor method for S_ROOM_LOCK_STATE_SEARCH_V001Response
     * @uses S_ROOM_LOCK_STATE_SEARCH_V001Response::setResult()
     * @uses S_ROOM_LOCK_STATE_SEARCH_V001Response::setTransactionID()
     * @uses S_ROOM_LOCK_STATE_SEARCH_V001Response::setRoomFree()
     * @uses S_ROOM_LOCK_STATE_SEARCH_V001Response::setRoomOOS()
     * @uses S_ROOM_LOCK_STATE_SEARCH_V001Response::setRoomOOO()
     * @uses S_ROOM_LOCK_STATE_SEARCH_V001Response::setRoomOOI()
     * @param \StructType\Result $result
     * @param string $transactionID
     * @param \StructType\RoomFree[] $roomFree
     * @param \StructType\RoomOOS[] $roomOOS
     * @param \StructType\RoomOOO[] $roomOOO
     * @param \StructType\RoomOOI[] $roomOOI
     */
    public function __construct(\StructType\Result $result = null, $transactionID = null, array $roomFree = array(), array $roomOOS = array(), array $roomOOO = array(), array $roomOOI = array())
    {
        $this
            ->setResult($result)
            ->setTransactionID($transactionID)
            ->setRoomFree($roomFree)
            ->setRoomOOS($roomOOS)
            ->setRoomOOO($roomOOO)
            ->setRoomOOI($roomOOI);
    }
    /**
     * Get Result value
     * @return \StructType\Result
     */
    public function getResult()
    {
        return $this->Result;
    }
    /**
     * Set Result value
     * @param \StructType\Result $result
     * @return \StructType\S_ROOM_LOCK_STATE_SEARCH_V001Response
     */
    public function setResult(\StructType\Result $result = null)
    {
        $this->Result = $result;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_ROOM_LOCK_STATE_SEARCH_V001Response
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
    /**
     * Get RoomFree value
     * @return \StructType\RoomFree[]|null
     */
    public function getRoomFree()
    {
        return $this->RoomFree;
    }
    /**
     * This method is responsible for validating the values passed to the setRoomFree method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRoomFree method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRoomFreeForArrayConstraintsFromSetRoomFree(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $s_ROOM_LOCK_STATE_SEARCH_V001ResponseRoomFreeItem) {
            // validation for constraint: itemType
            if (!$s_ROOM_LOCK_STATE_SEARCH_V001ResponseRoomFreeItem instanceof \StructType\RoomFree) {
                $invalidValues[] = is_object($s_ROOM_LOCK_STATE_SEARCH_V001ResponseRoomFreeItem) ? get_class($s_ROOM_LOCK_STATE_SEARCH_V001ResponseRoomFreeItem) : sprintf('%s(%s)', gettype($s_ROOM_LOCK_STATE_SEARCH_V001ResponseRoomFreeItem), var_export($s_ROOM_LOCK_STATE_SEARCH_V001ResponseRoomFreeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RoomFree property can only contain items of type \StructType\RoomFree, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RoomFree value
     * @throws \InvalidArgumentException
     * @param \StructType\RoomFree[] $roomFree
     * @return \StructType\S_ROOM_LOCK_STATE_SEARCH_V001Response
     */
    public function setRoomFree(array $roomFree = array())
    {
        // validation for constraint: array
        if ('' !== ($roomFreeArrayErrorMessage = self::validateRoomFreeForArrayConstraintsFromSetRoomFree($roomFree))) {
            throw new \InvalidArgumentException($roomFreeArrayErrorMessage, __LINE__);
        }
        $this->RoomFree = $roomFree;
        return $this;
    }
    /**
     * Add item to RoomFree value
     * @throws \InvalidArgumentException
     * @param \StructType\RoomFree $item
     * @return \StructType\S_ROOM_LOCK_STATE_SEARCH_V001Response
     */
    public function addToRoomFree(\StructType\RoomFree $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RoomFree) {
            throw new \InvalidArgumentException(sprintf('The RoomFree property can only contain items of type \StructType\RoomFree, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RoomFree[] = $item;
        return $this;
    }
    /**
     * Get RoomOOS value
     * @return \StructType\RoomOOS[]|null
     */
    public function getRoomOOS()
    {
        return $this->RoomOOS;
    }
    /**
     * This method is responsible for validating the values passed to the setRoomOOS method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRoomOOS method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRoomOOSForArrayConstraintsFromSetRoomOOS(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $s_ROOM_LOCK_STATE_SEARCH_V001ResponseRoomOOSItem) {
            // validation for constraint: itemType
            if (!$s_ROOM_LOCK_STATE_SEARCH_V001ResponseRoomOOSItem instanceof \StructType\RoomOOS) {
                $invalidValues[] = is_object($s_ROOM_LOCK_STATE_SEARCH_V001ResponseRoomOOSItem) ? get_class($s_ROOM_LOCK_STATE_SEARCH_V001ResponseRoomOOSItem) : sprintf('%s(%s)', gettype($s_ROOM_LOCK_STATE_SEARCH_V001ResponseRoomOOSItem), var_export($s_ROOM_LOCK_STATE_SEARCH_V001ResponseRoomOOSItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RoomOOS property can only contain items of type \StructType\RoomOOS, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RoomOOS value
     * @throws \InvalidArgumentException
     * @param \StructType\RoomOOS[] $roomOOS
     * @return \StructType\S_ROOM_LOCK_STATE_SEARCH_V001Response
     */
    public function setRoomOOS(array $roomOOS = array())
    {
        // validation for constraint: array
        if ('' !== ($roomOOSArrayErrorMessage = self::validateRoomOOSForArrayConstraintsFromSetRoomOOS($roomOOS))) {
            throw new \InvalidArgumentException($roomOOSArrayErrorMessage, __LINE__);
        }
        $this->RoomOOS = $roomOOS;
        return $this;
    }
    /**
     * Add item to RoomOOS value
     * @throws \InvalidArgumentException
     * @param \StructType\RoomOOS $item
     * @return \StructType\S_ROOM_LOCK_STATE_SEARCH_V001Response
     */
    public function addToRoomOOS(\StructType\RoomOOS $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RoomOOS) {
            throw new \InvalidArgumentException(sprintf('The RoomOOS property can only contain items of type \StructType\RoomOOS, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RoomOOS[] = $item;
        return $this;
    }
    /**
     * Get RoomOOO value
     * @return \StructType\RoomOOO[]|null
     */
    public function getRoomOOO()
    {
        return $this->RoomOOO;
    }
    /**
     * This method is responsible for validating the values passed to the setRoomOOO method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRoomOOO method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRoomOOOForArrayConstraintsFromSetRoomOOO(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $s_ROOM_LOCK_STATE_SEARCH_V001ResponseRoomOOOItem) {
            // validation for constraint: itemType
            if (!$s_ROOM_LOCK_STATE_SEARCH_V001ResponseRoomOOOItem instanceof \StructType\RoomOOO) {
                $invalidValues[] = is_object($s_ROOM_LOCK_STATE_SEARCH_V001ResponseRoomOOOItem) ? get_class($s_ROOM_LOCK_STATE_SEARCH_V001ResponseRoomOOOItem) : sprintf('%s(%s)', gettype($s_ROOM_LOCK_STATE_SEARCH_V001ResponseRoomOOOItem), var_export($s_ROOM_LOCK_STATE_SEARCH_V001ResponseRoomOOOItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RoomOOO property can only contain items of type \StructType\RoomOOO, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RoomOOO value
     * @throws \InvalidArgumentException
     * @param \StructType\RoomOOO[] $roomOOO
     * @return \StructType\S_ROOM_LOCK_STATE_SEARCH_V001Response
     */
    public function setRoomOOO(array $roomOOO = array())
    {
        // validation for constraint: array
        if ('' !== ($roomOOOArrayErrorMessage = self::validateRoomOOOForArrayConstraintsFromSetRoomOOO($roomOOO))) {
            throw new \InvalidArgumentException($roomOOOArrayErrorMessage, __LINE__);
        }
        $this->RoomOOO = $roomOOO;
        return $this;
    }
    /**
     * Add item to RoomOOO value
     * @throws \InvalidArgumentException
     * @param \StructType\RoomOOO $item
     * @return \StructType\S_ROOM_LOCK_STATE_SEARCH_V001Response
     */
    public function addToRoomOOO(\StructType\RoomOOO $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RoomOOO) {
            throw new \InvalidArgumentException(sprintf('The RoomOOO property can only contain items of type \StructType\RoomOOO, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RoomOOO[] = $item;
        return $this;
    }
    /**
     * Get RoomOOI value
     * @return \StructType\RoomOOI[]|null
     */
    public function getRoomOOI()
    {
        return $this->RoomOOI;
    }
    /**
     * This method is responsible for validating the values passed to the setRoomOOI method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRoomOOI method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRoomOOIForArrayConstraintsFromSetRoomOOI(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $s_ROOM_LOCK_STATE_SEARCH_V001ResponseRoomOOIItem) {
            // validation for constraint: itemType
            if (!$s_ROOM_LOCK_STATE_SEARCH_V001ResponseRoomOOIItem instanceof \StructType\RoomOOI) {
                $invalidValues[] = is_object($s_ROOM_LOCK_STATE_SEARCH_V001ResponseRoomOOIItem) ? get_class($s_ROOM_LOCK_STATE_SEARCH_V001ResponseRoomOOIItem) : sprintf('%s(%s)', gettype($s_ROOM_LOCK_STATE_SEARCH_V001ResponseRoomOOIItem), var_export($s_ROOM_LOCK_STATE_SEARCH_V001ResponseRoomOOIItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RoomOOI property can only contain items of type \StructType\RoomOOI, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RoomOOI value
     * @throws \InvalidArgumentException
     * @param \StructType\RoomOOI[] $roomOOI
     * @return \StructType\S_ROOM_LOCK_STATE_SEARCH_V001Response
     */
    public function setRoomOOI(array $roomOOI = array())
    {
        // validation for constraint: array
        if ('' !== ($roomOOIArrayErrorMessage = self::validateRoomOOIForArrayConstraintsFromSetRoomOOI($roomOOI))) {
            throw new \InvalidArgumentException($roomOOIArrayErrorMessage, __LINE__);
        }
        $this->RoomOOI = $roomOOI;
        return $this;
    }
    /**
     * Add item to RoomOOI value
     * @throws \InvalidArgumentException
     * @param \StructType\RoomOOI $item
     * @return \StructType\S_ROOM_LOCK_STATE_SEARCH_V001Response
     */
    public function addToRoomOOI(\StructType\RoomOOI $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RoomOOI) {
            throw new \InvalidArgumentException(sprintf('The RoomOOI property can only contain items of type \StructType\RoomOOI, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RoomOOI[] = $item;
        return $this;
    }
}
