<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_SALESPOTENTIAL_GET_V001Response StructType
 * @subpackage Structs
 */
class S_SALESPOTENTIAL_GET_V001Response extends AbstractStructBase
{
    /**
     * The Result
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Result
     */
    public $Result;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * The SALESPOTENTIAL
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\SALESPOTENTIAL[]
     */
    public $SALESPOTENTIAL;
    /**
     * Constructor method for S_SALESPOTENTIAL_GET_V001Response
     * @uses S_SALESPOTENTIAL_GET_V001Response::setResult()
     * @uses S_SALESPOTENTIAL_GET_V001Response::setTransactionID()
     * @uses S_SALESPOTENTIAL_GET_V001Response::setSALESPOTENTIAL()
     * @param \StructType\Result $result
     * @param string $transactionID
     * @param \StructType\SALESPOTENTIAL[] $sALESPOTENTIAL
     */
    public function __construct(\StructType\Result $result = null, $transactionID = null, array $sALESPOTENTIAL = array())
    {
        $this
            ->setResult($result)
            ->setTransactionID($transactionID)
            ->setSALESPOTENTIAL($sALESPOTENTIAL);
    }
    /**
     * Get Result value
     * @return \StructType\Result
     */
    public function getResult()
    {
        return $this->Result;
    }
    /**
     * Set Result value
     * @param \StructType\Result $result
     * @return \StructType\S_SALESPOTENTIAL_GET_V001Response
     */
    public function setResult(\StructType\Result $result = null)
    {
        $this->Result = $result;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_SALESPOTENTIAL_GET_V001Response
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
    /**
     * Get SALESPOTENTIAL value
     * @return \StructType\SALESPOTENTIAL[]|null
     */
    public function getSALESPOTENTIAL()
    {
        return $this->SALESPOTENTIAL;
    }
    /**
     * This method is responsible for validating the values passed to the setSALESPOTENTIAL method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSALESPOTENTIAL method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSALESPOTENTIALForArrayConstraintsFromSetSALESPOTENTIAL(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $s_SALESPOTENTIAL_GET_V001ResponseSALESPOTENTIALItem) {
            // validation for constraint: itemType
            if (!$s_SALESPOTENTIAL_GET_V001ResponseSALESPOTENTIALItem instanceof \StructType\SALESPOTENTIAL) {
                $invalidValues[] = is_object($s_SALESPOTENTIAL_GET_V001ResponseSALESPOTENTIALItem) ? get_class($s_SALESPOTENTIAL_GET_V001ResponseSALESPOTENTIALItem) : sprintf('%s(%s)', gettype($s_SALESPOTENTIAL_GET_V001ResponseSALESPOTENTIALItem), var_export($s_SALESPOTENTIAL_GET_V001ResponseSALESPOTENTIALItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SALESPOTENTIAL property can only contain items of type \StructType\SALESPOTENTIAL, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SALESPOTENTIAL value
     * @throws \InvalidArgumentException
     * @param \StructType\SALESPOTENTIAL[] $sALESPOTENTIAL
     * @return \StructType\S_SALESPOTENTIAL_GET_V001Response
     */
    public function setSALESPOTENTIAL(array $sALESPOTENTIAL = array())
    {
        // validation for constraint: array
        if ('' !== ($sALESPOTENTIALArrayErrorMessage = self::validateSALESPOTENTIALForArrayConstraintsFromSetSALESPOTENTIAL($sALESPOTENTIAL))) {
            throw new \InvalidArgumentException($sALESPOTENTIALArrayErrorMessage, __LINE__);
        }
        $this->SALESPOTENTIAL = $sALESPOTENTIAL;
        return $this;
    }
    /**
     * Add item to SALESPOTENTIAL value
     * @throws \InvalidArgumentException
     * @param \StructType\SALESPOTENTIAL $item
     * @return \StructType\S_SALESPOTENTIAL_GET_V001Response
     */
    public function addToSALESPOTENTIAL(\StructType\SALESPOTENTIAL $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SALESPOTENTIAL) {
            throw new \InvalidArgumentException(sprintf('The SALESPOTENTIAL property can only contain items of type \StructType\SALESPOTENTIAL, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SALESPOTENTIAL[] = $item;
        return $this;
    }
}
