<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_SALESPOTENTIAL_GUEST_CREATE_V001Request StructType
 * @subpackage Structs
 */
class S_SALESPOTENTIAL_GUEST_CREATE_V001Request extends AbstractStructBase
{
    /**
     * The Authentication
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Authentication
     */
    public $Authentication;
    /**
     * The SALESPOTENTIAL
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\SALESPOTENTIAL
     */
    public $SALESPOTENTIAL;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * Constructor method for S_SALESPOTENTIAL_GUEST_CREATE_V001Request
     * @uses S_SALESPOTENTIAL_GUEST_CREATE_V001Request::setAuthentication()
     * @uses S_SALESPOTENTIAL_GUEST_CREATE_V001Request::setSALESPOTENTIAL()
     * @uses S_SALESPOTENTIAL_GUEST_CREATE_V001Request::setTransactionID()
     * @param \StructType\Authentication $authentication
     * @param \StructType\SALESPOTENTIAL $sALESPOTENTIAL
     * @param string $transactionID
     */
    public function __construct(\StructType\Authentication $authentication = null, \StructType\SALESPOTENTIAL $sALESPOTENTIAL = null, $transactionID = null)
    {
        $this
            ->setAuthentication($authentication)
            ->setSALESPOTENTIAL($sALESPOTENTIAL)
            ->setTransactionID($transactionID);
    }
    /**
     * Get Authentication value
     * @return \StructType\Authentication
     */
    public function getAuthentication()
    {
        return $this->Authentication;
    }
    /**
     * Set Authentication value
     * @param \StructType\Authentication $authentication
     * @return \StructType\S_SALESPOTENTIAL_GUEST_CREATE_V001Request
     */
    public function setAuthentication(\StructType\Authentication $authentication = null)
    {
        $this->Authentication = $authentication;
        return $this;
    }
    /**
     * Get SALESPOTENTIAL value
     * @return \StructType\SALESPOTENTIAL
     */
    public function getSALESPOTENTIAL()
    {
        return $this->SALESPOTENTIAL;
    }
    /**
     * Set SALESPOTENTIAL value
     * @param \StructType\SALESPOTENTIAL $sALESPOTENTIAL
     * @return \StructType\S_SALESPOTENTIAL_GUEST_CREATE_V001Request
     */
    public function setSALESPOTENTIAL(\StructType\SALESPOTENTIAL $sALESPOTENTIAL = null)
    {
        $this->SALESPOTENTIAL = $sALESPOTENTIAL;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_SALESPOTENTIAL_GUEST_CREATE_V001Request
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
}
