<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_SALESPOTENTIAL_SEARCH_V001Request StructType
 * @subpackage Structs
 */
class S_SALESPOTENTIAL_SEARCH_V001Request extends AbstractStructBase
{
    /**
     * The Authentication
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Authentication
     */
    public $Authentication;
    /**
     * The SALESPOTENTIAL_SEARCH
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\SALESPOTENTIAL_SEARCH
     */
    public $SALESPOTENTIAL_SEARCH;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * Constructor method for S_SALESPOTENTIAL_SEARCH_V001Request
     * @uses S_SALESPOTENTIAL_SEARCH_V001Request::setAuthentication()
     * @uses S_SALESPOTENTIAL_SEARCH_V001Request::setSALESPOTENTIAL_SEARCH()
     * @uses S_SALESPOTENTIAL_SEARCH_V001Request::setTransactionID()
     * @param \StructType\Authentication $authentication
     * @param \StructType\SALESPOTENTIAL_SEARCH $sALESPOTENTIAL_SEARCH
     * @param string $transactionID
     */
    public function __construct(\StructType\Authentication $authentication = null, \StructType\SALESPOTENTIAL_SEARCH $sALESPOTENTIAL_SEARCH = null, $transactionID = null)
    {
        $this
            ->setAuthentication($authentication)
            ->setSALESPOTENTIAL_SEARCH($sALESPOTENTIAL_SEARCH)
            ->setTransactionID($transactionID);
    }
    /**
     * Get Authentication value
     * @return \StructType\Authentication
     */
    public function getAuthentication()
    {
        return $this->Authentication;
    }
    /**
     * Set Authentication value
     * @param \StructType\Authentication $authentication
     * @return \StructType\S_SALESPOTENTIAL_SEARCH_V001Request
     */
    public function setAuthentication(\StructType\Authentication $authentication = null)
    {
        $this->Authentication = $authentication;
        return $this;
    }
    /**
     * Get SALESPOTENTIAL_SEARCH value
     * @return \StructType\SALESPOTENTIAL_SEARCH
     */
    public function getSALESPOTENTIAL_SEARCH()
    {
        return $this->{'SALESPOTENTIAL-SEARCH'};
    }
    /**
     * Set SALESPOTENTIAL_SEARCH value
     * @param \StructType\SALESPOTENTIAL_SEARCH $sALESPOTENTIAL_SEARCH
     * @return \StructType\S_SALESPOTENTIAL_SEARCH_V001Request
     */
    public function setSALESPOTENTIAL_SEARCH(\StructType\SALESPOTENTIAL_SEARCH $sALESPOTENTIAL_SEARCH = null)
    {
        $this->SALESPOTENTIAL_SEARCH = $this->{'SALESPOTENTIAL-SEARCH'} = $sALESPOTENTIAL_SEARCH;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_SALESPOTENTIAL_SEARCH_V001Request
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
}
