<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for
 * S_SERVICE_MASTER_FILE_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001Response
 * StructType
 * @subpackage Structs
 */
class S_SERVICE_MASTER_FILE_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001Response extends AbstractStructBase
{
    /**
     * The Result
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Result
     */
    public $Result;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * The ServiceMasterFiles
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ServiceMasterFiles[]
     */
    public $ServiceMasterFiles;
    /**
     * Constructor method for
     * S_SERVICE_MASTER_FILE_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001Response
     * @uses S_SERVICE_MASTER_FILE_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001Response::setResult()
     * @uses S_SERVICE_MASTER_FILE_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001Response::setTransactionID()
     * @uses S_SERVICE_MASTER_FILE_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001Response::setServiceMasterFiles()
     * @param \StructType\Result $result
     * @param string $transactionID
     * @param \StructType\ServiceMasterFiles[] $serviceMasterFiles
     */
    public function __construct(\StructType\Result $result = null, $transactionID = null, array $serviceMasterFiles = array())
    {
        $this
            ->setResult($result)
            ->setTransactionID($transactionID)
            ->setServiceMasterFiles($serviceMasterFiles);
    }
    /**
     * Get Result value
     * @return \StructType\Result
     */
    public function getResult()
    {
        return $this->Result;
    }
    /**
     * Set Result value
     * @param \StructType\Result $result
     * @return \StructType\S_SERVICE_MASTER_FILE_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001Response
     */
    public function setResult(\StructType\Result $result = null)
    {
        $this->Result = $result;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_SERVICE_MASTER_FILE_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001Response
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
    /**
     * Get ServiceMasterFiles value
     * @return \StructType\ServiceMasterFiles[]|null
     */
    public function getServiceMasterFiles()
    {
        return $this->ServiceMasterFiles;
    }
    /**
     * This method is responsible for validating the values passed to the setServiceMasterFiles method
     * This method is willingly generated in order to preserve the one-line inline validation within the setServiceMasterFiles method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateServiceMasterFilesForArrayConstraintsFromSetServiceMasterFiles(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $s_SERVICE_MASTER_FILE_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001ResponseServiceMasterFilesItem) {
            // validation for constraint: itemType
            if (!$s_SERVICE_MASTER_FILE_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001ResponseServiceMasterFilesItem instanceof \StructType\ServiceMasterFiles) {
                $invalidValues[] = is_object($s_SERVICE_MASTER_FILE_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001ResponseServiceMasterFilesItem) ? get_class($s_SERVICE_MASTER_FILE_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001ResponseServiceMasterFilesItem) : sprintf('%s(%s)', gettype($s_SERVICE_MASTER_FILE_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001ResponseServiceMasterFilesItem), var_export($s_SERVICE_MASTER_FILE_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001ResponseServiceMasterFilesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ServiceMasterFiles property can only contain items of type \StructType\ServiceMasterFiles, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ServiceMasterFiles value
     * @throws \InvalidArgumentException
     * @param \StructType\ServiceMasterFiles[] $serviceMasterFiles
     * @return \StructType\S_SERVICE_MASTER_FILE_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001Response
     */
    public function setServiceMasterFiles(array $serviceMasterFiles = array())
    {
        // validation for constraint: array
        if ('' !== ($serviceMasterFilesArrayErrorMessage = self::validateServiceMasterFilesForArrayConstraintsFromSetServiceMasterFiles($serviceMasterFiles))) {
            throw new \InvalidArgumentException($serviceMasterFilesArrayErrorMessage, __LINE__);
        }
        $this->ServiceMasterFiles = $serviceMasterFiles;
        return $this;
    }
    /**
     * Add item to ServiceMasterFiles value
     * @throws \InvalidArgumentException
     * @param \StructType\ServiceMasterFiles $item
     * @return \StructType\S_SERVICE_MASTER_FILE_MULTILANGUAGE_DESCRIPTION_COMMENT_GET_V001Response
     */
    public function addToServiceMasterFiles(\StructType\ServiceMasterFiles $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ServiceMasterFiles) {
            throw new \InvalidArgumentException(sprintf('The ServiceMasterFiles property can only contain items of type \StructType\ServiceMasterFiles, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ServiceMasterFiles[] = $item;
        return $this;
    }
}
