<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_SERVICE_PACKAGE_RESTRICTION_SEARCH_V002Request
 * StructType
 * @subpackage Structs
 */
class S_SERVICE_PACKAGE_RESTRICTION_SEARCH_V002Request extends AbstractStructBase
{
    /**
     * The Authentication
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Authentication
     */
    public $Authentication;
    /**
     * The SERVICERESTRICTION_SEARCH
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\SERVICERESTRICTION_SEARCH
     */
    public $SERVICERESTRICTION_SEARCH;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * Constructor method for S_SERVICE_PACKAGE_RESTRICTION_SEARCH_V002Request
     * @uses S_SERVICE_PACKAGE_RESTRICTION_SEARCH_V002Request::setAuthentication()
     * @uses S_SERVICE_PACKAGE_RESTRICTION_SEARCH_V002Request::setSERVICERESTRICTION_SEARCH()
     * @uses S_SERVICE_PACKAGE_RESTRICTION_SEARCH_V002Request::setTransactionID()
     * @param \StructType\Authentication $authentication
     * @param \StructType\SERVICERESTRICTION_SEARCH $sERVICERESTRICTION_SEARCH
     * @param string $transactionID
     */
    public function __construct(\StructType\Authentication $authentication = null, \StructType\SERVICERESTRICTION_SEARCH $sERVICERESTRICTION_SEARCH = null, $transactionID = null)
    {
        $this
            ->setAuthentication($authentication)
            ->setSERVICERESTRICTION_SEARCH($sERVICERESTRICTION_SEARCH)
            ->setTransactionID($transactionID);
    }
    /**
     * Get Authentication value
     * @return \StructType\Authentication
     */
    public function getAuthentication()
    {
        return $this->Authentication;
    }
    /**
     * Set Authentication value
     * @param \StructType\Authentication $authentication
     * @return \StructType\S_SERVICE_PACKAGE_RESTRICTION_SEARCH_V002Request
     */
    public function setAuthentication(\StructType\Authentication $authentication = null)
    {
        $this->Authentication = $authentication;
        return $this;
    }
    /**
     * Get SERVICERESTRICTION_SEARCH value
     * @return \StructType\SERVICERESTRICTION_SEARCH
     */
    public function getSERVICERESTRICTION_SEARCH()
    {
        return $this->{'SERVICERESTRICTION-SEARCH'};
    }
    /**
     * Set SERVICERESTRICTION_SEARCH value
     * @param \StructType\SERVICERESTRICTION_SEARCH $sERVICERESTRICTION_SEARCH
     * @return \StructType\S_SERVICE_PACKAGE_RESTRICTION_SEARCH_V002Request
     */
    public function setSERVICERESTRICTION_SEARCH(\StructType\SERVICERESTRICTION_SEARCH $sERVICERESTRICTION_SEARCH = null)
    {
        $this->SERVICERESTRICTION_SEARCH = $this->{'SERVICERESTRICTION-SEARCH'} = $sERVICERESTRICTION_SEARCH;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_SERVICE_PACKAGE_RESTRICTION_SEARCH_V002Request
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
}
