<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_SYSMESSAGE_ADD_V002Request StructType
 * @subpackage Structs
 */
class S_SYSMESSAGE_ADD_V002Request extends AbstractStructBase
{
    /**
     * The Authentication
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Authentication
     */
    public $Authentication;
    /**
     * The SysMessage
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\SysMessage
     */
    public $SysMessage;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * Constructor method for S_SYSMESSAGE_ADD_V002Request
     * @uses S_SYSMESSAGE_ADD_V002Request::setAuthentication()
     * @uses S_SYSMESSAGE_ADD_V002Request::setSysMessage()
     * @uses S_SYSMESSAGE_ADD_V002Request::setTransactionID()
     * @param \StructType\Authentication $authentication
     * @param \StructType\SysMessage $sysMessage
     * @param string $transactionID
     */
    public function __construct(\StructType\Authentication $authentication = null, \StructType\SysMessage $sysMessage = null, $transactionID = null)
    {
        $this
            ->setAuthentication($authentication)
            ->setSysMessage($sysMessage)
            ->setTransactionID($transactionID);
    }
    /**
     * Get Authentication value
     * @return \StructType\Authentication
     */
    public function getAuthentication()
    {
        return $this->Authentication;
    }
    /**
     * Set Authentication value
     * @param \StructType\Authentication $authentication
     * @return \StructType\S_SYSMESSAGE_ADD_V002Request
     */
    public function setAuthentication(\StructType\Authentication $authentication = null)
    {
        $this->Authentication = $authentication;
        return $this;
    }
    /**
     * Get SysMessage value
     * @return \StructType\SysMessage
     */
    public function getSysMessage()
    {
        return $this->SysMessage;
    }
    /**
     * Set SysMessage value
     * @param \StructType\SysMessage $sysMessage
     * @return \StructType\S_SYSMESSAGE_ADD_V002Request
     */
    public function setSysMessage(\StructType\SysMessage $sysMessage = null)
    {
        $this->SysMessage = $sysMessage;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_SYSMESSAGE_ADD_V002Request
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
}
