<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for S_YIELD_HURDLE_PRODUCTION_SEARCH_V001Request StructType
 * @subpackage Structs
 */
class S_YIELD_HURDLE_PRODUCTION_SEARCH_V001Request extends AbstractStructBase
{
    /**
     * The Authentication
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Authentication
     */
    public $Authentication;
    /**
     * The YieldHurdleProductionSearch
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\YieldHurdleProductionSearch
     */
    public $YieldHurdleProductionSearch;
    /**
     * The TransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionID;
    /**
     * Constructor method for S_YIELD_HURDLE_PRODUCTION_SEARCH_V001Request
     * @uses S_YIELD_HURDLE_PRODUCTION_SEARCH_V001Request::setAuthentication()
     * @uses S_YIELD_HURDLE_PRODUCTION_SEARCH_V001Request::setYieldHurdleProductionSearch()
     * @uses S_YIELD_HURDLE_PRODUCTION_SEARCH_V001Request::setTransactionID()
     * @param \StructType\Authentication $authentication
     * @param \StructType\YieldHurdleProductionSearch $yieldHurdleProductionSearch
     * @param string $transactionID
     */
    public function __construct(\StructType\Authentication $authentication = null, \StructType\YieldHurdleProductionSearch $yieldHurdleProductionSearch = null, $transactionID = null)
    {
        $this
            ->setAuthentication($authentication)
            ->setYieldHurdleProductionSearch($yieldHurdleProductionSearch)
            ->setTransactionID($transactionID);
    }
    /**
     * Get Authentication value
     * @return \StructType\Authentication
     */
    public function getAuthentication()
    {
        return $this->Authentication;
    }
    /**
     * Set Authentication value
     * @param \StructType\Authentication $authentication
     * @return \StructType\S_YIELD_HURDLE_PRODUCTION_SEARCH_V001Request
     */
    public function setAuthentication(\StructType\Authentication $authentication = null)
    {
        $this->Authentication = $authentication;
        return $this;
    }
    /**
     * Get YieldHurdleProductionSearch value
     * @return \StructType\YieldHurdleProductionSearch
     */
    public function getYieldHurdleProductionSearch()
    {
        return $this->YieldHurdleProductionSearch;
    }
    /**
     * Set YieldHurdleProductionSearch value
     * @param \StructType\YieldHurdleProductionSearch $yieldHurdleProductionSearch
     * @return \StructType\S_YIELD_HURDLE_PRODUCTION_SEARCH_V001Request
     */
    public function setYieldHurdleProductionSearch(\StructType\YieldHurdleProductionSearch $yieldHurdleProductionSearch = null)
    {
        $this->YieldHurdleProductionSearch = $yieldHurdleProductionSearch;
        return $this;
    }
    /**
     * Get TransactionID value
     * @return string|null
     */
    public function getTransactionID()
    {
        return $this->TransactionID;
    }
    /**
     * Set TransactionID value
     * @param string $transactionID
     * @return \StructType\S_YIELD_HURDLE_PRODUCTION_SEARCH_V001Request
     */
    public function setTransactionID($transactionID = null)
    {
        // validation for constraint: string
        if (!is_null($transactionID) && !is_string($transactionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionID, true), gettype($transactionID)), __LINE__);
        }
        $this->TransactionID = $transactionID;
        return $this;
    }
}
