<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ServiceMasterFiles StructType
 * @subpackage Structs
 */
class ServiceMasterFiles extends AbstractStructBase
{
    /**
     * The ServiceMasterFile
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ServiceMasterFile[]
     */
    public $ServiceMasterFile;
    /**
     * Constructor method for ServiceMasterFiles
     * @uses ServiceMasterFiles::setServiceMasterFile()
     * @param \StructType\ServiceMasterFile[] $serviceMasterFile
     */
    public function __construct(array $serviceMasterFile = array())
    {
        $this
            ->setServiceMasterFile($serviceMasterFile);
    }
    /**
     * Get ServiceMasterFile value
     * @return \StructType\ServiceMasterFile[]|null
     */
    public function getServiceMasterFile()
    {
        return $this->ServiceMasterFile;
    }
    /**
     * This method is responsible for validating the values passed to the setServiceMasterFile method
     * This method is willingly generated in order to preserve the one-line inline validation within the setServiceMasterFile method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateServiceMasterFileForArrayConstraintsFromSetServiceMasterFile(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $serviceMasterFilesServiceMasterFileItem) {
            // validation for constraint: itemType
            if (!$serviceMasterFilesServiceMasterFileItem instanceof \StructType\ServiceMasterFile) {
                $invalidValues[] = is_object($serviceMasterFilesServiceMasterFileItem) ? get_class($serviceMasterFilesServiceMasterFileItem) : sprintf('%s(%s)', gettype($serviceMasterFilesServiceMasterFileItem), var_export($serviceMasterFilesServiceMasterFileItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ServiceMasterFile property can only contain items of type \StructType\ServiceMasterFile, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ServiceMasterFile value
     * @throws \InvalidArgumentException
     * @param \StructType\ServiceMasterFile[] $serviceMasterFile
     * @return \StructType\ServiceMasterFiles
     */
    public function setServiceMasterFile(array $serviceMasterFile = array())
    {
        // validation for constraint: array
        if ('' !== ($serviceMasterFileArrayErrorMessage = self::validateServiceMasterFileForArrayConstraintsFromSetServiceMasterFile($serviceMasterFile))) {
            throw new \InvalidArgumentException($serviceMasterFileArrayErrorMessage, __LINE__);
        }
        $this->ServiceMasterFile = $serviceMasterFile;
        return $this;
    }
    /**
     * Add item to ServiceMasterFile value
     * @throws \InvalidArgumentException
     * @param \StructType\ServiceMasterFile $item
     * @return \StructType\ServiceMasterFiles
     */
    public function addToServiceMasterFile(\StructType\ServiceMasterFile $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ServiceMasterFile) {
            throw new \InvalidArgumentException(sprintf('The ServiceMasterFile property can only contain items of type \StructType\ServiceMasterFile, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ServiceMasterFile[] = $item;
        return $this;
    }
}
