<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ServiceReservations StructType
 * @subpackage Structs
 */
class ServiceReservations extends AbstractStructBase
{
    /**
     * The ServiceReservation
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ServiceReservation[]
     */
    public $ServiceReservation;
    /**
     * Constructor method for ServiceReservations
     * @uses ServiceReservations::setServiceReservation()
     * @param \StructType\ServiceReservation[] $serviceReservation
     */
    public function __construct(array $serviceReservation = array())
    {
        $this
            ->setServiceReservation($serviceReservation);
    }
    /**
     * Get ServiceReservation value
     * @return \StructType\ServiceReservation[]|null
     */
    public function getServiceReservation()
    {
        return $this->ServiceReservation;
    }
    /**
     * This method is responsible for validating the values passed to the setServiceReservation method
     * This method is willingly generated in order to preserve the one-line inline validation within the setServiceReservation method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateServiceReservationForArrayConstraintsFromSetServiceReservation(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $serviceReservationsServiceReservationItem) {
            // validation for constraint: itemType
            if (!$serviceReservationsServiceReservationItem instanceof \StructType\ServiceReservation) {
                $invalidValues[] = is_object($serviceReservationsServiceReservationItem) ? get_class($serviceReservationsServiceReservationItem) : sprintf('%s(%s)', gettype($serviceReservationsServiceReservationItem), var_export($serviceReservationsServiceReservationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ServiceReservation property can only contain items of type \StructType\ServiceReservation, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ServiceReservation value
     * @throws \InvalidArgumentException
     * @param \StructType\ServiceReservation[] $serviceReservation
     * @return \StructType\ServiceReservations
     */
    public function setServiceReservation(array $serviceReservation = array())
    {
        // validation for constraint: array
        if ('' !== ($serviceReservationArrayErrorMessage = self::validateServiceReservationForArrayConstraintsFromSetServiceReservation($serviceReservation))) {
            throw new \InvalidArgumentException($serviceReservationArrayErrorMessage, __LINE__);
        }
        $this->ServiceReservation = $serviceReservation;
        return $this;
    }
    /**
     * Add item to ServiceReservation value
     * @throws \InvalidArgumentException
     * @param \StructType\ServiceReservation $item
     * @return \StructType\ServiceReservations
     */
    public function addToServiceReservation(\StructType\ServiceReservation $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ServiceReservation) {
            throw new \InvalidArgumentException(sprintf('The ServiceReservation property can only contain items of type \StructType\ServiceReservation, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ServiceReservation[] = $item;
        return $this;
    }
}
