<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SettlementProfiles StructType
 * @subpackage Structs
 */
class SettlementProfiles extends AbstractStructBase
{
    /**
     * The SettlementProfile
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\SettlementProfile[]
     */
    public $SettlementProfile;
    /**
     * Constructor method for SettlementProfiles
     * @uses SettlementProfiles::setSettlementProfile()
     * @param \StructType\SettlementProfile[] $settlementProfile
     */
    public function __construct(array $settlementProfile = array())
    {
        $this
            ->setSettlementProfile($settlementProfile);
    }
    /**
     * Get SettlementProfile value
     * @return \StructType\SettlementProfile[]|null
     */
    public function getSettlementProfile()
    {
        return $this->SettlementProfile;
    }
    /**
     * This method is responsible for validating the values passed to the setSettlementProfile method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSettlementProfile method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSettlementProfileForArrayConstraintsFromSetSettlementProfile(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $settlementProfilesSettlementProfileItem) {
            // validation for constraint: itemType
            if (!$settlementProfilesSettlementProfileItem instanceof \StructType\SettlementProfile) {
                $invalidValues[] = is_object($settlementProfilesSettlementProfileItem) ? get_class($settlementProfilesSettlementProfileItem) : sprintf('%s(%s)', gettype($settlementProfilesSettlementProfileItem), var_export($settlementProfilesSettlementProfileItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SettlementProfile property can only contain items of type \StructType\SettlementProfile, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SettlementProfile value
     * @throws \InvalidArgumentException
     * @param \StructType\SettlementProfile[] $settlementProfile
     * @return \StructType\SettlementProfiles
     */
    public function setSettlementProfile(array $settlementProfile = array())
    {
        // validation for constraint: array
        if ('' !== ($settlementProfileArrayErrorMessage = self::validateSettlementProfileForArrayConstraintsFromSetSettlementProfile($settlementProfile))) {
            throw new \InvalidArgumentException($settlementProfileArrayErrorMessage, __LINE__);
        }
        $this->SettlementProfile = $settlementProfile;
        return $this;
    }
    /**
     * Add item to SettlementProfile value
     * @throws \InvalidArgumentException
     * @param \StructType\SettlementProfile $item
     * @return \StructType\SettlementProfiles
     */
    public function addToSettlementProfile(\StructType\SettlementProfile $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SettlementProfile) {
            throw new \InvalidArgumentException(sprintf('The SettlementProfile property can only contain items of type \StructType\SettlementProfile, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SettlementProfile[] = $item;
        return $this;
    }
}
