<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TAXS StructType
 * @subpackage Structs
 */
class TAXS extends AbstractStructBase
{
    /**
     * The TAX
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\TAX[]
     */
    public $TAX;
    /**
     * Constructor method for TAXS
     * @uses TAXS::setTAX()
     * @param \StructType\TAX[] $tAX
     */
    public function __construct(array $tAX = array())
    {
        $this
            ->setTAX($tAX);
    }
    /**
     * Get TAX value
     * @return \StructType\TAX[]|null
     */
    public function getTAX()
    {
        return $this->TAX;
    }
    /**
     * This method is responsible for validating the values passed to the setTAX method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTAX method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTAXForArrayConstraintsFromSetTAX(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $tAXSTAXItem) {
            // validation for constraint: itemType
            if (!$tAXSTAXItem instanceof \StructType\TAX) {
                $invalidValues[] = is_object($tAXSTAXItem) ? get_class($tAXSTAXItem) : sprintf('%s(%s)', gettype($tAXSTAXItem), var_export($tAXSTAXItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TAX property can only contain items of type \StructType\TAX, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TAX value
     * @throws \InvalidArgumentException
     * @param \StructType\TAX[] $tAX
     * @return \StructType\TAXS
     */
    public function setTAX(array $tAX = array())
    {
        // validation for constraint: array
        if ('' !== ($tAXArrayErrorMessage = self::validateTAXForArrayConstraintsFromSetTAX($tAX))) {
            throw new \InvalidArgumentException($tAXArrayErrorMessage, __LINE__);
        }
        $this->TAX = $tAX;
        return $this;
    }
    /**
     * Add item to TAX value
     * @throws \InvalidArgumentException
     * @param \StructType\TAX $item
     * @return \StructType\TAXS
     */
    public function addToTAX(\StructType\TAX $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TAX) {
            throw new \InvalidArgumentException(sprintf('The TAX property can only contain items of type \StructType\TAX, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TAX[] = $item;
        return $this;
    }
}
