<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpsellingAddServices StructType
 * @subpackage Structs
 */
class UpsellingAddServices extends AbstractStructBase
{
    /**
     * The UpsellingService
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\UpsellingService[]
     */
    public $UpsellingService;
    /**
     * Constructor method for UpsellingAddServices
     * @uses UpsellingAddServices::setUpsellingService()
     * @param \StructType\UpsellingService[] $upsellingService
     */
    public function __construct(array $upsellingService = array())
    {
        $this
            ->setUpsellingService($upsellingService);
    }
    /**
     * Get UpsellingService value
     * @return \StructType\UpsellingService[]|null
     */
    public function getUpsellingService()
    {
        return $this->UpsellingService;
    }
    /**
     * This method is responsible for validating the values passed to the setUpsellingService method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUpsellingService method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUpsellingServiceForArrayConstraintsFromSetUpsellingService(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $upsellingAddServicesUpsellingServiceItem) {
            // validation for constraint: itemType
            if (!$upsellingAddServicesUpsellingServiceItem instanceof \StructType\UpsellingService) {
                $invalidValues[] = is_object($upsellingAddServicesUpsellingServiceItem) ? get_class($upsellingAddServicesUpsellingServiceItem) : sprintf('%s(%s)', gettype($upsellingAddServicesUpsellingServiceItem), var_export($upsellingAddServicesUpsellingServiceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UpsellingService property can only contain items of type \StructType\UpsellingService, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UpsellingService value
     * @throws \InvalidArgumentException
     * @param \StructType\UpsellingService[] $upsellingService
     * @return \StructType\UpsellingAddServices
     */
    public function setUpsellingService(array $upsellingService = array())
    {
        // validation for constraint: array
        if ('' !== ($upsellingServiceArrayErrorMessage = self::validateUpsellingServiceForArrayConstraintsFromSetUpsellingService($upsellingService))) {
            throw new \InvalidArgumentException($upsellingServiceArrayErrorMessage, __LINE__);
        }
        $this->UpsellingService = $upsellingService;
        return $this;
    }
    /**
     * Add item to UpsellingService value
     * @throws \InvalidArgumentException
     * @param \StructType\UpsellingService $item
     * @return \StructType\UpsellingAddServices
     */
    public function addToUpsellingService(\StructType\UpsellingService $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UpsellingService) {
            throw new \InvalidArgumentException(sprintf('The UpsellingService property can only contain items of type \StructType\UpsellingService, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UpsellingService[] = $item;
        return $this;
    }
}
